Utilisation de Microsoft Query pour extraire des données externes

Cette rubrique fournit des informations sur les sujets suivants :

Qu'est-ce que Microsoft Query ?

Définition de sources de données

Définition de votre requête

Utilisation des données dans Microsoft Excel

Qu'est-ce que Microsoft Query ?

Microsoft Query est un programme qui permet de transférer des données de sources externes vers d'autres programmes Microsoft Office — notamment Microsoft Excel. Si vous utilisez Microsoft Query pour récupérer les données de vos bases de données et fichiers d'entreprise, vous n'avez pas besoin de retaper les données à analyser dans Excel. Vous pouvez également mettre à jour automatiquement vos rapports et synthèses Excel à partir de la base de données sources d'origine lors de la mise à jour de la base de données.

Types de bases de données auxquelles vous pouvez accéder Vous pouvez extraire des données de plusieurs types de bases de données, dont Microsoft Access, Microsoft SQL Server et Microsoft SQL Server OLAP Services. Vous pouvez également extraire des données de listes Excel et de fichiers de texte. Consultez la liste des types de bases de données auxquelles vous pouvez accéder.

Dans Excel, vous pouvez également récupérer des données de pages Web sans utiliser Microsoft Query. Pour plus d'informations sur la récupération de données de pages Web, consultez l'aide de Excel.

Sélection de données à partir d'une base de données Vous pouvez récupérer les données d'une base de données en créant une requête, qui est une question relative aux données stockées dans une base de données externe. Par exemple, si vos données sont stockées dans une base de données Access, vous pouvez souhaiter connaître les chiffres des ventes d'un produit donné par région. Vous pouvez récupérer une partie des données en ne sélectionnant que les données relatives au produit et à la région à analyser et ignorer les données dont vous n'avez pas besoin.

Exemple de sélection de données dans Query

Query vous permet de sélectionner les colonnes de données de votre choix et de n'importer que celles-là.

Mise à jour de la feuille de calcul en une seule opération Lorsqu'un classeur Excel contient des données externes, chaque fois que la base de données change, vous pouvez actualiser les données de façon à mettre à jour l'analyse (sans devoir pour autant recréer vos rapports et graphiques d'analyse). Par exemple, vous pouvez créer une synthèse mensuelle des ventes et l'actualiser chaque mois, à l'aide des nouveaux chiffres.

Utilisation de Query pour extraire des données L'importation de données externes dans Excel à l'aide de Query s'effectue en trois étapes : Vous devez d'abord définir une source de données à laquelle connecter votre base de données, puis utiliser l'Assistant Requête pour sélectionner les données de votre choix, puis enfin renvoyer les données à Excel où il vous est possible de les mettre en forme, de les synthétiser et de générer des rapports.

Retour au début

Définition de sources de données

Qu'est-ce qu'une source de données ? Une source de données est un ensemble d'informations stocké qui permet à Microsoft Excel et Microsoft Query de se connecter à une base de données externe. Lorsque vous utilisez Microsoft Query pour définir une source de données, vous attribuez un nom à cette dernière, puis fournissez le nom et l'emplacement de la base de données ou du serveur, le type de base de données ainsi que des informations sur votre nom d'ouverture de session et votre mot de passe. Ces informations comprennent également le nom d'un pilote ODBC ou d'un pilote de source de données, qui est un programme permettant d'établir des connexions à un type de base de données spécifique. Pour certains types de bases de données externes (cubes OLAP), il vous suffit de définir une source de données pour pouvoir récupérer les données.

Utilisation des sources de données par Microsoft Query Après avoir défini une source de données pour une base de données spécifique, vous pouvez l'utiliser lorsque vous souhaitez créer une requête afin de sélectionner et de récupérer les données de cette base de données — sans avoir à retaper l'ensemble des informations de connexion. Microsoft Query utilise la source de données pour se connecter à la base de données externe et vous indique les données disponibles. Après avoir créé votre requête et renvoyé les données vers Excel, Microsoft Query récupère les données et transfère la requête et les informations de la source de données vers le classeur Excel afin que vous puissiez vous reconnecter à la base de données lorsque vous souhaitez actualiser les données.

Diagramme illustrant la manière dont Query utilise les sources de données

Une source de données est le moyen par lequel Query et Excel se connectent à une base de données spécifique pour extraire des données.

Retour au début

Définition de votre requête

Utilisation de l'Assistant Requête pour la plupart des requêtes L'Assistant Requête, fourni avec Microsoft Query, a été conçu pour les utilisateurs qui apprennent à créer des requêtes. L'Assistant vous guide au cours des étapes de sélection et de regroupement des données de différentes tables et champs dans votre base de données. Après avoir sélectionné les données, vous pouvez également utiliser l'Assistant pour filtrer et trier les résultats de votre requête. Utilisez l'Assistant Requête pour créer une requête complète ou exécuter une requête que vous avez modifiée directement dans Microsoft Query.

Création des autres types de requêtes directement dans Microsoft Query Si vous maîtrisez parfaitement la création des requêtes ou que vous souhaitez créer une requête plus complexe, vous pouvez travailler directement dans Microsoft Query. Microsoft Query vous permet d'afficher et de modifier les requêtes que vous commencez à créer dans l'Assistant Requête ou de créer des requêtes sans l'aide de l'Assistant.

Utilisez directement Query lorsque vous voulez créer des requêtes effectuant les opérations suivantes :

  • Sélection de données spécifiques dans un champ Dans une base de données volumineuse, vous pouvez choisir certaines données d'un champ et en ignorer d'autres. Par exemple, si vous avez besoin de données pour deux des produits d'un champ contenant des informations sur de nombreux produits, vous pouvez utiliser des critères afin de sélectionner des données uniquement pour les deux produits souhaités. Obtenir des informations sur l'utilisation des critères.
  • Récupérer des données en fonction de divers critères chaque fois que vous exécutez la requête Si vous devez créer le même rapport ou la même synthèse Excel pour plusieurs zones des mêmes données externes (par exemple un rapport sur les ventes distinct pour chaque région), vous pouvez créer un type de requête appelé requête paramétrée. Lorsque vous exécutez une requête paramétrée, le système vous invite à préciser quelles données il doit utiliser comme critères pour la sélection des enregistrements. Il se peut, par exemple, qu'une requête paramétrée vous invite à entrer une région spécifique ; vous pouvez réutiliser cette requête pour créer vos différents rapports de ventes par région. Obtenir des informations sur les requêtes paramétrées.
  • Différentes associations de données Vous pouvez utiliser Microsoft Query pour associer ou joindre les données de différentes tables dans votre base de données. Par exemple, si vous disposez d'une table d'informations sur les ventes de produits et d'une table d'informations sur les clients, vous pouvez joindre ces tables pour afficher les clients n'ayant pas effectué d'achats récemment. Obtenir des informations sur l'association de tables.

Création d'un cube OLAP à partir des données d'une requête OLAP (On-Line Analytical Processing) est une méthode d'organisation des données permettant d'effectuer des requêtes et d'établir des rapports au lieu de procéder à des transactions. Dans une base de données OLAP, les données sont organisées de manière hiérarchique et sont stockées dans des cubes et non dans des tables.

Vous pouvez utiliser Microsoft Query pour créer un cube OLAP à partir des données d'une requête afin que la création des rapports Microsoft Excel à partir des données dure moins longtemps et soit moins fastidieuse. Pour créer un cube OLAP, exécutez l'Assistant Cube OLAP à partir de l'Assistant Requête ou directement de Microsoft Query. Vous pouvez renvoyer les données vers Excel sous forme de rapport de tableau croisé dynamique. Obtenir des informations sur la création d'un cube OLAP à partir de données faisant l'objet d'une requête.

Informations complémentaires

Quand utiliser l'Assistant Requête ou Microsoft Query ?

Retour au début

Utilisation des données dans Microsoft Excel

Après avoir créé une requête à l'aide de l'Assistant Requête ou dans Microsoft Query, vous pouvez renvoyer les données vers une feuille de calcul Microsoft Excel. Les données sont transformées en une plage de données externes ou un rapport de tableau croisé dynamique que vous pouvez mettre en forme, analyser et actualiser.

Mise en forme et analyse des données Dans Excel, vous pouvez utiliser des outils qui vous sont familiers, notamment l'Assistant Graphique ou des sous-totaux automatiques afin de présenter et de synthétiser les données. Il vous est possible de mettre en forme les données et votre mise en forme est conservée lors de l'actualisation des données externes à partir de la base de données sources. Si vous ajoutez des colonnes de formules à la plage de données externes, les formules peuvent être copiées automatiquement dans les nouvelles lignes ajoutées à la plage lors de l'actualisation des données. Vous pouvez utiliser vos propres étiquettes de colonne à la place des noms de champ et ajouter automatiquement des numéros de ligne. Pour plus d'informations sur le contrôle de la mise en forme et de la présentation de la plage de données externes, consultez l'aide de Excel.

Réutilisation et partage des requêtes À la fois dans l'Assistant Requête et dans Microsoft Query, il vous est possible d'enregistrer un fichier de requête .dqy que vous pouvez modifier, réutiliser et partager. Excel peut ouvrir directement les fichiers .dqy, ce qui vous permet, ainsi qu'à d'autres utilisateurs, de créer des plages de données externes supplémentaires à partir de la même requête.

Pour partager une synthèse ou un rapport Excel créé à partir de données externes, vous pouvez fournir à d'autres utilisateurs un classeur qui contient une plage de données externes ou créer un modèle de rapport. Ce dernier vous permet d'enregistrer la synthèse ou le rapport sans enregistrer les données externes afin de réduire la taille du fichier. Les données externes sont récupérées lorsqu'un utilisateur ouvre le modèle de rapport. Pour plus d'informations sur la création des modèles de rapport, consultez l'aide de Excel.

Actualisation des données externes Lorsque vous actualisez les données externes, vous exécutez la requête afin de récupérer les données nouvelles ou modifiées correspondant à vos spécifications. Vous pouvez actualiser une requête à la fois dans Microsoft Query et dans Microsoft Excel. Excel propose différentes options permettant d'actualiser les requêtes, notamment l'actualisation des données à l'ouverture du classeur et l'actualisation automatique à intervalles réguliers. Vous pouvez continuer à travailler dans Excel lors de l'actualisation des données et également vérifier l'état des données après son exécution. Pour plus d'informations sur l'actualisation des données externes dans Excel, consultez l'aide de Excel.

Retour au début


Obtention d'informations relatives à Microsoft Query

  • Dans le menu Aide (Aide) de Microsoft Query, cliquez sur À propos de Microsoft Query.

    Des informations relatives au programme, notamment le numéro de la version, s'affichent dans la boîte de dialogue À propos de Microsoft Query.


Utiliser les touches de raccourci dans Microsoft Query

Que voulez-vous faire ?

Naviguer dans les volets Microsoft Query à l'aide des touches de raccourci

Sélectionner des données et des critères à l'aide des touches de raccourci

Modifier des données et des critères à l'aide des touches de raccourci

Utiliser les touches de fonction dans Microsoft Query

Utiliser les touches de raccourci dans l'Assistant Cube OLAP


Naviguer dans les volets Microsoft Query à l'aide des touches de raccourci

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Déplacement dans le volet des tables

Appuyez sur | Pour
TABULATION | Vous déplacer d'une table à une autre
HAUT ou BAS | Vous déplacer d'un nom de champ à un autre dans une table et sélectionner des noms de champs
MAJ+HAUT ou MAJ+BAS | Sélectionner des champs contigus dans une table ou annuler la sélection

Déplacement d'une colonne ou d'une ligne à l'autre sur le volet des données ou le volet des critères

Appuyez sur | Pour
F5, tapez le numéro de l'enregistrement dans la zone Enreg, puis appuyez sur ENTRÉE | Vous déplacer sur un enregistrement (ligne) donné sur le volet des données
TABULATION, ENTRÉE ou DROITE (à partir de la cellule sélectionnée) | Passer dans la colonne suivante sur le volet des données
MAJ+TABULATION, MAJ+ENTRÉE ou GAUCHE (à partir de la cellule sélectionnée) | Passer dans la colonne précédente de la ligne en cours ou dans le dernier champ de l'enregistrement précédent
FIN | Passer dans la dernière colonne de la ligne en cours
CTRL+FIN | Passer dans la dernière colonne de la dernière ligne
DÉBUT | Passer dans la première colonne de la ligne en cours
CTRL+DÉBUT | Passer dans la première colonne de la première ligne
BAS | Passer à la ligne suivante de la colonne en cours
CTRL+BAS | Passer à la dernière ligne de la colonne en cours
HAUT | Passer à la ligne précédente de la colonne en cours
CTRL+HAUT | Passer à la première ligne de la colonne en cours

Déplacement du point d'insertion à l'intérieur d'une valeur dans une cellule du volet des données ou du volet des critères

Appuyez sur | Pour
F2 | Annuler la sélection et afficher le point d'insertion dans la cellule sélectionnée
DROITE | Vous déplacer d'un caractère vers la droite
CTRL+DROITE | Vous déplacer d'un mot vers la droite
GAUCHE | Vous déplacer d'un caractère vers la gauche
CTRL+GAUCHE | Vous déplacer d'un mot vers la gauche
FIN | Vous déplacer à la fin de la ligne en cours dans des valeurs sur une ou plusieurs lignes
CTRL+FIN | Vous déplacer à la fin de la valeur dans des valeurs sur plusieurs lignes
DÉBUT | Vous déplacer au début de la ligne en cours dans des valeurs sur une ou plusieurs lignes
CTRL+DÉBUT | Vous déplacer au début de la valeur dans des valeurs sur plusieurs lignes

Déplacement d'un écran à l'autre dans le volet des données ou dans le volet des critères

Appuyez sur | Pour
PG.SUIV | Vous déplacer d'un écran vers le bas dans un volet
PG.PRÉC | Vous déplacer d'un écran vers le haut dans un volet
CTRL+PG.SUIV | Vous déplacer d'un écran sur la droite dans un volet
CTRL+PG.PRÉC | Vous déplacer d'un écran vers la gauche dans un volet


Sélectionner des données et des critères à l'aide des touches de raccourci

Sélection de valeurs dans une colonne

Appuyez sur | Pour
F2 | Sélectionner la valeur en cours, ou annuler la sélection et afficher le point d'insertion
TABULATION, ENTRÉE ou DROITE (à partir de la cellule sélectionnée) | Sélectionner la valeur de la colonne suivante
MAJ+DÉBUT | Effectuer une sélection dans une valeur, du point d'insertion au début de la ligne
MAJ+FIN | Effectuer une sélection dans une valeur, du point d'insertion à la fin de la ligne
MAJ+DROITE | Étendre ou annuler la sélection d'un caractère vers la droite
CTRL+MAJ+DROITE | Étendre ou annuler la sélection d'un mot vers la droite
MAJ+GAUCHE | Étendre ou annuler la sélection d'un caractère vers la gauche
CTRL+MAJ+GAUCHE | Étendre ou annuler la sélection d'un mot vers la gauche

Sélection d'une ligne

Appuyez sur | Pour
MAJ+ESPACE | Sélectionner la ligne en cours
BAS | Sélectionner la ligne suivante, si la ligne en cours est sélectionnée
HAUT | Sélectionner la ligne précédente, si la ligne en cours est sélectionnée
MAJ+BAS | Étendre ou annuler la sélection d'une ligne vers le bas
MAJ+HAUT | Étendre ou annuler la sélection d'une ligne vers le haut
MAJ+PG.SUIV | Étendre la sélection d'un écran vers le bas
MAJ+PG.PRÉC | Étendre la sélection d'un écran vers le haut
CTRL+MAJ+ESPACE | Sélectionner tout le jeu de résultats

Sélection d'une colonne

Appuyez sur | Pour
CTRL+ESPACE | Sélectionner la colonne en cours
DROITE | Sélectionner la colonne de droite, si la colonne en cours est sélectionnée
GAUCHE | Sélectionner la colonne de gauche, si la colonne en cours est sélectionnée
MAJ+GAUCHE | Étendre ou annuler la sélection d'une colonne vers la gauche
MAJ+DROITE | Étendre ou annuler la sélection d'une colonne vers la droite
CTRL+MAJ+BAS | Étendre la sélection d'un écran vers la droite
CTRL+MAJ+HAUT | Étendre la sélection d'un écran vers la gauche


Modifier des données et des critères à l'aide des touches de raccourci

Copier, couper, coller ou supprimer

Appuyez sur | Pour
CTRL+C | Copier la sélection en cours dans le Presse-papiers
CTRL+V | Coller le contenu du Presse-papiers à l'emplacement du point d'insertion
CTRL+X | Couper la sélection en course et la coller dans le Presse-papiers
RET.ARR | Supprimer la sélection en cours ou le caractère situé à gauche du point d'insertion
SUPPR | Supprimer la sélection en cours ou le caractère situé à droite du point d'insertion

Zoom avant pour effectuer une modification sur le volet des données

Appuyez sur | Pour
MAJ+F2 | Ouvrir la boîte de dialogue Zoom sur un champ afin de faciliter la saisie des valeurs dans les petites zones de saisie du volet des données


Touches de fonction dans Microsoft Query

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Appuyez sur | Pour
F1 | Basculer vers l'aide
MAJ+F1 | Obtenir l'aide contextuelle relative à l'élément actuellement sélectionné
F2 | Sélectionner ou annuler la sélection de la valeur en cours
ALT+MAJ+F2 ou MAJ+F12 | Enregistrer une requête à l'aide de la commande Enregistrer
ALT+F2 ou F12 | Enregistrer une requête à l'aide de la commande Enregistrer sous
MAJ+F2 | Ouvrir la boîte de dialogue Zoom sur un champ afin de faciliter la saisie des valeurs dans les petites zones de saisie du volet des données
CTRL+F4 | Fermer la requête active
ALT+F4 | Quitter Microsoft Query
F5, tapez le numéro de l'enregistrement dans la zone Enreg, puis appuyez sur ENTRÉE | Atteindre un enregistrement donné (ligne) du volet des données
F6 | Vous déplacer au volet suivant de la fenêtre Query
MAJ+F6 | Vous déplacer au volet précédent de la fenêtre Query
CTRL+F6 | Basculer vers la fenêtre Query ouverte suivante
CTRL+MAJ+F6 | Basculer vers la fenêtre Query ouverte précédente
F9 | Exécuter la requête actuellement ouverte


Utiliser les touches de raccourci dans l'Assistant Cube OLAP

Utilisez les touches suivantes pour exécuter l'étape 2 de l'Assistant Cube OLAP.

Pour déplacer un champ de la liste Champs source vers la zone Dimensions

  1. Appuyez sur la touche TABULATION pour sélectionner la liste Champs source.
  2. Appuyez sur la touche HAUT ou BAS pour sélectionner le champ que vous voulez déplacer.
  3. Appuyez sur la touche TABULATION pour sélectionner le bouton >, puis appuyez sur ENTRÉE.
  4. Recommencez les étapes 1 à 3 pour déplacer d'autres champs.

Pour déplacer un champ vers un niveau inférieur ou supérieur d'une dimension de la zone Dimensions

  1. Appuyez sur la touche TABULATION pour sélectionner la zone Dimensions.
  2. Appuyez sur la touche HAUT ou BAS pour sélectionner le champ que vous voulez déplacer.
  3. Appuyez sur CTRL+X.
  4. Appuyez sur la touche HAUT ou BAS pour sélectionner l'emplacement où vous voulez déplacer le champ.
  5. Appuyez sur CTRL+V.


Installer un pilote ODBC pour accéder à une source de données externes

Les pilotes ODBC fournis par Microsoft avec Microsoft Query sont tous installés lors de l'installation de Query. Consultez la liste des pilotes ODBC installés avec Query.

Si la base de données externes à laquelle vous voulez accéder n'est pas prise en charge par ces pilotes ODBC, procurez-vous un pilote compatible ODBC Microsoft Office auprès d'un vendeur tiers tel que le fabricant de la base de données, puis installez-le. Contactez le vendeur de la base de données pour obtenir des instructions installation.

Remarque Les bases de données OLAP ne nécessitent pas de pilote ODBC. Lorsque vous installez Query, les pilotes et prises en charge permettant d'accéder aux bases de données créées à l'aide des Services Microsoft SQL Server OLAP sont installés automatiquement. Pour vous connecter à d'autres bases de données OLAP, vous devez installer un pilote de source de données et un logiciel client. Obtenir des informations sur les fournisseurs OLAP tiers.


Installer des fournisseurs OLAP

Pour vous connecter à des produits fournis par d'autres fabricants et offrant des données et des services OLAP, vous devez installer un logiciel de fournisseur OLAP. Ce logiciel contient des pilotes de source de données complémentaires et un logiciel client pour vous permettre de vous connecter à une base de données OLAP fournie par d'autres fabricants sur un serveur.

Pour utiliser les fonctionnalités Microsoft Office permettant de travailler avec des données OLAP, le fournisseur OLAP tiers doit être compatible avec Office. Le fournisseur peut prendre ou ne pas prendre en charge la création et l'utilisation de fichiers de cube hors connexion. Pour vérifier l'existence de cette prise en charge, vous pouvez créer un rapport de tableau croisé dynamique Microsoft Excel à partir d'une source de données fournie par la base de données OLAP d'un autre fabricant. Dans le rapport de tableau croisé dynamique, la commande Paramètres client serveur du menu Tableau croisé dynamique (barre d'outils Tableau croisé dynamique) n'est pas disponible si le fournisseur ne prend pas en charge les fichiers de cube hors connexion.

Pour plus d'informations sur l'installation et l'utilisation d'un fournisseur OLAP tiers, consultez votre administrateur système ou le vendeur de votre produit OLAP. Après avoir installé le fournisseur, vous pouvez définir des sources de données dans Microsoft Query pour accéder aux bases de données du fournisseur.


Bases de données auxquelles vous avez accès

Microsoft Office fournit des pilotes que vous pouvez utiliser pour extraire des données des sources de données suivantes :

  • Microsoft SQL Server OLAP Services (fournisseur OLAP ) version 7.0 et ultérieure
  • Microsoft Access 2000 et versions ultérieures
  • dBASE
  • Microsoft FoxPro
  • Microsoft Excel
  • Oracle
  • Paradox
  • SQL Server
  • Bases de données de fichier texte

Remarque Vous pouvez utiliser des pilotes ODBC ou des pilotes de source de données d'autres fabricants afin d'obtenir des informations sur d'autres types de bases de données non répertoriées ici, notamment d'autres types de bases de données OLAP. Pour plus d'informations sur l'installation d'un pilote ODBC ou d'un pilote de source de données non répertorié ici , consultez la documentation de la base de données ou contactez le revendeur de cette dernière.


Indiquer la source d'extraction des données

  1. Si la boîte de dialogue Choisir une source de données n'est pas affichée, cliquez sur le bouton Nouvelle requête Image du bouton.
  2. Effectuez l'une des actions suivantes :

    Pour spécifier une source de données pour une base de données relationnelle, une base de données de fichiers texte ou une liste Microsoft Excel, cliquez sur l'onglet Bases de données.

    Pour spécifier la source de données d'un cube OLAP, cliquez sur l'onglet Cubes OLAP. Ce dernier n'est disponible que si vous avez exécuté Microsoft Query à partir de Microsoft Excel.

  3. Double-cliquez sur Nouvelle source de données.
  4. À l'étape 1, tapez un nom pour identifier la source de données.
  5. À l'étape 2, cliquez sur un pilote pour le type de base de données que vous utilisez en tant que source de données.

    Si la base de données souhaitée ne s'affiche pas, il est peut-être nécessaire d'installer le pilote ODBC ou le pilote de source de données pour votre source de données.

    Procédure

  6. Cliquez sur Ouverture de session, puis fournissez les informations nécessaires pour vous connecter à votre banque de données.

    Pour les bases de données relationnelles, les bases de données de fichiers texte et les listes Excel, les informations que vous fournissez dépendent du type de base de données sélectionnée. Vous pouvez être invité à fournir un nom d'ouverture de session, un mot de passe, la version de la base de données que vous utilisez, l'emplacement de la base de données ou d'autres informations spécifiques au type de base de données.

    Pour les sources de données Microsoft SQL Server OLAP Services, suivez les étapes de l'Assistant Connexion multidimensionnelle.

  7. Après avoir entré les informations requises, cliquez sur OK ou sur Terminer pour revenir à la boîte de dialogue Créer une nouvelle source de données.
  8. Si la base de données contient des tableaux et que vous vouliez que l'un deux s'affiche automatiquement dans l'Assistant Requête, cliquez sur la case de l'étape 4, puis sur le tableau de votre choix.
  9. Si vous ne souhaitez pas taper de nom de connexion et de mot de passe lorsque vous utilisez la source de données, activez la case à cocher Enregistrer l'identité et le mot de passe de l'utilisateur. Si la case à cocher n'est pas disponible, consultez l'administrateur de la base de données pour savoir si cette option a été désactivée.

    Une fois ces étapes accomplies, le nom de la source de données s'inscrit dans la boîte de dialogue Choisir une source de données.


Installer une source de données utilisant le pilote Microsoft Access

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Bases de données, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez Pilote Microsoft Access à l'étape 2.
  2. À l'étape 3, cliquez sur Ouverture de session.
  3. Sous Base de données, cliquez sur Sélectionner, puis utilisez la boîte de dialogue Sélectionner la base de données pour localiser votre fichier de base de données.

    Si vous souhaitez que Microsoft Query ouvre la base de données en lecture seule, activez la case à cocher Lecture seule.

    Si vous souhaitez que Microsoft Query soit l'unique utilisateur de la base de données lorsque vous utilisez cette source de données, activez la case à cocher Exclusif.

  4. Cliquez sur OK.

    Si votre base de données requiert la définition de paramètres de connexion supplémentaires, cliquez sur Extension. Pour plus d'informations sur la nécessité, ou non, de modifier ces paramètres, contactez l'administrateur de votre base de données. Pour plus d'informations sur les paramètres avancés, cliquez sur Annuler, puis sur ? dans la boîte de dialogue ODBC Microsoft Access Setup.

  5. Si vous souhaitez que Microsoft Query ait accès à la base de données système, cliquez sous Base de données système sur Base de données, puis sur Base de données système. Dans la boîte de dialogue Sélectionner la base de données système, localisez le fichier de votre base de données système, puis cliquez sur OK.
  6. Cliquez sur OK, puis tapez votre nom d'ouverture de session et votre mot de passe sous Autorisation par défaut. Si vous n'utilisez pas de nom d'ouverture de session ni de mot de passe pour accéder à la base de données, laissez vides les zones situées sous Autorisation par défaut.

Remarque Vous pouvez utiliser la boîte de dialogue ODBC Microsoft Access Setup pour créer, réparer et compacter des bases de données Microsoft Access. Si ces opérations ne vous sont pas familières, vous devez les effectuer uniquement à partir de Microsoft Access. Pour plus d'informations, consultez l'aide de Microsoft Access.


Installer une source de données utilisant le pilote Microsoft dBASE ou FoxPro

Avant d'exécuter les étapes suivantes, il est conseillé de regrouper dans le même dossier tous les fichiers de base de données que vous voulez utiliser, afin que Microsoft Query puisse trouver tous vos fichiers et que vous n'ayez pas à taper le chemin d'accès complet chaque fois que vous voulez ajouter une table à une requête. Si vous le souhaitez, vous pouvez placer les fichiers de base de données dans un dossier et les fichiers d'index dans un autre dossier.

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Bases de données, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez Pilote Microsoft dBase ou Pilote Microsoft Visual FoxPro à l'étape 2.
  2. À l'étape 3, cliquez sur Ouverture de session.
  3. Effectuez l'une des actions suivantes :

    Pour le Pilote Microsoft dBase, cliquez sur la version de dBASE ou FoxPro utilisée pour créer vos fichiers de base de données dans la liste Version. Si les fichiers de base de données ne se situent pas dans le dossier en cours, désactivez la case à cocher Utilisation du répertoire en cours, puis cliquez sur Sélectionner un répertoire pour localiser le dossier. Si les fichiers d'index de la base de données se trouvent également dans un dossier différent, cliquez sur Sélectionner les index pour localiser le dossier.

    Pour le Pilote Microsoft Visual FoxPro, cliquez sur l'option correspondant à votre base de données FoxPro sous Type de la base de données, puis entrez le chemin d'accès de la base de données dans la zone Chemin.


Installer une source de données utilisant le pilote Microsoft Excel

Le pilote ODBC Microsoft Excel ne vous permet d'accéder qu'à des données contenues dans des classeurs situés dans le même dossier. Avant d'effectuer les étapes suivantes, copiez dans un même dossier tous les classeurs contenant les données auxquelles vous voulez accéder simultanément et nommez chaque plage de feuilles de calcul qui doit être reconnue comme une table par Microsoft Query.

Vous devez créer une source de données distincte pour chaque dossier contenant des données auxquelles vous voulez accéder.

Avant d'installer une source de données ou d'exécuter une requête pour accéder aux données dans un classeur Excel, fermez le classeur dans Excel.

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Bases de données, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez Pilote Microsoft Excel à l'étape 2.
  2. À l'étape 3, cliquez sur Ouverture de session.
  3. Dans la zone Version, cliquez sur la version de Excel utilisée pour créer le classeur. Si votre classeur a été créé avec Excel 97, Excel 2000 ou une version ultérieure de Excel, cliquez sur Excel 97-2000. S'il a été créé avec Excel 95 (Excel version 7.0), cliquez sur Excel 5.0/7.0.
  4. Cliquez sur Classeur Sélectionner, puis localisez le fichier de classeur.


Installer une source de données utilisant le pilote Microsoft ODBC pour Oracle

En utilisant le pilote Microsoft ODBC pour Oracle, vous pouvez vous connecter à des bases de données Oracle prenant en charge SQL*Net version 2.3 ou ultérieure. Pour plus d'informations sur ce support, consultez votre documentation Oracle.

Avant de pouvoir définir des sources de données utilisant ce pilote, vous devez installer les composants Oracle client et réseau, version 7.3 ou ultérieure. Ces composants sont disponibles auprès d'Oracle ou de votre revendeur Oracle.

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Bases de données, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez Pilote Microsoft ODBC pour Oracle à l'étape 2.
  2. À l'étape 3, cliquez sur Ouverture de session.
  3. Sous Base de données, cliquez sur Sélectionner.
  4. Dans la zone Nom d'utilisateur, entrez le nom d'ouverture de session de votre base de données.
  5. Tapez le nom du serveur Oracle et toute information supplémentaire nécessaire pour vous connecter au serveur. Consultez votre administrateur de base de données Oracle à ce sujet. Pour plus d'informations sur les options de configuration, cliquez sur ? dans la boîte de dialogue de configuration.
  6. Entrez votre nom d'ouverture de session et votre mot de passe, puis cliquez deux fois sur OK.


Installer une source de données utilisant le pilote Microsoft Paradox

Avant d'exécuter les étapes suivantes, il est conseillé de regrouper dans le même dossier tous les fichiers de base de données que vous voulez utiliser, afin que Microsoft Query puisse trouver tous vos fichiers et que vous n'ayez pas à taper le chemin d'accès complet chaque fois que vous voulez ajouter une table à une requête.

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Bases de données, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez Pilote Microsoft Paradox à l'étape 2.
  2. À l'étape 3, cliquez sur Ouverture de session.
  3. Dans la zone Version, sélectionnez la version de Paradox utilisée qui a été utilisée pour créer les fichiers de base de données.
  4. Si les fichiers de base de données ne se trouvent pas dans le dossier en cours, désactivez la case à cocher Utiliser du répertoire en cours, puis cliquez sur Sélectionner le répertoire pour localiser les fichiers.
  5. Si votre base de données requiert la définition d'options avancées, cliquez sur Options. Pour plus d'informations sur la nécessité, ou non, de modifier l'un de ces paramètres, consultez l'administrateur de votre base de données. Pour plus d'informations sur les paramètres d'options, cliquez dans la boîte de dialogue Installation ODBC pour Paradox sur ?.


Installer une source de données utilisant le Pilote Microsoft SQL Server

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Bases de données, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez SQL Server à l'étape 2.
  2. À l'étape 3, cliquez sur Ouverture de session.
  3. Dans la zone Serveur, tapez le nom du serveur SQL de votre réseau. Pour obtenir des informations sur les choix possibles dans la zone Serveur, cliquez sur ?.
  4. Cliquez sur Options, puis définissez toutes les autres options nécessaires pour votre base de données. Pour plus d'informations sur la nécessité, ou non, de modifier ces paramètres, contactez l'administrateur de votre base de données. Pour plus d'informations sur les paramètres d'options, cliquez sur ?.
  5. Entrez votre nom d'ouverture de session et votre mot de passe, puis cliquez deux fois sur OK.


Installer une source de données utilisant le pilote OLAP Services Microsoft SQL Server

Vous pouvez utiliser ce pilote afin de définir des sources de données pour les bases de données du serveur et les fichiers de cube hors connexion (*.cub) créées à partir des bases de données Microsoft SQL Server OLAP Services à l'aide de l'Assistant Cube hors connexion de Microsoft Excel ou à partir des enregistrements des bases de données relationnelles à l'aide de l'Assistant Cube OLAP de Microsoft Query. Obtenir des informations sur les sources de données OLAP.

Remarque Cette rubrique explique comment définir des sources de données qui utilisent le fournisseur OLAP pour la première version de Microsoft SQL Server OLAP Services (version 7.0 du fichier MSMDCUBE.DLL). Si vous souhaitez définir des sources de données pour des versions ultérieures de ce fournisseur, vous pouvez utiliser l'Assistant Connexion aux données au lieu de Query. Pour plus d'informations sur ces sources de données, consultez l'aide de votre version de Microsoft SQL Server OLAP Services.

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Cubes OLAP, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez Microsoft OLE DB Provider for OLAP Services à l'étape 2.

    L'onglet Cubes OLAP n'est disponible que si vous exécutez Microsoft Query à partir de Excel.

  2. À l'étape 3 de la boîte de dialogue Créer une nouvelle source de données, cliquez sur Ouverture de session.
  3. À l'étape 1 de la boîte de dialogue Connexion multidimensionnelle, exécutez l'une des actions suivantes :

    Pour vous connecter à une base de données de serveur, cliquez sur Serveur Analyse, puis introduisez le nom du serveur, votre ID, puis un mot de passe. Pour plus d'informations sur ces paramètres, et d'autres, pour votre base de données, consultez l'administrateur du serveur.

    Pour vous connecter à un fichier de cube hors connexion, cliquez sur Fichier Cube, puis entrez le chemin d'accès du fichier .cub dans le champ Fichier.

  4. Effectuez l'une des actions suivantes :

    Si vous vous connectez à un fichier de cube hors connexion, cliquez sur Terminer.

    Si vous vous connectez à une base de données de serveur, cliquez sur Suivant, sélectionnez la base de données du serveur, puis cliquez sur Terminer. À l'étape 4 de la boîte de dialogue Créer une nouvelle source de données, sélectionnez le nom de cube de la base de données dont vous voulez extraire des données.


Installer une source de données utilisant le pilote de texte Microsoft

Vous devez créer une source de données distincte pour chaque dossier contenant des fichiers texte de données auxquelles vous voulez accéder. Si vous voulez utiliser la source de données pour accéder simultanément à des données stockées dans plusieurs fichiers texte, copiez tous les fichiers texte dans le même dossier avant d'exécuter les étapes suivantes.

  1. Si la boîte de dialogue Créer une nouvelle source de données ne s'affiche pas, cliquez dans le menu Fichier sur Nouveau, cliquez sur l'onglet Bases de données, puis double-cliquez sur Nouvelle source de données. Tapez un nom pour la source de données à l'étape 1, puis sélectionnez Pilote Microsoft Text à l'étape 2.
  2. À l'étape 3, cliquez sur Ouverture de session.
  3. Si les fichiers texte ne se trouvent pas dans le répertoire en cours, désactivez la case à cocher Utiliser du répertoire en cours, puis cliquez sur Sélectionner le répertoire pour localiser le dossier.

Remarque Vous pouvez accéder aux données contenues dans des fichiers texte sous différents formats, y compris des colonnes séparées par des espaces, des virgules ou des tabulations. Pour plus d'informations sur les formats de fichiers texte que vous pouvez utiliser, cliquez dans la boîte de dialogue Installation ODBC pour des fichiers Texte sur ?.


Création d'une requête

Une requête est un moyen de trouver les enregistrements qui répondent à une question donnée que vous avez posée sur les données stockées dans une base de données. Lorsque vous créez une requête, vous pouvez utiliser l'Assistant Requête ou bien le faire directement dans Microsoft Query. Le mode de création de votre requête doit être choisi en fonction des fonctionnalités dont vous avez besoin pour sélectionner les données souhaitées.

Cas d'utilisation de l'Assistant Requête Utilisez l'Assistant Requête lorsque vous souhaitez créer une requête simple. Il permet de sélectionner les tables et les champs que vous souhaitez inclure. Une jointure interne est automatiquement créée lorsque l'Assistant reconnaît un champ de clé primaire dans une table ou un champ ayant le même nom dans une autre table.

Vous pouvez également utiliser l'Assistant pour trier le jeu de résultats et effectuer des filtrages simples. À la fin de la procédure de l'Assistant Requête, vous pouvez renvoyer les données dans Microsoft Excel, affiner la requête dans Query ou créer un cube OLAP à partir des données. Après avoir créé la requête, vous pouvez l'exécuter dans Excel ou dans Query. Comment utiliser l'Assistant Requête.

Cas d'utilisation de Microsoft Query Utilisez Microsoft Query lorsque vous souhaitez créer une requête plus complexe. Cette méthode est celle qui vous permet de contrôler au mieux votre requête, car vous pouvez affiner votre jeu de résultats en créant une jointure interne ou une jointure externe, ou encore en utilisant des expressions et des critères complexes. Les expressions sont des calculs que vous pouvez effectuer à l'aide d'opérateurs, de fonctions, de noms de champs et de constantes. Vous pouvez effectuer des filtrages plus complexes à l'aide de critères.

Vous pouvez visualiser l'ensemble des résultats dans Query. Lorsque vous êtes certain que les résultats contiennent les données souhaitées, vous pouvez les renvoyer dans Microsoft Excel. Vous pouvez également créer des cubes OLAP dans Query. Après avoir créé la requête, vous pouvez l'exécuter dans Excel ou Query. Comment créer une requête dans Microsoft Query.

Cas d'utilisation d'une requête paramétrée Utilisez une requête paramétrée lorsque vous souhaitez créer une requête permettant de récupérer des données répondant à différents critères. Par exemple, pour récupérer les données sur les ventes pour un produit à la fois, vous pouvez utiliser le nom du produit comme critère. Les requêtes paramétrées sont également utiles pour récupérer une partie des données d'une base de données trop volumineuse pour que votre système puisse prendre en charge la récupération de toutes les données en une seule fois.

Une requête paramétrée vous invite à indiquer des critères lorsque vous l'exécutez. Une requête paramétrée ne peut être créée que dans Microsoft Query, et non dans l'Assistant de Requête. Les critères que vous tapez sont utilisés pour extraire les données des tables dans votre requête. Une fois la requête créée, vous pouvez l'exécuter dans Microsoft Excel ou Microsoft Query. Comment créer une requête paramétrée.


Créer une nouvelle requête

Que voulez-vous faire ?

Créer une requête à l'aide de l'Assistant Requête

Créer une requête plus complexe dans Microsoft Query

Créer une requête paramétrée

Vous hésitez entre plusieurs rubriques ?


Créer une requête paramétrée

  1. Créez une requête comprenant des tables et des champs pour les enregistrements souhaités.

    Procédure

  2. Vérifiez que le bouton Requête automatique Image du bouton n'est pas enfoncé.
  3. Vérifiez que le bouton Afficher ou masquer les critères Image du bouton est enfoncé pour afficher le volet des critères.
  4. Cliquez sur la première cellule de la ligne Champ, puis cliquez sur la flèche dans la cellule pour sélectionner dans la liste un champ que vous souhaitez utiliser comme paramètre de la requête.
  5. Cliquez sur la première cellule de la ligne Valeur. Tapez [ (un crochet gauche) suivi du texte de l'invite que Microsoft Query doit afficher lorsque la requête est exécutée, puis tapez ] (un crochet droit). Un exemple est donné dans l'illustration suivante.

    Le texte de l'invite doit être différent du nom du champ, bien qu'il puisse l'inclure.

    Pour créer d'autres paramètres pour la requête, répétez les étapes 4 et 5 pour chaque paramètre que vous souhaitez ajouter dans la colonne disponible suivante dans le volet des critères.

    Pour plus d'informations sur les critères que vous pouvez utiliser pour affiner une requête, cliquez sur Image du bouton .

  6. Appuyez sur ENTRÉE.
  7. Pour exécuter la requête, cliquez sur le bouton Requête immédiate Image du bouton.

Remarque Lorsque vous avez terminé de récupérer les données souhaitées, vous pouvez renvoyer le jeu de résultats vers Microsoft Excel. Pour plus d'informations, cliquez sur Image du bouton .


Ouvrir une requête

  1. Cliquez sur le bouton Ouvrir une requête Image du bouton, sélectionnez le fichier que vous souhaitez ouvrir, puis cliquez sur Ouvrir.

    L'extension d'un fichier de type Query est .dqy ou .qry.

  2. Si vous y êtes invité, tapez votre nom d'accès, mot de passe et toute autre information obligatoire pour votre source de données.
  3. SI vous y êtes invité, entrez des valeurs de paramètre pour la requête, puis cliquez sur OK. Si vous ne savez pas quels sont les paramètres valides, contactez la personne qui a créé la requête.

Remarque Vous pouvez également ouvrir un fichier de définition du cube .oqy créé à l'aide de l'Assistant Cube OLAP. Si vous ouvrez ce type de fichier, l'Assistant démarre afin que vous puissiez modifier la définition du cube. Obtenir des informations sur la création de cubes à l'aide de l'Assistant Cube OLAP.


Enregistrer une requête

Enregistrez une requête si vous souhaitez conserver la mise en forme ou utiliser la requête ultérieurement ou dans un autre classeur. Pour plus d'informations sur l'ouverture des fichiers de requête dans Microsoft Excel, consultez l'aide de Microsoft Excel. Vous n'avez pas besoin d'enregistrer une requête pour renvoyer des données vers Excel.

  1. Cliquez sur le bouton Enregistrer la requête Image du bouton.
  2. Dans la zone Nom de fichier, tapez le nom souhaité.
  3. Dans la liste Type, Microsoft Query sélectionne automatiquement Fichiers Query (*.dqy). Pour utiliser la requête dans une version de Microsoft Query antérieure à Microsoft Query 97, cliquez sur Fichiers Query (*.qry).

    Une requête de paramètres ne peut être enregistrée qu'au format *.dqy et ne peut pas être utilisée dans une version de Microsoft Query antérieure à Microsoft Query 97.

  4. Dans la liste Dans, cliquez sur le dossier dans lequel vous souhaitez stocker la requête.
  5. Cliquez sur le bouton Enregistrer.

Remarques

  • Lorsque vous enregistrez un fichier de requête, Microsoft Query n'enregistre pas le jeu de résultats actuel affiché dans le volet des données. Le jeu de résultats est automatiquement actualisé, avant l'affichage de la boîte de dialogue Enregistrer sous, même lorsque le bouton Requête automatique Image du bouton n'est pas enfoncé.
  • Pour empêcher Microsoft Query d'exécuter la requête avant son enregistrement ou avant le renvoi de données vers Excel, cliquez dans le menu Edition sur Options, puis désactivez la case à cocher Valider les requêtes avant l'enregistrement ou le retour des données.
  • Les fichiers de requête figurent par défaut dans votre dossier de profils utilisateur, dans Application Data\Microsoft\Queries. Lorsque vous enregistrez une requête à cet endroit, son nom de fichier s'affiche sous l'onglet Requêtes lors de l'ouverture d'une nouvelle requête dans Microsoft Query ou de l'utilisation de la commande Exécuter une requête enregistrée (menu Données, sous-menu Données externes) dans Microsoft Excel.


Exécuter, afficher ou modifier une commande, une procédure ou une instruction SQL

Si vous connaissez le langage SQL (Structured Query Language), vous pouvez l'utiliser pour modifier l'instruction SQL SELECT d'une requête. Pour plus d'informations sur le langage SQL, consultez la documentation de votre base de données.

  1. Créez une nouvelle requête. Ne renvoyez pas les résultats vers Microsoft Excel.

    Procédure

  2. Cliquez sur le bouton Afficher l'interrogation SQL Image du bouton.

    Microsoft Query affiche la boîte de dialogue SQL avec l'instruction SQL SELECT correspondant à la requête.

  3. Effectuez les modifications souhaitées dans l'instruction SQL, puis cliquez sur OK.

    Pour ajouter une nouvelle ligne dans la zone Interrogation SQL, appuyez sur ENTRÉE.

Remarques

  • Pour modifier ou remplacer l'instruction SQL, utilisez la même syntaxe SQL que celle qui est utilisée par Microsoft Query ou la syntaxe prise en charge par votre source de données. Microsoft Query essaie d'interpréter la syntaxe utilisée et affiche la conception de la requête et son jeu de résultats.
  • Si Microsoft Query ne peut pas afficher la conception de la requête parce qu'il ne peut pas interpréter une partie de la syntaxe utilisée, le jeu de résultats est quand même affiché. Toutefois, vous ne pouvez changer que la mise en forme du jeu de résultats, telle que la police d'affichage ou la largeur des colonnes. Vous ne pouvez pas modifier les données, et toute modification apportée à la définition de la requête, telle que l'ajout ou la suppression de champs, doit être effectuée dans la boîte de dialogue SQL.


Exécuter une requête automatiquement ou différer l'exécution de la requête

Microsoft Query exécute automatiquement une requête et actualise les données dans le jeu de résultats à chaque fois que vous ajoutez un champ dans le volet des données ou que vous ajoutez ou modifiez des critères dans le volet des critères. Si votre requête contient un nombre important d'enregistrements, vous pouvez différer l'exécution de la requête jusqu'à ce que vous ayez terminé de la modifier.

  • Pour exécuter automatiquement une requête à chaque fois que vous ajoutez des critères ou un champ, vérifiez que le bouton Requête automatique Image du bouton est enfoncé.
  • Pour différer l'exécution d'une requête jusqu'à ce que vous ayez terminé d'ajouter de nouveaux critères ou champs, vérifiez que le bouton Requête automatique Image du bouton n'est pas enfoncé. Lorsque vous êtes prêt à exécuter la requête, cliquez sur le bouton Requête immédiate Image du bouton.


Renvoyer un jeu de résultats vers Microsoft Excel

  1. Si la boîte de dialogue Renvoi de données externes vers Excel n'est pas affichée, cliquez sur le bouton Renvoyer les données Image du bouton, et si vous y êtes invité, indiquez toute valeur paramétrée requise par la requête.
  2. Cliquez sur Propriétés pour contrôler les options de mise en forme et de mise en page et la manière dont la plage de données externes est renvoyée vers Microsoft Excel. Pour plus d'informations, consultez l'aide de Microsoft Excel.
  3. Pour insérer l'ensemble de résultats sur la feuille de calcul sélectionnée, cliquez sur Une feuille de calcul existante. Dans votre feuille de calcul, cliquez sur la cellule dans laquelle vous souhaitez insérer le coin supérieur gauche de l'ensemble de résultats, puis cliquez sur OK.

    Pour insérer l'ensemble de résultats sur une nouvelle feuille de calcul, cliquez sur Une nouvelle feuille de calcul, puis sur OK. Microsoft Excel ajoute une nouvelle feuille de calcul à votre classeur et insère automatiquement l'ensemble de résultats dans le coin supérieur gauche de la nouvelle feuille.

    Pour utiliser des données externes dans un rapport de tableau croisé dynamique, cliquez sur Rapport de tableau croisé dynamique, puis sur OK.

Remarques

  • Le jeu de résultats est automatiquement actualisé dans Microsoft Query, avant l'affichage de la boîte de dialogue Renvoi de données externes vers Excel, même si l'utilisateur n'a pas cliqué sur le bouton Requête automatique Image du bouton. Pour empêcher Microsoft Query d'exécuter la requête avant le renvoi des données vers Excel, cliquez dans le menu Edition sur Options dans Microsoft Query, puis désactivez la case à cocher Valider les requêtes avant l'enregistrement ou le retour des données.
  • Vous pouvez vérifier l'état d'une requête dont le temps de recherche des données est particulièrement long. Dans Excel, cliquez sur le bouton Actualiser les données image du bouton dans la barre d'outils Données externes. Pour annuler la recherche de données, cliquez sur Annuler l'actualisation.


Exécuter une instruction SQL ou une procédure

Si vous connaissez le langage SQL (Structured Query Language), vous pouvez l'utiliser pour exécuter une instruction SQL SELECT. Pour plus d'informations sur le langage SQL, consultez la documentation de votre base de données.

  1. Dans le menu Fichier, cliquez sur Exécuter SQL.

    Pour exécuter une instruction SQL sur une table dans une autre source de données, cliquez sur Sources de données, et enfin sur la source de données souhaitée, puis sur OK. Vous pouvez spécifier une nouvelle source de données.

    Procédure

  2. Dans la zone Interrogation SQL, tapez l'instruction SQL que vous souhaitez exécuter.

    Si vous souhaitez exécuter une instruction SQL existante, cliquez sur Ouvrir, puis sur le fichier SQL et enfin sur Ouvrir.

    Pour exécuter une procédure SQL stockée dans votre base de données externe, cliquez sur Procédures, puis dans la zone Query sur la procédure souhaitée, et enfin sur Coller pour copier la procédure dans Interrogation SQL.

  3. Cliquez sur Exécuter.

    Microsoft Query exécute l'instruction SQL. Vous pouvez annuler une requête pour laquelle le temps de récupération des données est trop long, en appuyant sur ÉCHAP.

    Pour enregistrer l'instruction SQL, cliquez sur Enregistrer.

Remarques

  • Pour modifier ou remplacer l'instruction SQL, utilisez la même syntaxe SQL que celle qui est utilisée par Microsoft Query ou la syntaxe prise en charge par votre source de données. Microsoft Query essaie d'interpréter la syntaxe utilisée et affiche la conception de la requête et son jeu de résultats.
  • Si Microsoft Query ne peut pas afficher la conception de la requête parce qu'il ne peut pas interpréter une partie de la syntaxe utilisée, le jeu de résultats est quand même affiché. Toutefois, vous ne pouvez changer que la mise en forme du jeu de résultats, telle que la police d'affichage ou la largeur des colonnes. Vous ne pouvez pas modifier les données, et toute modification apportée à la définition de la requête, telle que l'ajout ou la suppression de champs, doit être effectuée dans la boîte de dialogue SQL.
  • Si la requête récupère plusieurs jeux de résultats, Microsoft Query affiche le premier dans le volet des données. Les autres jeux de résultats ne sont pas affichés.
  • Si la requête est correctement exécutée mais qu'aucun jeu de résultats n'est renvoyé, Microsoft Query affiche un message indiquant que l'instruction a été correctement exécutée. Si la requête a affecté des lignes de tables sous-jacentes, le message indique également le nombre de lignes qui ont été affectées.
  • Si la requête n'a pas correctement été exécutée, Microsoft Query affiche le message d'erreur SQL correspondant au problème. Pour afficher la boîte de dialogue Exécuter SQL et la bonne instruction, cliquez sur OK.


À propos des requêtes OLAP

Microsoft Query vous permet de créer et d'utiliser des données provenant de bases de données OLAP (On-Line Analytical Processing) en définissant des sources de données, en créant des cubes OLAP à partir de données relationnelles et en enregistrant des fichiers de définition de cube OLAP. Cette rubrique explique comment utiliser Microsoft Query pour préparer des données OLAP à utiliser dans des rapports de tableau croisé dynamique et des rapports de graphique croisé dynamique Microsoft Excel.

Cette rubrique fournit des informations sur les sujets suivants :

Qu'est-ce que OLAP ?

Connexion à des bases de données OLAP

Création d'un cube OLAP à partir des enregistrements contenus dans une requête

Enregistrement de fichiers de requête OLAP

Qu'est-ce que OLAP ?

OLAP permet d'organiser les bases de données des grandes entreprises. Les données OLAP sont organisées par un administrateur de bases de données pour correspondre à la façon dont les utilisateurs les analysent et les gèrent, de sorte que la création de vos rapports nécessite moins de temps et d'effort.

Niveaux de détail Les bases de données OLAP organisent les données par niveau de détail, en utilisant des catégories de même type que celles que vous utilisez lorsque vous analysez les données. Par exemple, une base de données contenant des informations sur les ventes mondiales des produits d'une société peut contenir des champs séparés identifiant le pays, la région, la ville et le site pour chaque vente. Dans une base de données OLAP, ces informations géographiques pourraient être organisées du niveau de détail le plus bas au niveau le plus élevé, comme suit :

Niveaux dans une dimension géographique

Niveaux dans une dimension géographique

Cette organisation facilite l'affichage des synthèses de ventes de haut niveau, telles que les totaux des ventes dans tout un pays ou toute une région et l'affichage des détails pour des sites où les ventes sont particulièrement fortes ou faibles. Dans un rapport de tableau ou de graphique croisé dynamique Microsoft Excel, vous pouvez afficher des données de synthèse à différents niveaux et, lorsque vous affichez les niveaux contenant plus de détails, vous pouvez choisir uniquement les éléments qui vous intéressent.

Dimensions et cubes Un ensemble de niveaux qui contient un aspect des données, tel que des zones géographiques, est appelé une dimension. De même, des informations relatives au moment où les ventes ont été effectuées peuvent être organisées dans une dimension temporelle hiérarchisée par année, trimestre, mois et jour. Les bases de données OLAP sont appelées cubes parce qu'elles associent plusieurs dimensions, telles que le temps, la géographie et les produits, avec des données de synthèse, telles que des ventes ou des résultats d'inventaire. Une base de données OLAP calcule une valeur de synthèse pour chaque intersection de chaque niveau de chaque dimension, comme les ventes totales pour chaque jour, mois et année de chaque site, région et pays et de chaque produit et gamme de produit.

Retour au début

Connexion à des bases de données OLAP

Fournisseurs OLAP Pour vous connecter à une base de données OLAP, vous devez faire appel à un fournisseur OLAP qui prend en charge ce type particulier de base de données OLAP. Microsoft Office contient un logiciel de fournisseur OLAP pour le produit serveur Microsoft OLAP, Microsoft SQL Server OLAP Services. Pour les autres produits qui fournissent des données et des services OLAP, vous devez installer des logiciels client et des pilotes complémentaires. Pour plus d'informations sur l'utilisation d'un fournisseur OLAP tiers, consultez votre administrateur système ou le vendeur de votre produit OLAP. Obtenir des informations sur l'installation de fournisseurs OLAP.

Sources de données Un logiciel client OLAP contient un pilote de source de données pour votre base de données OLAP. Office contient un pilote, appelé Fournisseur Microsoft OLE DB pour OLAP Services, permettant d'accéder aux bases de données créées à l'aide de Microsoft SQL Server OLAP Services. Lorsque vous créez des cubes ou des fichiers de cube hors connexion à partir de Microsoft Query, vous créez également des sources de données pour accéder à ces cubes.

Lorsque vous exécutez Microsoft Query pour vous connecter à une base de données OLAP ou à un fichier de cube hors connexion, vous définissez une nouvelle source de données comme vous le feriez pour tout autre type de données, excepté que vous utilisez l'onglet Cubes OLAP de la boîte de dialogue Choisir une source de données pour nommer la source de données, indiquer le pilote de source de données pour votre fournisseur OLAP et vous connecter à la base de données. Installer une source de données ODBC.

Renvoi de données dans Excel Après avoir défini une source de données OLAP et l'avoir sélectionnée pour l'utiliser, vous ne créez pas une requête pour sélectionner des tables et des champs comme vous le feriez pour d'autres types de données. La source de données vous donne accès à toutes les données contenues dans le cube OLAP. Les champs de données sont immédiatement renvoyés dans Excel sous la forme d'un rapport de tableau croisé dynamique.

Retour au début

Création d'un cube OLAP à partir des enregistrements contenus dans une requête

En utilisant Microsoft Query et le logiciel client OLAP fourni avec Microsoft Office, vous pouvez créer votre propre cube OLAP ou fichier de cube hors connexion à partir de données extraites d'une base de données relationnelles, telle que Microsoft SQL Server. La création d'un cube OLAP peut améliorer l'accès à de grandes quantités de données relationnelles et aider à organiser les données pour les utiliser dans des rapports. Aucun produit serveur OLAP n'est nécessaire pour créer et utiliser ce type de cube OLAP.

Extraction des données pour le cube Pour créer votre propre cube, vous devez d'abord définir une source de données pour la base de données relationnelle, créer une requête pour extraire les données, puis exécuter l'Assistant Cube OLAP pour définir une structure de cube pour les données faisant l'objet d'une requête et, si vous le souhaitez, enregistrer un fichier de cube hors connexion.

Création d'un cube en mémoire Dans l'Assistant Cube OLAP, vous pouvez créer un cube temporaire recréé en mémoire chaque fois que vous ouvrez un rapport basé sur le cube. Consultez l'aide de l'Assistant Cube OLAP pour plus d'informations sur la création de ce type de cube. Obtenir des informations sur l'exécution de l'Assistant pour créer un cube OLAP.

Création d'un fichier de cube hors connexion L'Assistant Cube OLAP vous permet également de créer un fichier de cube hors connexion (.cub) que vous pouvez stocker sur votre disque local ou sur un partage réseau. Lorsqu'il est stocké sur votre disque local, un fichier .cub peut être utilisé pour continuer à travailler avec les données lorsque vous êtes déconnecté du réseau ou si le serveur n'est pas disponible. Si vous stockez le fichier sur un partage réseau, vous et d'autres utilisateurs pouvez définir des sources de données pour accéder au fichier de cube hors connexion et baser des rapports dessus. Obtenir des informations sur l'exécution de l'Assistant pour créer un fichier de cube hors connexion.

Retour au début

Enregistrement de fichiers de requête OLAP

Sources de données OLAP Lorsque vous utilisez l'onglet Cubes OLAP de la boîte de dialogue Choisir une source de données pour définir une source de données, Microsoft Query enregistre un fichier .oqy dans votre dossier de profil utilisateur sous Application Data\Microsoft\Queries. Outre la spécification de la source de données lorsque vous créez un rapport de tableau ou de graphique croisé dynamique dans Excel, vous pouvez ouvrir le fichier .oqy directement à partir de Microsoft Excel pour créer un rapport de tableau croisé dynamique. Si le fichier .oqy se connecte à la base de données d'un serveur OLAP ou à un fichier de cube hors connexion sur un partage réseau, vous pouvez permettre à d'autres utilisateurs d'accéder au fichier .oqy afin qu'ils puissent l'ouvrir pour créer des rapports sans avoir à définir leurs propres sources de données.

Cubes de l'Assistant Cube OLAP Après l'étape finale de l'Assistant Cube OLAP, vous êtes invité à enregistrer un fichier de définition de cube avec l'extension .oqy. Ce fichier contient les informations nécessaires à Excel pour créer le cube en mémoire ou pour se connecter à un fichier de cube hors connexion, si vous en avez créé un. Au lieu de renvoyer les enregistrements de votre requête dans Microsoft Excel, vous pouvez ouvrir ce fichier dans Microsoft Excel pour créer un rapport de tableau croisé dynamique. Il n'est pas nécessaire de définir une source de données séparée pour le cube OLAP, bien que vous puissiez définir une source de données séparée pour un fichier de cube hors connexion si vous souhaitez vous connecter directement au fichier de cube afin de créer des rapports.

L'enregistrement du fichier .oqy est différent de l'enregistrement d'une copie de la requête pour les enregistrements de la base de données relationnelle que vous avez utilisés pour créer le cube OLAP. Si vous souhaitez conserver une copie de cette requête pour pouvoir ajouter des données à votre cube ultérieurement, vous devez enregistrer la requête dans un fichier de requête (.dqy) de base de données.

Retour au début


Création d'un cube OLAP à partir de données relationnelles

Cette rubrique explique comment vous pouvez créer un cube OLAP à partir d'une requête qui extrait des données d'une base de données relationnelle, telle qu'une base de données Microsoft Access ou Microsoft SQL Server. Aucun produit serveur OLAP n'est nécessaire pour créer et utiliser ce type de cube OLAP. Pour mieux connaître et utiliser cette fonctionnalité de Microsoft Query, vous devez être familiarisé avec la gestion de bases de données et avec l'utilisation de Microsoft Query pour extraire des données pour des rapports de tableau croisé dynamique ou des rapports de graphique croisé dynamique Microsoft Excel.

Cette rubrique fournit des informations de références sur les sujets suivants :

Qu'est-ce qu'un cube OLAP ?

Création d'une requête pour les données

Création d'un cube

Actualisation et modification d'un cube

Qu'est-ce qu'un cube OLAP ?

Le traitement analytique en ligne (OLAP, On-Line Analytical Processing) est une manière d'organiser des données pour ajuster la façon de les analyser et de les gérer, afin que la création de vos rapports nécessite moins de temps et d'effort. Lorsque vous créez un cube OLAP à partir d'une requête, vous transformez le jeu d'enregistrements à deux dimensions en hiérarchie structurée, ou cube, permettant à des rapports d'afficher le niveau de détails souhaité. Vous définissez également les valeurs de synthèse pour les rapports, ce qui accélère le calcul d'un rapport.

Créez un cube OLAP lorsque vous souhaitez fournir une grande quantité de données externes à utiliser dans des rapports Microsoft Excel, en particulier si vous avez plus d'enregistrements à analyser que vous ne pouvez en renvoyer dans Excel sans épuiser les ressources de votre système. Étant donné qu'un cube permet à Excel d'extraire uniquement les données dont il a besoin pour l'affichage en cours du rapport, la création et la mise à jour d'un rapport est généralement plus rapide pour de grandes quantités de données que si vous procédez à l'extraction de tout le jeu d'enregistrements à partir de la base de données.

Les données de votre cube OLAP peuvent être renvoyées vers Excel uniquement en tant que rapport de tableau ou de graphique croisé dynamique, contrairement aux enregistrements de la base de données relationnelle de votre requête, qui peuvent également être renvoyées vers Excel en tant que plage de données externes dans une feuille de calcul.

Retour au début

Création d'une requête pour les données

Pour créer un cube OLAP à partir des enregistrements d'une base de données relationnelle, vous devez définir une source de données pour la base de données relationnelle puis créer une requête pour extraire les champs et les enregistrements afin de fournir les données pour le cube.

Sélection de champs pour la requête Pour être sûr que la requête s'exécute aussi efficacement que possible, incluez uniquement les tables et les champs dont vous avez besoin pour le cube dans la requête. Toutefois, assurez-vous que vous ajoutez tous les champs que vous souhaitez. Une fois que vous avez créé un cube, vous ne pouvez plus ajouter d'autres champs à la requête puis incorporer les nouveaux champs dans le cube. Pour ajouter d'autres champs à un cube, vous devez le recréer complètement.

Ajout de champs plusieurs fois Parfois, il est possible vous souhaitiez utiliser un champ plusieurs fois dans un cube. Par exemple, vous pouvez synthétiser un champ Ventes de deux manières différentes, en additionnant les montants des ventes et en comptant le nombre de ventes. Vous pouvez également inclure deux versions différentes d'un champ Date : un qui organise les dates par trimestre et par mois et un autre qui organise les dates par trimestre et par semaine. Pour utiliser un champ plusieurs fois dans un cube, vous devez ajouter le champ à la requête une fois pour chaque utilisation. Par exemple, ajoutez le champ Ventes à la requête deux fois si vous comptez à la fois additionner et compter les valeurs dans le champ.

Consultez l'aide de l'Assistant Cube OLAP pour savoir à quel moment inclure un champ dans la requête plusieurs fois. Si vous devez ajouter des champs à la requête pendant l'exécution de l'Assistant, vous pouvez fermer celui-ci, ajouter les champs, puis exécuter de nouveau l'Assistant.

Enregistrement de la requête Si vous pensez que vous devrez recréer le cube ultérieurement avec d'autres champs, veillez à enregistrer la requête dans un fichier de requête de base de données (.dqy). Vous pouvez ensuite ouvrir le fichier .dqy, changer la requête et créer des cubes à partir de la requête modifiée.

Retour au début

Création d'un cube

Pour créer un cube, exécutez l'Assistant Cube OLAP. Consultez l'aide de cet Assistant pour obtenir des instructions spécifiques à chaque étape de l'Assistant.

Cubes temporaires et fichiers de cube hors connexion L'Assistant vous permet de créer deux types de cubes. Le premier type est une définition du cube que l'Assistant enregistre dans un fichier .oqy. Lorsque vous ouvrez un rapport basé sur ce type de fichier .oqy, le cube est créé temporairement en mémoire. Le second type est un fichier de cube hors connexion séparé que vous stockez sur votre disque local ou sur un partage réseau. S'il est stocké sur votre disque local, ce type de cube vous permet de continuer à travailler avec les données lorsque vous êtes déconnecté du réseau. Vous pouvez définir un fichier de cube hors connexion en tant que source de données pour des rapports.

Enregistrement d'un fichier de définition d'un cube Que vous décidiez d'enregistrer ou non un fichier de cube hors connexion séparé, l'Assistant enregistre un fichier de définition de cube (.oqy). Ce fichier contient les informations nécessaires à Microsoft Query pour charger le cube pour que vous puissiez le modifier et les informations nécessaires à Excel pour créer le cube en mémoire ou vous connecter à un fichier de cube hors connexion, si vous en avez créé un.

Utilisation du fichier de définition du cube pour créer des rapports Au lieu de renvoyer les enregistrements de votre requête de base de données relationnelle vers Microsoft Excel, vous pouvez ouvrir le fichier .oqy dans Excel pour créer un rapport de tableau croisé dynamique basé sur votre cube OLAP. Vous pouvez ensuite enregistrer un rapport de tableau croisé dynamique dans un classeur ou créer des rapports de graphique croisé dynamique basés sur le rapport de tableau croisé dynamique. Pour obtenir des instructions sur l'ouverture des fichiers .oqy et la création des rapports, consultez l'aide de Microsoft Excel.

Retour au début

Actualisation et modification d'un cube

Actualisation d'un cube OLAP Pour actualiser un cube, ouvrez un rapport basé sur le cube dans Microsoft Excel et actualisez le rapport. En procédant ainsi, les données nouvelles et modifiées de la base de données d'origine sont importées dans le cube, si celui-ci est temporairement créé en mémoire. Si le cube est un fichier de cube hors connexion, le fichier est recréé avec les nouvelles données et le fichier existant est remplacé. Pour créer vos propres cubes et les actualiser, vous devez faire appel à un fournisseur OLAP, tel que Microsoft SQL Server OLAP Services, qui prend en charge ces fonctionnalités. Consultez l'aide de Microsoft Excel pour en savoir plus sur la procédure d'actualisation d'un rapport de tableau ou de graphique croisé dynamique basé sur un cube OLAP.

Modification d'un cube OLAP Vous pouvez modifier un cube OLAP créé dans l'Assistant Cube OLAP pour organiser les données différemment ou supprimer des champs que vous ne souhaitez pas utiliser dans des rapports. Si vous avez créé un fichier de cube hors connexion, vous pouvez enregistrer le fichier avec vos modifications.

Une fois que vous avez créé un cube OLAP, vous ne pouvez plus lui ajouter d'autres champs à partir de la base de données relationnelle d'origine. Vous pouvez, toutefois, créer un nouveau cube OLAP à partir du même fichier de requête de base de données (.dqy) ce qui vous permet d'utiliser des champs différents de la base de données d'origine.

Retour au début


Créer un cube OLAP à partir de données relationnelles

Les données de votre cube OLAP ne peuvent être renvoyées dans Microsoft Excel que sous la forme d'un rapport de tableau croisé dynamique, mais pas en tant que plage de données externes dans une feuille de calcul.

  1. Créez une requête pour extraire les champs que vous souhaitez utiliser dans le cube.

    Procédure

  2. Exécutez l'Assistant Cube OLAP en appliquant l'une des méthodes suivantes :

    Si vous avez créé la requête dans l'Assistant Requête, cliquez sur Créer un cube OLAP à partir de cette requête dans la dernière étape de l'Assistant, puis cliquez sur Terminer.

    Si vous avez créé la requête dans Microsoft Query, cliquez sur Créer un cube OLAP dans le menu Fichier.

  3. Suivez les étapes de l'Assistant Cube OLAP. Pour obtenir des instructions spécifiques, consultez l'aide de l'Assistant Cube OLAP.
  4. Lorsque vous avez accompli toutes les étapes de l'Assistant, Query vous invite à enregistrer un fichier de définition de cube (.oqy). Tapez un nom pour ce fichier, puis cliquez sur Enregistrer.

Remarques

  • Si vous avez spécifié un fichier de cube (.cub) hors connexion dans l'Assistant Cube OLAP, le fichier .cub est créé une fois que vous avez cliqué sur Enregistrer. Selon la quantité de données pour votre cube, l'enregistrement de ce fichier peut prendre un certain temps. Vous ne pouvez accomplir aucune autre tâche dans Microsoft Query tant que la création du fichier de cube hors connexion n'est pas terminée.
  • Pour baser d'autres rapports Microsoft Excel sur votre cube, ne renvoyez pas les données de votre requête dans Excel. Ouvrez plutôt le fichier .oqy en utilisant la commande Ouvrir du menu Fichier de Microsoft Excel.
  • Vous pouvez également baser des rapports Excel sur un fichier de cube hors connexion en définissant une source de données pour le fichier, puis en spécifiant cette source de données lorsque vous exécutez l'Assistant Tableau et graphique croisé dynamique de Microsoft Excel.
  • Si vous comptez ajouter ultérieurement d'autres champs au cube à partir de la base de données sources, veillez à enregistrer un fichier de requête de base de données (.dqy) afin de pouvoir utiliser ce fichier pour changer le cube.


Changer le contenu et les paramètres d'un cube OLAP

Vous pouvez changer l'organisation des champs dans un cube et supprimer les champs dont vous n'avez plus besoin dans le cube, mais vous ne pouvez pas ajouter d'autres champs à un cube OLAP existant. Pour ajouter d'autres champs à un cube, vous devez créer un nouveau cube.

  1. Dans le menu Fichier de Microsoft Query, cliquez sur Ouvrir.
  2. Dans la liste Types de fichiers, cliquez sur Cubes OLAP.
  3. Recherchez et double-cliquez sur le fichier de définition du cube (.oqy) que vous souhaitez modifier.
  4. Suivez les étapes de l'Assistant Cube OLAP pour changer le contenu et les paramètres. Pour obtenir des instructions spécifiques, consultez l'aide de l'Assistant Cube OLAP.
  5. Lorsque vous avez effectué toutes les étapes de l'Assistant, Query vous invite à enregistrer le fichier .oqy. Pour remplacer le fichier .oqy existant, cliquez sur Enregistrer. Pour enregistrer un nouveau fichier .oqy, tapez un nouveau nom puis cliquez sur Enregistrer.

Remarques

  • Si vous avez spécifié un fichier de cube (.cub) hors connexion dans l'Assistant Cube OLAP, le fichier .cub est créé une fois que vous avez cliqué sur Enregistrer. Pour modifier un fichier .cub existant, vous devez complètement le recréer et le remplacer. Selon la quantité de données pour votre cube, l'enregistrement de ce fichier peut prendre un certain temps. Vous ne pouvez accomplir aucune autre tâche dans Microsoft Query tant que la création du fichier .cub n'est pas terminée.
  • Vous pouvez baser des rapports Microsoft Excel sur un fichier .cub en ouvrant le fichier .oqy à l'aide de la commande Ouvrir du menu Fichier de Microsoft Excel ou en définissant une source de données pour le fichier .cub puis en spécifiant cette source de données lorsque vous exécutez l'Assistant Tableau et graphique croisé dynamique.


Supprimer un fichier de cube hors connexion

La suppression d'un fichier de cube (.cub) hors connexion efface celui-ci de manière permanente du disque sur lequel il était stocké, et l'espace disque souvent important utilisé par ces fichiers est libéré. Toutefois, vous ne pouvez plus changer les rapports qui étaient basés sur le fichier. Si vous, ou d'autres utilisateurs, avez créé des sources de données qui utilisent ce fichier, vous ne pouvez plus les utiliser.

  • Dans Microsoft Windows, recherchez et supprimez le fichier .cub.


Ajouter une table dans une requête

  1. Cliquez sur le bouton Ajouter une ou des tables Image du bouton.
  2. Sélectionnez la table que vous souhaitez ajouter.
  3. Cliquez sur Ajouter.

Remarque Vous pouvez ajouter à la requête autant de tables que vous le souhaitez. Lorsque vous avez terminé, cliquez sur Fermer.


Supprimer une table dans une requête

  1. Cliquez sur la table que vous souhaitez supprimer.
  2. Dans le menu Edition, cliquez sur Supprimer.


Ajouter ou supprimer un champ

Un champ est une catégorie d'informations, par exemple un nom de produit ou un montant de commandes, stockée dans une table d'informations d'une base de données. Lorsque vous ajoutez ou supprimez un champ, votre requête inclut ou exclut les informations contenues dans ce champ. La base de données sous-jacente qui fournit les informations n'est pas modifiée.

Ajout d'un champ Pour ajouter un seul champ au jeu de résultats, double-cliquez sur le champ à ajouter dans le volet des tables.

Exemple de sélection d'un seul champ dans le volet des tables

Suppression d'un champ Pour supprimer un champ du jeu de résultats, cliquez sur l'en-tête de colonne du champ que vous souhaitez supprimer dans le volet des données, puis sur Supprimer une colonne dans le menu Enregistrements.

Conseils

  • Pour ajouter plusieurs champs à la fois provenant de la même table, maintenez la touche CTRL enfoncée pendant que vous cliquez sur chaque champ, puis faites glisser les champs ainsi sélectionnés vers le volet des données.
  • Pour ajouter tous les champs d'une table dans le jeu de résultats, double-cliquez sur l'astérisque (*) en haut de la table dans le volet des tables.

    Exemple d'astérisque (*) sélectionné dans le volet des tables


Récupérer des enregistrements liés provenant de plusieurs tables comportant des jointures

Cette rubrique fournit des informations sur les sujets suivants :

Jointure de tables

Jointures internes

Jointures externes

Jointures réflexives

Jointures externes complètes

Jointures de soustraction

Jointure de tables

Les bases de données sont constituées de plusieurs tables contenant des informations liées. Lorsque vous ajoutez deux tables (ou plus) à une requête, Microsoft Query crée automatiquement une « jointure » entre les tables lorsqu'il reconnaît un champ clé primaire dans une table et un champ dont le nom est identique dans l'autre table. Des lignes de jointure affichent les relations entre les données des tables.

Lignes de jointure entre des tables

Les lignes de jointure connectent la table Produits à la table Détails des commandes en liant le champ IDproduit de chaque table. La table Détails des commandes et la table Commandes sont également liées par le biais de leur champ IDcommande.

Il existe deux types de jointures de base qui peuvent être utilisées pour récupérer des enregistrements à partir de plusieurs tables. Une jointure interne récupère uniquement les enregistrements liés des tables. Une jointure externe récupère tous les enregistrements d'une table et les enregistrements liés d'une autre table.

En plus des jointures internes et externes, vous pouvez créer trois autres types de jointures : des jointures réflexives, externes complètes et de soustraction. Une jointure réflexive renvoie un jeu de résultats qui combine les informations d'une table. Une jointure externe complète renvoie tous les enregistrements des deux tables, même si ceux-ci ne sont pas liés. Une jointure de soustraction renvoie uniquement les enregistrements de la première table qui ne correspondent pas aux enregistrements de la deuxième table.

Retour au début

Jointures internes

Une jointure interne (type de jointure par défaut) récupère uniquement les enregistrements qui comportent la même valeur dans les champs joints des deux tables. Microsoft Query combine les enregistrements correspondants de chaque table, puis les affiche dans le jeu de résultats.

Exemple d'une jointure interne

Informations complémentaires

Joindre des tables dans une requête

Modifier le type de jointure entre les tables d'une requête

Retour au début

Jointures externes

Une jointure externe récupère tous les enregistrements d'une table et tous les enregistrements correspondants d'une autre table. Lorsque les valeurs des deux tables sont identiques, Microsoft Query combine les enregistrements correspondants et les affiche sous la forme d'un enregistrement unique dans le jeu de résultats. Lorsqu'un enregistrement de la table qui apporte tous ses enregistrements ne peut pas être mis en correspondance avec un enregistrement de l'autre table, l'enregistrement continue d'apparaître dans le jeu de résultats. Toutefois, Query affiche des cellules vides à l'endroit de cet enregistrement.

Exemple d'une jointure externe

Informations complémentaires

Joindre des tables dans une requête

Modifier le type de jointure entre les tables d'une requête

Retour au début

Jointures réflexives

Lorsque vous souhaitez combiner des informations dans une table, utilisez une jointure réflexive. Par exemple, dans une table d'employés, chaque enregistrement comprend l'ID d'employé du directeur responsable d'un employé. Le directeur se trouvant dans la même table que cet employé, vous pouvez lier la table à elle-même pour renvoyer à la fois le nom et l'ID d'employé du directeur.

Exemple de jointure réflexive

En liant une table à elle-même, vous pouvez récupérer à la fois l'ID et le nom du directeur.

Informations complémentaires

Récupérer plusieurs champs à l'aide d'une jointure réflexive

Retour au début

Jointures externes complètes

Lorsque vous souhaitez combiner tous les enregistrements provenant de deux tables, vous pouvez créer une requête de jointure externe complète. Ce type de requête renvoie toutes les données des deux tables, même lorsque celles-ci ne sont pas liées.

Tables contenant des données semblables avant une jointure externe complète

Par exemple, si vous disposez d'une table Clients et d'une table Commandes, vous pouvez utiliser une jointure externe complète pour renvoyer toutes les commandes en attente (de la table Commandes) et tous les clients qui n'ont pas passé de commande (de la table Clients).

Jeu de résultats affichant les clients qui n'ont pas passé de commande

Les deux premiers noms de cette liste n'ont pas passé de commande.

Remarque Lorsque vous créez une jointure externe complète, Query affiche uniquement le jeu de résultats de la requête et non les tables utilisées à l'intérieur de la requête.

Informations complémentaires

Combiner toutes les données provenant de deux tables

Retour au début

Jointures de soustraction

Lorsque deux de vos tables contiennent des données semblables, comme deux tables de clients, et lorsque chaque table contient des informations qui ne figurent pas dans l'autre table, vous pouvez créer une jointure de soustraction. Une jointure de soustraction renvoie uniquement les enregistrements de la première table qui ne correspondent pas aux enregistrements de la deuxième.

Tables contenant des données semblables avant une jointure de soustraction

Deux tables contenant des données client semblables

Exemple d'une jointure de soustraction

Informations complémentaires

Récupérer des enregistrements qui ne sont pas communs à deux tables

Retour au début


Récupérer des enregistrements provenant de plusieurs tables

Si votre requête contient plus d'une table, vous pouvez récupérer les enregistrements liés provenant de plusieurs tables à l'aide de jointures. Une jointure est un lien entre deux tables où le champ d'une table contient les mêmes données que le champ d'une autre table.

Que voulez-vous faire ?

Récupérer des enregistrements avec des jointures internes et externes

Créer une jointure interne

Créer une jointure externe

Créer une jointure réflexive

Récupérer tous les enregistrements provenant de deux tables

Récupérer uniquement les enregistrements qui ne sont pas communs à deux tables


Combiner toutes les données provenant de deux tables

Si vous voulez associer toutes les données provenant de deux tables qui comprennent des données similaires, mais pas identiques — telles que deux listes (tables) de clients qui contiennent chacune des informations (champs) différentes pour chaque client, et que chaque liste comporte des clients qui ne figurent pas dans l'autre liste — vous pouvez créer une requête qui comprend tous les clients. Ce type de requête est appelé jointure externe totale. Obtenir des informations sur les jointures externes totales.

  1. Dans Microsoft Query, créez une requête, puis ajoutez-lui les deux tables.
  2. Joignez un champ qui est identique dans les deux tables (par exemple, le champ Code client de deux listes de clients) en faisant glisser le champ de la première table vers la seconde.

    Sélectionnez un champ qui contient des informations pour tous les enregistrements de chaque table. Par exemple, si deux listes de clients contiennent les mêmes champs Code client, joignez le champ Code client.

  3. Double-cliquez sur la ligne de jointure qui relie les deux tables.
  4. Dans la boîte de dialogue Jointure, cliquez sur l'option 2, sur Ajouter, puis sur Fermer.
  5. Ajoutez tous les champs souhaités à la requête.
  6. Dans le menu Affichage, cliquez sur SQL.
  7. Sélectionnez les données de la zone Interrogation SQL, appuyez sur CTRL+C pour les copier, puis cliquez sur OK.
  8. Double-cliquez de nouveau sur la ligne de jointure.
  9. Dans la boîte de dialogue Jointure, cliquez sur l'option 3, sur Ajouter, puis sur Fermer.
  10. Dans le menu Affichage, cliquez sur SQL.
  11. Cliquez à la fin des données dans la zone Interrogation SQL, appuyez sur ENTRÉE, tapez le mot UNION en majuscules et appuyez de nouveau sur ENTRÉE.
  12. Appuyez sur CTRL+V pour coller les informations copiées après le mot UNION.
  13. Cliquez sur OK et, lorsqu'un message vous indique que la requête ne peut pas être représentée graphiquement, cliquez de nouveau sur OK.


Récupérer des enregistrements que deux tables n'ont pas en commun

Si deux tables contiennent des données similaires — telles que deux listes (tables) de clients et que chaque liste comporte des clients qui ne figurent pas dans l'autre liste — vous pouvez créer une requête qui renvoie uniquement les enregistrements de la première table ne correspondant pas aux enregistrements de la seconde table. Ce type de requête est appelé requête soustractive ou jointure soustractive.

  1. Dans Microsoft Query, créez une requête, puis ajoutez-lui les deux tables.
  2. Joignez les champs qui sont identiques dans les deux tables (par exemple, le champ Code client de deux listes de clients) en faisant glisser le champ de la première table vers la seconde.
  3. Double-cliquez sur la ligne de jointure qui relie les deux tables.
  4. Dans la boîte de dialogue Jointure, cliquez sur l'option 2, sur Ajouter, puis sur Fermer.
  5. Ajoutez le champ joint à la requête.
  6. Ajoutez à la requête un champ de la seconde table autre que le champ joint. Sélectionnez un champ qui contient des données pour tous les enregistrements de la seconde table. Par exemple, si vous avez joint les champs Code client des deux tables, vous pouvez ajouter le champ Nom du client de la seconde table.
  7. Dans le menu Affichage, cliquez sur Critères.
  8. Dans le premier champ de critères, cliquez sur le champ ajouté à l'étape 6.
  9. Dans le premier champ Valeur, tapez Est Nul.
  10. Pour afficher les enregistrements de la première table qui ne sont pas inclus dans la seconde, cliquez sur Requête immédiate Image du bouton.
  11. Ajoutez tous les champs supplémentaires souhaités dans la requête, puis renvoyez les données vers Microsoft Excel.

Remarque Si vous voulez également afficher les enregistrements de la seconde table qui ne correspondent pas aux enregistrements de la première table, créez une seconde requête dans laquelle vous suivez les mêmes étapes, mais où vous inversez l'ordre des tables (la seconde table devient la première et inversement).


Créer une jointure externe

Une jointure externe affiche tous les enregistrements d'une table et tous les enregistrements liés provenant d'une autre table.

  1. Créez une jointure interne entre les tables. Comment créer une jointure interne.
  2. Double-cliquez sur la ligne de jointure entre les tables.
  3. Cliquez sur = (signe égal) dans la liste Opérateur.
  4. Effectuez l'une des actions suivantes :

    Pour créer une jointure externe qui utilise tous les enregistrements de la table de gauche, cliquez sur l'option 2 sous Options.

    Pour créer une jointure externe qui utilise tous les enregistrements de la table de droite, cliquez sur l'option 3 sous Options.

Remarques

  • Récupérez tous les enregistrements provenant de deux tables Si vous souhaitez associer tous les enregistrements provenant de deux tables, qu'ils soient liés ou non, vous pouvez créer une jointure externe complète.
  • Récupérez uniquement les enregistrements qui ne sont pas communs à deux tables Plutôt que de récupérer les enregistrements liés, vous pouvez récupérer tous les enregistrements qui ne sont pas communs à deux tables.


Créer une jointure interne

  • Faites glisser un champ d'une table vers le champ correspondant (un champ du même type de données qui contient des données similaires) dans la liste des champs pour l'autre table.

Remarque Avec une jointure interne, Microsoft Query sélectionne les enregistrements des deux tables ou exécute la requête uniquement lorsque les valeurs des champs joints sont identiques. Vous pouvez également créer une jointure externe qui récupère tous les enregistrements d'une table et tout enregistrement lié provenant d'une autre table.


Créer une jointure réflexive

Exécutez cette procédure pour associer les informations de deux copies d'une table — par exemple, si une table d'informations sur les employés contient l'identificateur d'employé du responsable de chaque employé et que vous souhaitez associer le numéro d'identificateur au nom du responsable. Cette procédure crée un type de requête appelé jointure réflexive. Obtenir des informations sur les jointures réflexives.

  1. Créez une requête dans Microsoft Query, puis ajoutez la table à joindre à la requête.
  2. Ajoutez la même table à la requête une deuxième fois.
  3. Lorsque le système vous demande si la table figure déjà dans la requête, cliquez sur OK.
  4. Si Microsoft Query joint automatiquement les deux tables, double-cliquez sur la ligne de jointure, cliquez sur Supprimer, puis sur Fermer.
  5. Créez une jointure interne entre les deux tables. Par exemple, si le champ Manager utilise l'identificateur d'employé pour identifier les responsables, vous pouvez joindre le champ Manager de la première table au champ ID Employé de la seconde.
  6. Ajoutez les champs souhaités à votre requête. Par exemple, vous pouvez ajouter les champs Nom Employé et Manager à la première table, puis le champ Nom Employé à la seconde pour afficher le nom du responsable de chaque employé.


Opérateurs disponibles dans des jointures

Vous pouvez utiliser les opérateurs suivants dans les jointures.

Opérateur | Description
= (Égal à) | Sélectionne les enregistrements qui contiennent des valeurs égales dans les champs joints.
<> (Différent de) | Sélectionne les enregistrements qui contiennent des valeurs différentes dans les champs joints.
> (Supérieur à) | Sélectionne les enregistrements de la table de gauche qui contiennent des valeurs supérieures aux valeurs des enregistrements de la table de droite dans les champs joints.
>= (Supérieur ou égal à) | Sélectionne les enregistrements de la table de gauche qui contiennent des valeurs supérieures ou égales aux valeurs des enregistrements de la table de droite dans les champs joints.
< (Inférieur à) | Sélectionne les enregistrements de la table de gauche qui contiennent des valeurs inférieures aux valeurs des enregistrements de la table droite dans les champs joints.
<= (Inférieur ou égal à) | Sélectionne les enregistrements de la table de gauche qui contiennent des valeurs inférieures ou égales aux valeurs des enregistrements de la table de droite dans les champs joints.


Supprimer une jointure

Si votre requête contient une jointure interne ou une jointure externe, mais ne récupère pas les enregistrements souhaités, vous pouvez supprimer la jointure.

  1. Dans le volet des tables, cliquez sur la ligne de jointure que vous voulez supprimer.
  2. Appuyez sur SUPPR.

Remarques

  • Quand vous supprimerez une jointure, les enregistrements du jeu de résultats de la requête seront modifiés. Suivant le type de jointure que vous supprimez, les enregistrements peuvent être ajoutés ou supprimés du jeu de résultats.
  • La suppression d'une jointure d'une requête affecte seulement cette requête. Par exemple, si Microsoft Query crée automatiquement une jointure interne entre deux tables dans votre requête et que vous supprimez cette jointure interne, Microsoft Query recréera automatiquement une jointure interne entre les deux tables si vous les utilisez dans une autre requête.


Utilisation des critères

Cette rubrique fournit des informations sur les sujets suivants :

Description des critères

Réponse à une condition unique

Réponse à plusieurs conditions

Recherche d'enregistrements similaires

Spécification d'une plage de valeurs

Utilisation d'un calcul

Exclusion d'enregistrements spécifiques

Recherche d'enregistrements incomplets

Description des critères

Les critères sont des conditions que vous définissez pour rechercher des enregistrements spécifiques dans une base de données ou une liste. Grâce aux critères, vous limitez le nombre des enregistrements (ou lignes) inclus dans le jeu de résultats de la requête. Par exemple, le critère PrixUnitaire > 30 sélectionne les enregistrements dont la valeur dans le champ PrixUnitaire est supérieur à 30. Vous pouvez ajouter des critères dans le volet des critères de Microsoft Query en les entrant directement dans le volet, ou en cliquant sur Ajouter des critères dans le menu Critères. Les champs que vous utilisez pour définir des critères n'ont pas besoin d'être inclus dans le jeu de résultats.

Volet des critères

Il est possible que votre requête contienne plusieurs tables avec des noms de champs semblables. C'est pourquoi vous devez vérifier que vous utilisez le champ à partir de la table appropriée. Par exemple, si vous souhaitez rechercher tous les fournisseurs d'un pays donné, sélectionnez le champ Pays de la table Fournisseur et non de la table Client.

Informations complémentaires

Spécifier des enregistrements à récupérer à l'aide de critères

Retour au début

Réponse à une condition unique

Vous pouvez rechercher tous les enregistrements dont les valeurs remplissent une condition unique, comme un pays ou un produit spécifique. L'exemple suivant montre un critère qui récupère tous les enregistrements dont le champ Pays contient Suède.

Exemple de critère simple

Pour définir un critère simple, sélectionnez le nom du champ dans la zone Champ, puis tapez la valeur que vous souhaitez rechercher dans la zone Valeur.

Informations complémentaires

Exemples d'expressions utilisant des opérateurs logiques

Retour au début

Réponse à plusieurs conditions

Remplir des conditions dans deux champs ou plus Vous pouvez rechercher tous les enregistrements dont les valeurs répondent à une condition dans un champ et à une autre condition dans un autre champ. Par exemple, vous pouvez rechercher tous les enregistrements correspondant aux commandes passées aux États-Unis dans l'état de Washington (WA). Pour sélectionner ces enregistrements, tapez deux séries de critères dans le volet des critères. Pour définir plusieurs conditions où toutes les conditions sont vraies, créez une condition ET.

Critère remplissant une condition ET

Pour rechercher les enregistrements qui remplissent deux conditions ou plus, spécifiez un champ pour chaque condition.

Remplir plusieurs conditions dans le même champ Vous pouvez rechercher tous les enregistrements dont les valeurs remplissent plusieurs conditions dans le même champ. Par exemple, vous pouvez rechercher tous les enregistrements correspondant aux clients se trouvant aux États-Unis et au Mexique. Pour sélectionner ces enregistrements, tapez deux séries de critères dans le volet des critères. Pour définir plusieurs conditions où l'une des conditions est vraie, créez une condition OU. Dans une condition OU, seule une condition sur deux ou plus doit être vraie.

Critère remplissant une condition OU

Le critère ci-dessus recherche tous les clients qui résident au Mexique ou aux États-Unis.

Remarque Vous pouvez également utiliser l'opérateur OU à l'intérieur d'une valeur de critère. Par exemple, au lieu de taper Mexique dans la zone OU, vous pouvez taper États-Unis ou Mexique dans la zone Valeur.

Informations complémentaires

Exemples d'expressions utilisant des opérateurs logiques

Retour au début

Recherche d'enregistrements similaires

Vous pouvez rechercher des enregistrements dont les valeurs d'un champ sont identiques, tels que les numéros de téléphone dont l'indicatif national ou régional est identique. Par exemple, vous pouvez rechercher tous les clients dont le numéro de téléphone commence par l'indicatif régional (171) ou les indicatifs nationaux (1) et (11).

Critère utilisant l'opérateur COMME

Pour utiliser l'opérateur COMME, tapez le mot COMME, puis tapez la valeur souhaitée à l'intérieur de guillemets simples.

Remarque Le signe pourcent (%) de l'exemple ci-dessus est un caractère générique qui représente tout nombre de caractères. Vous pouvez utiliser un trait de soulignement (_) lorsque vous souhaitez représenter un caractère unique. Les caractères génériques que vous pouvez utiliser varient en fonction de votre source de données. Consultez la documentation du pilote de votre source de données pour plus d'informations sur les caractères génériques pris en charge par le pilote.

Informations complémentaires

Exemples d'expressions utilisant d'autres types d'opérateurs

Retour au début

Spécification d'une plage de valeurs

Vous pouvez rechercher tous les enregistrements qui se trouvent à l'intérieur d'une certaine plage de valeurs ou de dates. Par exemple, vous pouvez récupérer tous les enregistrements effectués entre le 1er novembre 1998 et le 31 décembre 1998. Pour définir deux conditions ou plus à remplir, créez une condition ET. Définissez une condition ET pour préciser une plage de valeurs.

Exemple de plage comportant deux critères

Condition ET utilisant deux occurrences du même champ dans le volet des critères.

Plage incluant l'opérateur ET

Condition ET dont les limites inférieures et supérieures sont séparées par l'opérateur ET.

Remarque Lorsque vous entrez une date dans le volet des critères, Query la convertit dans un format qu'il comprend. Par exemple, lorsque vous entrez le critère >31/10/1998, Query le convertit en >#31/10/98#.

Informations complémentaires

Exemples d'expressions utilisant des opérateurs de comparaison

Retour au début

Utilisation d'un calcul

Il est possible que vous ayez besoin de rechercher des enregistrements qui correspondent au résultat d'un calcul. Par exemple, tous les enregistrements dont le total de la commande est supérieur à un montant basé sur le champ prix multiplié par le champ quantité.

Exemple de critère calculé

Pour rechercher tous les enregistrements dont le total des commandes s'élève à plus de 3000 F, créez une formule afin de calculer le total de la commande, puis définissez le critère.

Informations complémentaires

Exemples d'expressions utilisant des opérateurs arithmétiques

Retour au début

Exclusion d'enregistrements spécifiques

Plutôt que de rechercher des enregistrements qui correspondent à une valeur déterminée, vous pouvez rechercher des enregistrements qui ne correspondent pas à une valeur. Par exemple, vous pouvez utiliser l'opérateur NON pour rechercher tous les enregistrements correspondant aux fournisseurs situés en dehors des États-Unis.

Critère utilisant l'opérateur NON

Utilisez l'opérateur Non pour exclure des enregistrements.

Informations complémentaires

Exemples d'expressions utilisant des opérateurs logiques

Retour au début

Recherche d'enregistrements incomplets

Vous pouvez rechercher des enregistrements qui contiennent des valeurs manquantes ou incomplètes. Par exemple, vous pouvez utiliser l'opérateur EST NUL pour rechercher tous les enregistrements correspondant aux employés dont le nom du superviseur est incomplet.

Critère utilisant l'opérateur EST NUL

Utilisez l'opérateur EST NUL pour rechercher les enregistrements qui comportent des champs vides.

Informations complémentaires

Exemples d'expressions utilisant d'autres types d'opérateurs

Retour au début


Limiter les enregistrements récupérés à l'aide de critères

Vous pouvez récupérer des enregistrements spécifiques à l'aide de critères. Microsoft Query utilise vos critères pour récupérer les enregistrements souhaités, puis les affiche dans le jeu de résultats. Pour limiter le nombre des enregistrements récupérés, vous pouvez sélectionner une valeur dans le jeu de résultats, puis rechercher d'autres enregistrements qui correspondent à cette valeur. Vous pouvez également créer des critères spécifiques dans le volet Critères, puis récupérer les enregistrements qui correspondent à ce critère uniquement.

Que voulez-vous faire ?

Utiliser des critères

Rechercher des enregistrements correspondant à une certaine valeur

Spécifier des enregistrements à récupérer à l'aide de critères

Voir des exemples d'expressions pouvant être utilisées comme critères


Spécifier les enregistrements à récupérer à l'aide de critères

  1. Cliquez sur le bouton Afficher ou masquer les critères Image du bouton.

    Microsoft Query affiche le volet des critères.

  2. Dans le volet des critères, cliquez sur la première cellule de la ligne Champ, puis cliquez sur le champ auquel vous souhaitez appliquer des critères.

    Si votre requête utilise plusieurs tables comportant des noms de champs identiques, vérifiez que vous cliquez sur le champ souhaité dans la bonne table.

  3. Sur la ligne Valeur, cliquez sur la cellule située juste en dessous du champ sélectionné dans la ligne Champ.
  4. Tapez les critères que vous souhaitez que Microsoft Query utilise pour sélectionner les enregistrements, puis appuyez sur ENTRÉE.

    Procédure

  5. Si vous ne l'avez pas encore fait, ajoutez les champs que vous souhaitez voir apparaître dans le jeu de résultats.

    Procédure

    Pour afficher des enregistrements provenant de tables différentes, vérifiez que vous avez ajouté ces tables dans le volet des tables de votre requête. Pour plus d'informations sur l'ajout de tables, cliquez sur Image du bouton .

Remarques

  • Vous pouvez limiter votre jeu de résultats davantage en ajoutant des critères dans le volet des critères. Vous pouvez, par exemple, rechercher tous les enregistrements correspondant aux fournisseurs de produits laitiers et qui sont originaires de Norvège ou d'Italie. Pour sélectionner ces enregistrements, tapez deux séries de critères dans le volet des critères. Cliquez d'abord sur Pays dans la zone Champ, puis tapez Norvège Ou Italie dans la zone Valeur. Cliquez ensuite sur Catégorie dans la zone Champ suivante, puis tapez =Produits laitiers dans la zone Valeur correspondante.
  • Si la valeur que vous souhaitez utiliser comme critère apparaît déjà dans le jeu de résultats, vous pouvez la copier dans le volet des critères. Dans le jeu de résultats, cliquez sur la valeur que vous souhaitez copier, dans le menu Edition, cliquez sur Copier, puis sur la cellule de la ligne Valeur où vous souhaitez coller la valeur. Enfin, dans le menu Edition, cliquez sur Coller.
  • Pour éviter une attente trop longue lors de la récupération des données de chaque champ, vous pouvez attendre d'avoir ajouté tous les champs à votre jeu de résultats avant de récupérer les données. Pour attendre avant de récupérer les données, vérifiez que le bouton Requête automatique Image du bouton n'est pas enfoncé. Lorsque vous êtes prêt à exécuter votre requête, cliquez sur le bouton Requête immédiate Image du bouton.
  • Vous pouvez interrompre une requête pour laquelle la récupération des données est trop longue en appuyant sur ÉCHAP.


Rechercher des enregistrements correspondant à une certaine valeur

  1. Vérifiez que le bouton Requête automatique Image du bouton est enfoncé.
  2. Ajoutez le champ pour lequel vous souhaitez spécifier des critères dans le volet des données.

    Procédure

    Si, par exemple, vous souhaitez rechercher les enregistrements pour lesquels la France est spécifiée dans le champ Pays, ajoutez le champ Pays dans le volet des données.

  3. Dans le jeu de résultats, cliquez sur une cellule contenant la valeur que vous souhaitez utiliser comme critère.
  4. Cliquez sur le bouton Critère Est égal à Image du bouton.


Restaurer la totalité du jeu de résultats en supprimant des critères

Si votre requête contient un grand nombre d'enregistrements, vous pouvez gagner du temps en n'effectuant l'actualisation du jeu de résultats que lorsque vous avez terminé de supprimer tous les critères. Pour différer l'actualisation du jeu de résultats, vérifiez que le bouton Requête automatique Image du bouton n'est pas enfoncé.

  1. Dans le volet des critères, cliquez sur l'en-tête de la colonne contenant les critères que vous souhaitez supprimer.
  2. Appuyez sur SUPPR.

    Répétez les étapes 1 et 2 pour chaque série de critères que vous souhaitez supprimer.

    Pour supprimer tous les critères en une seule fois, cliquez sur Supprimer tous les critères dans le menu Critères.

Remarque Si le bouton Requête automatique n'est pas enfoncé, vous devez cliquer sur Requête immédiate Image du bouton pour rétablir l'intégralité du jeu de résultats.


À propos des expressions

Une expression est un calcul qui associe des opérateurs, des fonctions, des noms de champs, et des constantes.

Une expression peut être utilisée comme critère de sélection pour des enregistrements. Pour utiliser une expression dans le volet Critères, vous devez sélectionner le champ contenant les valeurs à évaluer dans la zone Champ, puis taper l'opérateur et la valeur souhaités dans la zone Valeur. Lorsque vous sélectionnez un champ de critère, vérifiez que le champ utilisé se trouve dans la table souhaitée.

Expressions utilisant des opérateurs arithmétiques Pour récupérer des enregistrements en fonction du résultat d'un calcul, créez une expression qui utilise les opérateurs arithmétiques de l'addition, de la soustraction, de la multiplication ou de la division. Voir des exemples d'expressions utilisant des opérateurs arithmétiques.

Expressions utilisant des opérateurs de comparaison Les opérateurs de comparaison comparent deux valeurs. Par exemple, pour rechercher toutes les commandes où le nombre d'unités vendues est supérieur à 1 000, entrez le critère >1000 dans le champ Quantité. Voir des exemples d'expressions utilisant des opérateurs de comparaison.

Expressions utilisant des opérateurs logiques Les opérateurs logiques, comme les opérateurs de comparaison, comparent des valeurs. Par exemple, pour récupérer tous les enregistrements correspondant aux ventes effectuées en dehors de la France, entrez le critère Pas France dans le champ Pays. Voir des exemples d'expressions utilisant des opérateurs logiques.

Expressions utilisant d'autres types d'opérateurs Vous pouvez utiliser des opérateurs supplémentaires pour rechercher des valeurs égales à l'une des valeurs spécifiées, déterminer si un enregistrement doit ou non contenir une certaine valeur dans un champ donné, ou rechercher des enregistrements à l'aide d'un caractère générique. Voir des exemples d'expressions utilisant d'autres types d'opérateurs.


Exemples d'expressions

Une expression est un calcul utilisant une combinaison d'opérateurs, de fonctions, de noms de champs et de constantes. Une expression peut être utilisée comme critère de sélection des enregistrements. Pour utiliser une expression dans le volet des critères, sélectionnez le champ dans la zone Champ contenant les valeurs que vous souhaitez évaluer, puis entrez un opérateur et une valeur dans la zone Valeur.

Quel exemple voulez-vous voir ?

Expressions utilisant des opérateurs arithmétiques

Expressions utilisant des opérateurs de comparaison

Expressions utilisant des opérateurs logiques

Expressions utilisant d'autres types d'opérateurs

Vous hésitez entre plusieurs rubriques ?


Exemples d'expressions utilisant des opérateurs arithmétiques

Les opérateurs arithmétiques permettent d'effectuer des opérations mathématiques de base, telles que des additions, des soustractions, des multiplications et des divisions, et génèrent des résultats numériques. Vous pouvez utiliser des opérateurs arithmétiques dans une expression dans le volet des critères ou dans un champ calculé.

Opérateur arithmétique | Signification | Exemple | Syntaxe
+ (signe plus) | Addition | Montant total de la facture d'un client | Mont_Commande+Frêt
– (signe moins) | Soustraction | Montant total d'une facture moins remise éventuelle | Mont_Commande-Remise
* (astérisque) | Multiplication | Montant total de toutes les factures pour un produit donné | Unité_Prix*Quantité
/ (barre de fraction) | Division | Prix à l'unité | Mont_Commande/Quantité


Exemples d'expressions utilisant des opérateurs de comparaison

Les opérateurs de comparaison sont utilisés dans des expressions servant de critères pour sélectionner des enregistrements et limiter un jeu de résultats.

Opérateur de comparaison | Signification | Exemple | Dans la zone Champ, cliquez sur | Dans la zone Valeur, tapez
= (signe égal) | Égal à | Recherche les enregistrements correspondant aux clients se trouvant en Allemagne | Pays | =Allemagne
<> (signe différent) | Différent de | Recherche les enregistrements correspondant aux fournisseurs ne se trouvant pas aux Etats-Unis | Pays | <>USA
> (signe supérieur à) | Supérieur à | Recherche les enregistrements correspondant aux commandes passées après une date donnée | Date_Commande | >30/06/2000
< (signe inférieur à) | Inférieur à | Recherche les enregistrements correspondant aux commandes passées avant une certaine date | Date_Commande | <30/06/2000
>= (signe supérieur ou égal à) | Supérieur ou égal à | Recherche les enregistrements correspondant aux commandes passées à une certaine date ou après | Date_Commande | >=30/06/2000
<= (signe inférieur ou égal à) | Inférieur ou égal à | Recherche les enregistrements correspondant aux commandes passées à une certaine date ou avant | Date_Commande | <=30/06/2000


Exemples d'expressions utilisant des opérateurs logiques

Les opérateurs logiques permettent de comparer deux valeurs.

Opérateur logique | Signification | Exemple | Dans la zone Champ, cliquez sur | Dans la zone Valeur, tapez
Et | Les enregistrements du jeu de résultats doivent correspondre aux deux valeurs spécifiées. | Recherche les enregistrements correspondant aux commandes passées entre deux dates spécifiées | Date_Commande | >05/06/2000 Et <23/06/2000
Ou | Les enregistrements du jeu de résultats doivent correspondre à l'un ou l'autre des critères spécifiés. | Recherche les enregistrements correspondant aux fournisseurs se trouvant dans l'un ou l'autre des pays spécifiés | Pays | USA Ou Brésil
Pas | Les enregistrements du jeu de résultats ne doivent pas remplir ce critère. | Recherche les enregistrements correspondant aux fournisseurs ne se trouvant pas dans le pays spécifié | Pays | Pas Canada


Exemples d'expressions utilisant d'autres types d'opérateurs

Le tableau suivant répertorie les opérateurs que vous pouvez utiliser pour sélectionner une plage de valeurs, rechercher des valeurs égales à l'une des valeurs spécifiées, déterminer si un enregistrement doit ou non contenir une certaine valeur dans un champ donné, ou rechercher des enregistrements à l'aide d'un caractère générique.

Opérateur | Signification | Exemple | Dans la zone Champ, cliquez sur | Dans la zone Valeur, tapez
Entre | Affiche une plage de valeurs comprises entre les deux valeurs spécifiées | Recherche les enregistrements correspondant aux commandes dont le montant est compris entre 1 000 et 3 000 F | Mont_Commande | Entre 1000 Et 3000
Dans | Détermine si une valeur est égale à l'une des valeurs d'une liste | Recherche les enregistrements correspondant aux clients situés à Portland, Seattle et Denver | Ville | Dans('Portland', 'Seattle', 'Denver')
Est Nul | Détermine si un enregistrement n'a pas d'entrée dans le champ spécifié | Recherche les enregistrements correspondant aux employés qui n'ont pas d'entrée dans le champ indiquant qui est leur responsable | Rend compte à | Est Nul
Est Pas Nul | Détermine si un enregistrement a une valeur dans le champ spécifié | Recherche les enregistrements correspondant aux employés qui ont une entrée dans le champ indiquant qui est leur responsable | Rend compte à | Est Pas Nul
Comme | Utilise Comme et le caractère générique % pour comparer des valeurs | Recherche les enregistrements correspondant aux employés dont le nom commence par les lettres "Du", comme Durant et Dupont | Nom | Comme 'Du%'


Créer un champ calculé

Vous pouvez afficher les résultats d'un calcul que vous spécifiez en créant un nouveau champ appelé champ calculé. Vous pouvez créer un champ calculé en tapant votre propre expression, c'est-à-dire un calcul qui utilise une combinaison d'opérateurs, de fonctions, de noms de champs et de constantes. Vous pouvez également utiliser une fonction prédéfinie pour calculer les totaux d'un champ.

Que voulez-vous faire ?

Créer un champ calculé à l'aide d'une expression

Créer un champ calculé à l'aide d'une fonction prédéfinie


Créer un champ calculé à l'aide d'une expression

  1. Dans le volet des données, cliquez sur un en-tête de colonne vide.
  2. Tapez l'expression pour le calcul, puis appuyez sur ENTRÉE. Ne faites pas précéder l'expression du signe égal (=).

    Si, par exemple, les employés reçoivent une commission égale à 15 pour cent de leurs ventes totales, vous pouvez calculer la commission de chacun des employés en ajoutant les ventes de chacun d'entre eux, puis en multipliant le total par 0,15.

    Pour afficher des exemples d'expressions utilisant des opérateurs arithmétiques, cliquez sur Image du bouton .


Créer un champ calculé à l'aide d'une fonction

  1. Ajoutez un champ contenant les valeurs dont vous souhaitez calculer le total.

    Procédure

  2. Cliquez n'importe où dans le champ dont vous souhaitez calculer le total, puis sur Totaux successifs Image du bouton.
  3. Continuez de cliquer sur Totaux successifs jusqu'à ce que Microsoft Query affiche le type de total souhaité.

    Chaque fois que vous cliquez sur Totaux successifs, Microsoft Query calcule et affiche un autre type de total (la fonction utilisée est indiquée dans l'en-tête de colonne). Pour afficher une description des fonctions que vous pouvez utiliser pour créer des totaux dans un champ calculé, cliquez sur Image du bouton .

  4. Après avoir sélectionné la fonction qui génère le type de total souhaité, cliquez sur le bouton Requête immédiate Image du bouton pour afficher les résultats du champ calculé.

Remarques

  • Pour supprimer un calcul d'un champ, cliquez sur Totaux successifs jusqu'à ce que le nom de champ initial soit de nouveau affiché dans l'en-tête de colonne.
  • Si votre requête contient de nombreux enregistrements, vous pouvez gagner du temps en différant l'affichage des résultats du champ calculé jusqu'à ce que vous ayez sélectionné la fonction souhaitée. Vérifiez que le bouton Requête automatique Image du bouton n'est pas enfoncé.


Fonctions pouvant être utilisées dans un champ calculé

Une fonction renvoie une valeur en fonction des résultats d'un calcul ou d'une autre opération. Par exemple, la fonction SOMME renvoie la somme de deux ou plusieurs valeurs. Microsoft Query prend en charge les fonctions répertoriées ci-après. Les fonctions disponibles pour une source de données varient en fonction du pilote ODBC de la source de données. Pour afficher les fonctions disponibles pour votre source de données, cliquez sur un champ numérique, puis sur Totaux successifs Image du bouton.

Pour renvoyer cette valeur | Utilisez
La moyenne d'une série de valeurs dans un champ | MOYENNE
Le nombre total d'enregistrements | NB
La valeur maximale d'une série de valeurs dans un champ | MAX
La valeur minimale d'une série de valeurs dans un champ | MIN
La somme d'une série de valeurs dans un champ | SOMME


Modifier la présentation d'un jeu de résultats

Lorsque vous insérez des champs ou modifiez l'ordre des champs, les modifications de mise en page sont conservées tant que vous travaillez dans Microsoft Query et lorsque vous renvoyez le jeu de résultats dans Microsoft Excel.

Que voulez-vous faire ?

Modifier l'ordre des champs dans un jeu de résultats

Insérer un champ dans un jeu de résultats


Mettre en forme des données dans Microsoft Query

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Microsoft Query enregistre les modifications lorsque vous enregistrez votre requête. Si vous formatez des données dans Query, le formatage n'est pas affiché quand vous renvoyez le jeu de résultats à Microsoft Excel. Si vous modifiez l'ordre des champs inclus dans le jeu de résultats, ces modifications sont conservées lorsque vous renvoyez des données à Excel.

Que voulez-vous faire ?

Modifier un en-tête de colonne de champ pour le rendre plus explicite

Modifier la largeur d'une colonne ou la hauteur de lignes

Modifier la police, le style ou la taille du texte dans un jeu de résultats

Masquer ou afficher un champ dans un jeu de résultats

Modifier la présentation d'un jeu de résultats


Accéder à un enregistrement spécifique du jeu de résultats

  1. Dans le menu Enregistrement, cliquez sur Atteindre.
  2. Tapez le numéro de l'enregistrement auquel vous voulez accéder.


Trier des enregistrements dans une requête

  1. Vérifiez que le bouton Requête automatique Image du bouton est enfoncé.
  2. Dans le jeu de résultats, cliquez sur le champ à trier.
  3. Pour trier les enregistrements dans l'ordre de tri croissant, cliquez sur le bouton Trier dans l'ordre croissant Image du bouton.

    Pour trier les enregistrements dans l'ordre de tri décroissant, cliquez sur le bouton Trier dans l'ordre décroissant Image du bouton.

Remarques

  • Pour trier plusieurs colonnes simultanément, disposez les colonnes de gauche à droite dans le volet des données dans l'ordre dans lequel vous souhaitez les trier. Appuyez sur la touche MAJ et cliquez sur les en-têtes de colonnes pour sélectionner les colonnes à inclure dans le tri, puis cliquez sur Trier dans l'ordre croissant ou Trier dans l'ordre décroissant.
  • Pour restaurer l'ordre initial des enregistrements, cliquez sur Copies assemblées dans le menu Enregistrements. Dans la zone Tris dans la requête, cliquez sur le champ pour lequel vous souhaitez supprimer de l'ordre de tri, puis cliquez sur Supprimer.
  • Si vous modifiez l'ordre des colonnes dans le jeu de résultats après avoir trié les enregistrements, l'ordre de tri n'est pas modifié.


Afficher d'autres champs dans une requête

  1. Dans le menu Format, cliquez sur Afficher une colonne.
  2. Pour empêcher provisoirement une colonne d'apparaître dans le volet des données, cliquez sur le nom de la colonne, puis sur Masquer.

    Pour afficher à nouveau la colonne, cliquez sur le nom de la colonne, puis sur Affichage.

Remarque Les champs masqués sont inclus lorsque vous renvoyez le jeu de résultats vers Microsoft Excel. Si vous ne souhaitez pas que les champs masqués soient renvoyés vers Microsoft Excel, supprimez les champs du volet des données avant de renvoyer le jeu de résultats vers Microsoft Excel.


Modification des données d'une base de données faisant l'objet d'une requête

Modification d'une base de données dans laquelle vous avez récupéré des données Dans certains cas, vous pouvez utiliser Microsoft Query pour modifier des données dans une base de données externe ou pour supprimer des données dans une base de données externe. Lorsque vous modifiez les résultats d'une requête, Microsoft Query modifie également les données de la table sous-jacente utilisée pour la requête.

Conditions empêchant la modification d'une base de données Vous ne pouvez pas modifier les données d'une base de données faisant l'objet d'une requête dans les cas suivants :

  • La source de données est protégée contre les modifications et ne permet pas les modifications.
  • La requête contient plusieurs tables.
  • La requête contient des totaux ou des expressions personnalisées.
  • Le champ que vous essayez de modifier est verrouillé ou désactivé, ou bien il se trouve dans un enregistrement verrouillé.
  • Le type de données que vous essayez d'entrer n'est pas un type valide pour la base de données. Selon la base de données que vous essayez de modifier, vous devrez peut-être entrer une valeur spécifique dans un champ.
  • Votre administrateur a rendu les fonctionnalités de modification indisponibles pour la base de données.


Apporter des modifications aux données d'une base de données faisant l'objet d'une requête

Que voulez-vous faire ?

Modifier une base de données faisant l'objet d'une requête

Modifier des données dans une base de données faisant l'objet d'une requête

Supprimer des données dans une base de données faisant l'objet d'une requête

Annuler les modifications apportées aux données d'une base de données faisant l'objet d'une requête


Utiliser DDE (Dynamic Data Exchange) avec Microsoft Query

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Microsoft Query prend en charge DDE (Dynamic Data Exchange, échange dynamique de données), qui est un moyen de communication permettant à deux programmes d'échanger des données entre eux. Vous pouvez utiliser des méthodes DDE dans Visual Basic pour Applications (VBA) pour communiquer et échanger des données entre Microsoft Query et un autre programme, tel que Microsoft Excel.

En savoir plus sur l'utilisation de DDE

Ouvrir un canal DDE

Exécuter des commandes DDE

Connaître les commandes DDE disponibles

Demander des états et autres informations

Extraire des données

Sortir de Microsoft Query à partir de DDE

Fermer un canal DDE

Utiliser Microsoft Query avec d'autres programmes


Commandes DDE

Cliquez sur une commande ou une requête pour afficher les informations correspondantes.

Activate

AddParameters

AllowEdit

BuildODBC

BuildSQL

Close

Command

EnableParameters

EnableTensor

Exit

Fetch et Fetch.Advise

Fetch.Unadvise

Logoff

Logon

LogonNow

ODBCLogon

Open

ParameterNames2

QueryNow

QueryType

SaveAs

SetParameterName

SetQueryName

SetQueryType

SetWindowState

UserControl

UserControl2

ViewPane


Résolution des problèmes liés à Microsoft Query

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Création et utilisation de sources de données

Impossible de créer une nouvelle source de données.

Impossible de trouver ou de supprimer une source de données.

Pourquoi y a-t-il un astérisque à côté de ma source de données ?

Un pilote ODBC que j'ai déjà utilisé ne fonctionne plus.

Création de requêtes

Impossible de trouver la table souhaitée.

Impossible de créer les jointures souhaitées.

Mes jointures ne me permettent pas d'obtenir les enregistrements souhaités.

Impossible de modifier dans Microsoft Query les types de paramètres de ma procédure SQL.

Impossible de modifier ma requête.

Récupération de données

Un message indique que le chemin d'accès à ma base de données n'est pas valide.

Microsoft Query ne dispose pas d'assez de temps pour se connecter à ma base de données.

Impossible d'accéder à partir de Microsoft Query aux données d'une liste Microsoft Excel.

Microsoft Query continue d'utiliser des ressources de connexion alors que je ne travaille pas avec une base de données.

Microsoft Query ne renvoie pas tous les enregistrements disponibles.

Utilisation de Microsoft Query

Impossible de continuer à travailler dans Microsoft Query.

Les modifications et la mise en forme de la requête disparaissent lors de l'exécution suivante.

Impossible d'imprimer l'ensemble de résultats dans Microsoft Query.

Impossible de créer des étiquettes de publipostage dans Microsoft Query.

Impossible d'enregistrer l'ensemble de résultats sous la forme d'une table dans ma base de données.

Impossible d'ajouter, de copier ou de déplacer un enregistrement dans ma base de données.


Résolution des problèmes liés aux requêtes et aux cubes OLAP

La fonction de synthèse que je souhaite pour mes données de cube n'est pas disponible.

Le format des champs de date ou d'heure est incorrect.

Lorsque j'essaie d'enregistrer un fichier de cube hors connexion, je manque d'espace disque.

Impossible d'ajouter des champs à mon cube OLAP.

Impossible de modifier mon cube OLAP.

Lors de la modification d'un cube OLAP, un message m'indique que des données ont été perdues.

Un message m'indique que l'Assistant Cube OLAP ne parvient pas à ouvrir mon fichier .oqy.


Prise en charge du passage à l'an 2000 par Microsoft Query

L'utilisation de la notation à quatre chiffres est recommandée pour les années Pour veiller à ce que les valeurs d'année soient recherchées et interprétées correctement, assurez-vous que vos bases de données externes enregistrent les valeurs d'années en utilisant quatre chiffres (2001 au lieu de 01) chaque fois que c'est possible.

Query et Microsoft Excel interprètent les années à deux chiffres de manière cohérente. Query et Excel interprètent les années à deux chiffres de la même manière. Lorsque vous consultez des données contenant des années à deux chiffres dans Query et que vous renvoyez ensuite ces données dans Excel, ces dates sont les mêmes dans les deux programmes.

Interprétation des années à deux chiffres par Query Lorsque Query extrait une valeur d'année à deux chiffres d'une base de données externe, il interprète l'année comme suit :

  • Valeurs d'année de 00 à 29 Les valeurs d'année à deux chiffres de 00 à 29 sont interprétées comme les années 2000 à 2029. Par exemple, si Query recherche la date 5/28/19 dans une base de données externe, il interprète la date comme le 28 mai 2019.
  • Valeurs d'année de 30 à 99 Les valeurs d'année à deux chiffres de 30 à 99 sont interprétées comme les années 1930 à 1999. Par exemple, si Query recherche la date 5/28/98 dans une base de données externe, il interprète la date comme le 28 mai 1998.

Les administrateurs peuvent modifier l'interprétation des années. Votre administrateur système peut personnaliser Microsoft Office de telle sorte que les dates soient interprétées différemment. Par exemple, il peut changer l'année à partir de laquelle une date est considérée comme étant une date future (par défaut, 29). Pour déterminer si votre système utilise une interprétation personnalisée des dates, consultez votre administrateur système.


Impossible d'exécuter la requête. Désirez-vous afficher l'interrogation SQL ?

Microsoft Query ne peut pas exécuter l'instruction SQL, car cette instruction SQL fait référence à un élément qui n'est pas valide actuellement. Par exemple, elle fait peut-être référence à une table qui n'existe plus. Pour afficher l'instruction SQL et effectuer les modifications nécessaires, cliquez sur OK.


La table <nom> est déjà dans la requête. Voulez-vous l'ajouter quand même ?

Vous avez essayé d'ajouter une table qui se trouve déjà dans le volet des tables.

  • Pour ajouter la table si vous souhaitez créer une jointure réflexive, cliquez sur OK.
  • Pour ne pas ajouter la table, cliquez sur Annuler.


Impossible de coller. Erreur dans le format des données.

Microsoft Query ne peut pas coller les données provenant du Presse-papiers, car la mémoire disponible est insuffisante.

Essayez de fermer les autres fenêtres de Microsoft Query ou les autres programmes. Si l'erreur se reproduit, redémarrez Microsoft Windows et réessayez de copier et coller les données.


Impossible d'enregistrer vers un fichier déjà ouvert.

Le fichier que vous souhaitez enregistrer est ouvert. Fermez le fichier avant d'essayer à nouveau de l'enregistrer.


L'autre application est occupée.

L'autre programme de la conversation DDE (Dynamic Data Exchange) est occupé ou ne peut effectuer une opération DDE. Attendez que l'autre programme soit disponible.


'GROUP' doit être suivi par 'BY'.

Votre instruction SQL inclut une clause GROUP au lieu d'une clause GROUP BY. BY est peut être mal orthographié ou manquant.


'ORDER' doit être suivi par 'BY'.

Votre instruction SQL inclut une clause ORDER au lieu d'une clause ORDER BY. BY est peut-être mal orthographié ou manquant.


Impossible d'ouvrir le Presse-papiers.

Le Presse-papiers ne répond pas, probablement parce qu'il est utilisé par un autre programme. Fermez ce programme, puis réessayez.


Impossible d'ouvrir le fichier <nom>.

Microsoft Query ne peut ouvrir ou lire le fichier que vous essayez d'ouvrir, ou ne peut enregistrer le fichier. Une erreur disque s'est peut-être produite, ou le fichier peut être corrompu.


Impossible de démarrer Microsoft Query. Essayez de nouveau.

Une erreur système s'est produite, ou il n'y a pas suffisamment de mémoire disponible pour démarrer Microsoft Query.

Redémarrez Microsoft Query ou fermez les autres programmes. Si l'erreur se reproduit, redémarrez Microsoft Windows et réessayez.


La colonne <nom> ne peut pas être utilisée avec l'opérateur <opérateur>.

Votre source de données ne permet pas l'utilisation de ce champ avec l'opérateur spécifié, car le type de données du champ ne peut pas être utilisé avec cet opérateur. Consultez la documentation de votre source de données afin de déterminer quels opérateurs peuvent être utilisés avec les champs de ce type de données.


La colonne <nom> ne peut pas être utilisée avec le critère.

Vous ne pouvez pas spécifier de critères dans une colonne (champ) avec ce type de données.


Aide non disponible. Mémoire insuffisante ou installation incorrecte de Microsoft Windows ou de Microsoft Query.

Pour libérer de la mémoire, essayez de fermer les fenêtres ou les autres programmes. Si nécessaire, réinstallez Microsoft Windows ou Microsoft Query.


Impossible de coller.

Le Presse-papiers ne répond plus. Il est possible qu'un autre programme l'utilise, que le format des données du Presse-papiers ne soit pas reconnu par Microsoft Query, ou qu'il n'y ait pas suffisamment de mémoire disponible pour coller les données.

Essayez de fermer les autres fenêtres de Microsoft Query ou les autres programmes. Si l'erreur se reproduit, redémarrez Microsoft Windows et réessayez de copier et coller les données.


Impossible de quitter Microsoft Query.

Microsoft Query is communicating with another program through Dynamic Data Exchange (DDE). Patientez jusqu'à la fin de l'opération DDE, puis quittez Microsoft Query.


Impossible d'afficher le critère.

Le critère que vous avez spécifié n'est pas valide.


Impossible d'ajouter l'expression <nom> à la liste des tris.

La source de données que vous utilisez ne vous permet pas d'effectuer une opération de tri dans un champ affichant les résultats d'une expression.


Impossible d'appliquer des agrégats aux tables.

Vous avez tapé un astérisque (*) pour l'option Champ au lieu de spécifier un champ spécifique sur lequel calculer un total. Supprimez l'astérisque ( *), puis entrez le nom du champ.


Impossible de spécifier * comme un champ. Pour ajouter tous les champs, vous devez glisser et déplacer * dans la grille donnée.

Vous avez tapé un astérisque (*) dans la cellule Champ du volet des critères. Pour définir des critères pour tous les champs de la requête, utilisez l'une des méthodes suivantes au lieu de l'astérisque :

  • Faites glisser l'astérisque * de la table vers le volet des critères.
  • Double-cliquez sur l'astérisque dans la table.
  • Ajoutez chaque champ individuellement.


La fonction <nom> ne peut pas être utilisée dans <nom de colonne>.

Vous avez sélectionné une fonction qui ne peut pas être calculée pour le type de donnée de ce champ. Par exemple, vous ne pouvez pas calculer la moyenne du champ SHIP_CNTRY si celui-ci contient du texte.


Format du Presse-papiers non supporté.

Les données du Presse-papiers ont un format que Microsoft Query ne reconnaît pas.


<nom de connexion> est utilisé par des requêtes. Désirez-vous fermer quand même ?

Une ou plusieurs requêtes utilisent la source de données que vous souhaitez supprimer.

  • Pour supprimer la source de données et fermer les requêtes, cliquez sur OK.
  • Pour conserver la source de données dans la liste et maintenir la requête ouverte, cliquez sur Annuler.


Souhaitez-vous supprimer <nombre> enregistrement(s) ?

Vous indiquez que vous voulez supprimer le nombre d'enregistrements spécifié.

Remarque Si le nombre d'enregistrements est supérieur au nombre spécifié, Microsoft Query a trouvé des doublons d'enregistrements dans les champs du volet des données. Pour éviter les doublons d'enregistrements, ajoutez tous les champs au volet des données avant de supprimer des enregistrements.

  • Pour supprimer les enregistrements, cliquez sur OK.
  • Pour qu'aucun enregistrement ne soit supprimé, cliquez sur Annuler.


<Nombre> enregistrements correspondent à la sélection. Voulez-vous les supprimer ?

Le volet des données ne comprenant pas de champ dont les valeurs identifient chaque enregistrement de manière exclusive, tel qu'un numéro de client ou un numéro de commande, le jeu de résultats contient d'autres enregistrements qui correspondent à celui que vous souhaitez supprimer. Si vous supprimez l'enregistrement sélectionné, Microsoft Query supprime également tous les enregistrements identiques.

Pour distinguer les enregistrements avant de commencer à modifier les données, veillez à ajouter tous les champs de la table sous-jacente ou à créer un index unique dans la table.


<Nombre> enregistrement(s) mis à jour.

Le volet des données contient d'autres enregistrements correspondant à l'enregistrement que vous avez mis à jour. En conséquence, Microsoft Query mettra automatiquement à jour les enregistrements correspondants en y effectuant des modifications identiques.

  • Pour éviter les doublons d'enregistrements dans le volet des données, ajoutez tous les champs au volet des données avant de modifier vos données.
  • Pour mettre à jour les enregistrements, cliquez sur OK.
  • Pour qu'aucun enregistrement ne soit mis à jour, cliquez sur Annuler.


Impossible de créer un fichier.

Microsoft Query ne peut pas créer le fichier de requête spécifié. Une erreur disque s'est peut-être produite, ou le fichier est peut-être corrompu.


La table <nom> a été créée avec succès.

Microsoft Query a créé la table définie avec la source de données sélectionnée.


La création d'un index unique a échoué. Désirez-vous en créer un vous-même ?

Microsoft Query ne peut pas créer un index unique pour cette table, même si le jeu de résultats que vous souhaitez enregistrer comme nouvelle table provient d'une table contenant un index unique.

  • Pour afficher la boîte de dialogue Créer un index afin de pouvoir créer un index unique pour la table, cliquez sur Oui.
  • Si vous ne souhaitez pas créer un index unique, cliquez sur Non.


La longueur spécifiée doit être supérieure à 0.

La longueur spécifiée dans la zone Longueur de la boîte de dialogue Définir une table doit être supérieure à 0 (zéro).


Activate, commande (DDE)

Active la fenêtre de requête spécifiée. Cette commande est utilisée pour changer de fenêtre active lorsque plusieurs fenêtres sont ouvertes. Elle n'est disponible que sur le canal système.

Syntaxe

Activate(queryname)

queryname Nom de la fenêtre de requête à activer

Exemple

Cet exemple montre comment exécuter deux requêtes, et créer ainsi deux fenêtres de requête. Après avoir exécuté la deuxième requête, l'exemple fait de la fenêtre créée par la première requête la fenêtre active.

DDEExecute chan, "[BuildSQL('Select * From Customers')]"
DDEExecute chan, "[QueryNow()]"
stQueryname1 = DDERequest(chan, "Query")
DDEExecute chan, "[BuildSQL('Select * From ORDERS')]"
DDEExecute chan, "[QueryNow()]"
stQueryName2 = DDERequest(chan, "Query")
DDEExecute chan, "[Activate('" & stQueryname1(1) & "')]"


AddParameters, commande (DDE)

Ajoute à la requête active un paramètre destiné à être utilisé par les rapports de tableaux croisés dynamiques.

Syntaxe

AddParameters(field1, field2, …)

field1, field2, … Noms des colonnes de la table qui doivent être ajoutés aux critères comme paramètres. Les noms des nouveaux paramètres sont définis comme noms des champs eux-mêmes. Si vous spécifiez un nom de champ indisponible dans la requête active, une erreur se produit.

Notes

La commande AddParameters peut être utilisée même lorsque la saisie des paramètres est désactivée dans Microsoft Query.

La chaîne SQL modifiée peut être renvoyée en appelant l'élément de requête ODBCSQLStatement.

Pour redéfinir les paramètres, vous devez redéfinir la totalité de la chaîne SQL.


AllowEdit, commande (DDE)

Détermine si des modifications sont autorisées dans une fenêtre de requête. Cette commande est disponible à la fois sur le canal système et sur le canal de requête. Elle équivaut à la commande Modification autorisée du menu Enregistrements.

Syntaxe 1

AllowEdit(allowedit, locked)

Syntaxe 2

Allow.Edit(allowedit, locked)

Les deux syntaxes sont équivalentes.

allowedit Détermine si les modifications sont autorisées dans la fenêtre de requête. Vous pouvez lui attribuer la valeur True ou False.

locked Détermine si la commande Modification autorisée du menu Enregistrements est désactivée lorsque la commande UserControl est activée. Vous pouvez lui attribuer la valeur True ou False.

Exemple

Cet exemple montre comment exécuter une instruction SQL créée précédemment. Il montre ensuite comment envoyer la commande AllowEdit et la commande UserControl à Microsoft Query afin de permettre à l'utilisateur de visualiser, sans les modifier, les données dans la source de données. (La commande de menu Modification autorisée est désactivée lorsque UserControl est activée.)

DDEExecute chan,"[BuildSQL(""" & sql & """)]")
DDEExecute chan,"[QueryNow()]")
DDEExecute chan,"[AllowEdit(False, True)]")
DDEExecute chan,"[UserControl(""&Return Data"", 3, False)]")


BuildODBC, commande (DDE)

Crée une chaîne de connexion de n'importe quelle longueur, segment par segment.

Syntaxe

BuildODBC([connectstring])

connectstring Segment d'une chaîne de connexion valide. Si vous attribuez la valeur 0 (zéro) à connectstring ou si vous ne spécifiez pas cet argument, la chaîne de connexion est effacée.


BuildSQL, commande (DDE)

Crée une instruction SQL, élément par élément, afin de créer une nouvelle requête sur le canal DDE. Cette commande n'est disponible que sur le canal système.

Syntaxe

BuildSQL[(sqltext)]

sqltext Instruction SQL valide. Si vous attribuez la valeur 0 (zéro) à sqltext ou si vous ne spécifiez pas cet argument, l'instruction SQL est effacée.

Notes

La commande BuildSQL s'avère utile pour créer de longues instructions SQL. Par exemple, si une instruction SQL s'avère trop longue à envoyer en une seule instruction, vous pouvez l'envoyer en plusieurs parties plus petites.

Après avoir créé une instruction SQL, vous pouvez l'exécuter à l'aide de la commande QueryNow.

Exemples

Cet exemple montre comment utiliser l'élément de requête QueryDefinition pour renvoyer l'instruction SQL pour une requête.

sql = DDERequest(chan,"QueryDefinition")

Cet exemple montre comment utiliser la commande BuildSQL pour envoyer de nouveau la chaîne SQL renvoyée avec une clause WHERE supplémentaire.

DDEExecute chan, "[BuildSQL(""" & sql & """)]"
DDEExecute chan, "[BuildSQL("WHERE Freight > 10")]"
DDEExecute chan, "[QueryNow()]


Close, commande (DDE)

Ferme la requête en cours. Cette commande est disponible à la fois sur le canal système et sur le canal de requête.

Syntaxe

Close( )


Fermer un canal DDE

Pour fermer un canal DDE, utilisez DDETerminate. Cette méthode a un seul argument, à savoir le numéro de canal du canal DDE à fermer. Toutes les requêtes qui sont ouvertes sur ce canal sont automatiquement fermées lorsque vous utilisez DDETerminate, et vous êtes déconnecté de toutes les sources de données connectées.

Une erreur est renvoyée si le numéro de canal que vous utilisez n'est pas valide.


Command, commande (DDE)

Envoie une commande Open vers Microsoft Query. Cette commande est fournie pour des programmes limitant la longueur des chaînes utilisées avec DDEExecute.

Cette commande n'est disponible que sur le canal système.

Syntaxe

Command(opnum, execstring)

opnum Détermine la manière dont Microsoft Query reçoit les commandes. Il peut s'agir de l'une des valeurs ci-dessous.

Valeur | Description
1 | Initialise le tampon de Microsoft Query à l'aide de execstring (en vidant le tampon, le cas échéant), mais n'exécute pas la requête.
2 | Concatène execstring à la fin du tampon.
3 | Concatène execstring à la fin du tampon et exécute la totalité du tampon de la commande. Le tampon de la commande étant vidé après l'exécution, execstring ne peut pas être réexécuté.

execstring Segments d'une commande Open. La chaîne entière doit être placée entre guillemets simples ou doubles.

Microsoft Query prend en charge uniquement l'envoi de la commande Open à l'aide de la commande Command.

Notes

Cette commande est uniquement fournie pour une compatibilité Q+E. Il est conseillé d'utiliser, dans la mesure du possible, la commande BuildSQL pour envoyer de longues instructions SQL.


EnableParameters, commande (DDE)

Contrôle si l'utilisateur peut spécifier des paramètres dans le volet des critères et dans la fenêtre SQL. Par défaut, l'utilisateur ne peut pas spécifier de paramètres. Vous ne pouvez pas désactiver les paramètres lorsque ceux-ci ont déjà été définis par l'utilisateur.

Syntaxe

EnableParameters(flag)

flag Détermine si l'utilisateur peut spécifier des paramètres. Attribuez à cet argument la valeur 0 (zéro) pour désactiver la spécification des paramètres ou la valeur 1 pour l'activer.


EnableTensor, commande (DDE)

Indique si le programme de destination prend en charge les sources de données OLAP. Cette commande est disponible sur le canal système uniquement.

Syntaxe

EnableTensor(flag)

flag Utilisez True pour autoriser les sources de données d'être renvoyées au programme de destination. Utilisez False, ou Omit, pour autoriser uniquement les sources de données non OLAP d'être renvoyées au programme de destination.


Exécuter des commandes DDE

Vous pouvez envoyer des commandes à Microsoft Query à l'aide de DDEExecute. Les commandes sont propres à Microsoft Query et peuvent ou non correspondre aux commandes de menu Microsoft Query. Par exemple, les commandes Open et SaveAs remplissent les mêmes fonctions que les commandes de menu équivalentes dans Microsoft Query, ce qui n'est pas le cas des commandes ODBCLogon et UserControl. Pour obtenir la liste des commandes disponibles, cliquez sur Image du bouton .

La méthode DDEExecute a deux arguments.

Argument | Description
channel | Valeur du canal DDE renvoyée par DDEInitiate.
command | Commande à envoyer à Microsoft Query

Pour permettre à un utilisateur de créer des requêtes dans Microsoft Query, utilisez la commande UserControl. L'exemple suivant montre comment affecter la chaîne Ma Commande Quitter à la commande Quitter du menu Fichier dans Microsoft Windows ou à la commande Quitter du menu Fichier sur Macintosh.

DDEExecute Chan,"[UserControl('&My Exit Command',3,True)]"

La valeur du canal DDE a été préalablement affectée à Chan, et la commande qui est envoyée à Microsoft Query est UserControl. Notez que la commande UserControl et ses paramètres sont placés entre guillemets anglais doubles ( " " ) et entre crochets droits ( [ ] ).


Exit, commande (DDE)

Ferme Microsoft Query. Cette commande n'est disponible que sur le canal système.

Syntaxe

Exit(exitall)

exitall Détermine si Microsoft Query sera fermé lorsque les requêtes situées sur des canaux autres que celui qui exécute la commande Exit sont ouvertes. Vous pouvez lui attribuer la valeur True ou False.

Utilisez True pour quitter Microsoft Query indépendamment des requêtes ouvertes. Si Microsoft Query est sous le contrôle d'un utilisateur pour un autre canal (c'est-à-dire, si la commande UserControl a été exécutée), ce paramètre ferme ce canal et renvoie le contrôle au programme qui a démarré Microsoft Query sous le contrôle de l'utilisateur.

Utilisez False pour quitter Microsoft Query uniquement si les requêtes ouvertes ont été ouvertes sur le canal exécutant la commande Exit.

Notes

Cette commande DDE est également utilisée pour quitter Microsoft Query sous Macintosh.


Sortir de Microsoft Query à partir de DDE

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Pour quitter Microsoft Query, un programme peut utiliser la commande Exit, pour que l'utilisateur n'ait pas à cliquer sur Quitter dans le menu Fichier.

Commande | Description
Exit (False) | Quitte Microsoft Query uniquement si aucune requête n'est ouverte sur d'autres canaux.
Exit (True) | Quitte Microsoft Query, que d'autres requêtes soient ouvertes ou non.


Fetch et Fetch.Advise, commandes (DDE)

La commande Fetch récupère des données de Microsoft Query et les envoie directement au programme de destination.

La commande Fetch.Advise met automatiquement à jour le programme de destination au fur et à mesure que les valeurs de Microsoft Query sont modifiées, et non juste lors de l'envoi de la commande Fetch.Advise.

Ces commandes sont disponibles à la fois sur le canal système et sur le canal de requête.

Syntaxe 1

Fetch.Advise(appname, topic, range, values)

Syntaxe 2

Fetch(appname, topic, range, values)

appname Nom du programme de destination vers lequel les données sont envoyées. Vous trouverez ci-dessous les arguments appname que vous pouvez utiliser pour les programmes Office :

Programmes | Valeur de appname
Microsoft Access | MSAccess
Microsoft Excel | Excel
Microsoft Word | WinWord

topic Nom de la feuille de calcul, du document ou du contrôle vers lequel les données doivent être envoyées.

range Zone de la feuille de calcul, du document ou du contrôle vers laquelle les données doivent être envoyées.

values Valeurs à récupérer dans Microsoft Query. (Pour connaître les valeurs valides, consultez le tableau ci-dessous.)

Remarque La commande Fetch.Advise ne met automatiquement à jour que les données de la requête, et non les éléments de la requête ou les références row#col#.

Il peut s'agir de l'une des valeurs suivantes :

Valeur | Description
Request_item | Informations à renvoyer ; par exemple, QueryDefinition.
row#col# | Référence destinée à récupérer des lignes et des colonnes spécifiques ; par exemple L3C5 dans Microsoft Excel.
/Headers | Récupère les noms de colonne.
/Rownum | Récupère les numéros de lignes.
(Tous) | Récupère tous les enregistrements.

Notes

Pour Fetch.Advise, le canal créé pour renvoyer les données au programme de destination reste ouvert jusqu'à l'envoi d'une commande Fetch.Unadvise ou Close.

Exemple

Cet exemple montre comment utiliser les éléments de requête NumRows et NumCols pour renvoyer le nombre de colonnes et de lignes de la requête, puis comment renvoyer les valeurs avec les en-têtes de colonne vers une feuille de calcul Microsoft Excel appelée « Feuil1 ».

rows=REQUEST(Chan,"NumRows")
cols=REQUEST(Chan,"NumCols")
DDEExecute chan, "[Fetch(""Excel"", ""Data.xls!Sheet1"", _
    ""R1C1:R"&rows&"C"&cols&""", ""All/Headers"")]"


Extraire des données

Alors que DDERequest peut renvoyer des données à un programme, les commandes Fetch et Fetch.Advise méritent une mention spéciale parce qu'elles extraient des données à partir de Microsoft Query et qu'elles les envoient directement à une feuille de calcul ou à un document. Fetch et Fetch.Advise sont utilisées comme l'argument de commande de DDEExecute.

Fetch.Advise est semblable à Fetch, excepté que le canal créé par la première extraction n'est pas immédiatement fermé. Microsoft Query continue d'envoyer toutes les modifications apportées aux données jusqu'à ce que le canal DDE d'origine soit fermé ou que Microsoft Query reçoive une commande Fetch.Unadvise.


Fetch.Unadvise, commande (DDE)

Supprime la fonctionnalité de mise à jour automatique définie par Fetch.Advise et ferme le canal ouvert par Microsoft Query pour transmettre les données au programme de destination. Cette commande est disponible à la fois sur le canal système et sur le canal de requête.

Remarque Les arguments utilisés par Fetch.Unadvise doivent correspondre aux arguments utilisés précédemment par Fetch.Advise.

Syntaxe

Fetch.Unadvise(appname, topic, range, values)

appname Nom du programme de destination vers lequel les données doivent être envoyées. (Pour obtenir des exemples, consultez la rubrique relative à la commande Fetch.Advise.)

topic Nom de la feuille de calcul, du document ou du contrôle vers lequel les données doivent être envoyées.

range Zone de la feuille de calcul, du document ou du contrôle vers laquelle les données doivent être envoyées.

values Valeur à récupérer dans Microsoft Query. (Pour obtenir un tableau des valeurs valides, consultez la rubrique relative à la commande Fetch.Advise.)


Impossible d'exécuter Microsoft Query. Version incompatible de <nom du fichier>.

Le fichier Ddeml.dll n'a plus cours ou est manquant. Essayez de réinstaller Microsoft Query ou Microsoft Windows.


Logoff, commande (DDE)

Arrête la connexion à la source de données spécifiée. Cette commande n'est disponible que sur le canal système.

Syntaxe

Logoff(source)

source Nom de la source de données dont vous voulez vous déconnecter.


Logon, commande (DDE)

Affiche une boîte de dialogue qui vous permet de vous connecter à une source de données. Cette commande n'est disponible que sur le canal système.

Syntaxe

Logon(source)

source Nom de la source de données à laquelle vous voulez vous connecter.


LogonNow, commande (DDE)

Si vous avez utilisé la commande BuildODBC pour créer la chaîne de connexion, cette commande établit une connexion en utilisant la chaîne de connexion stockée dans le tampon. En l'absence d'une chaîne de connexion dans le tampon, une erreur se produit.

Syntaxe

LogonNow([dialog])

dialog Détermine si des boîtes de dialogue s'affichent au moment de la connexion. Il peut s'agir de l'une des valeurs ci-dessous.

Valeur | Description
0 (zéro) | Aucune boîte de dialogue ne s'affiche. Si vous ne spécifiez pas cet argument, la valeur par défaut est 0 (zéro).
1 | Des boîtes de dialogue s'affichent afin d'obtenir des informations supplémentaires de la part de l'utilisateur non fournies par la chaîne de connexion.
2 | Des boîtes de dialogue s'affichent avec des valeurs de la chaîne de connexion fournies comme valeurs par défaut.
3 | Identique à 1, à l'exception du fait que les informations qui ne sont pas obligatoires pour la connexion à la source de données sont estompées.


ODBCLogon, commande (DDE)

Permet à un programme de se connecter à une source de données. Vous pouvez spécifier si des boîtes de dialogue sont présentées à l'utilisateur au moment de la connexion. Cette commande n'est disponible que sur le canal système.

Syntaxe

ODBCLogon(connectstring, dialog)

connectstring Chaîne qui fournit des informations (telles que le nom de la source de données, le nom d'utilisateur et le mot de passe) requises par un pilote pour se connecter à une source de données. Cet argument doit posséder le format requis par le pilote que vous utilisez. (Pour plus d'informations sur la chaîne de connexion, consultez la documentation relative à votre source de données.)

Remarque Because Microsoft Query supports File Data Source Names (DSNs), you can use the ConnectionString request item to obtain the DSN-less connection string of a query created from a File DSN. Vous pouvez ensuite utiliser cette chaîne de connexion pour vous reconnecter à la source de données d'un ordinateur quelconque.

dialog Détermine si des boîtes de dialogue s'affichent au moment de la connexion. Il peut s'agir de l'une des valeurs ci-dessous.

Valeur | Description
0 (zéro) | Aucune boîte de dialogue ne s'affiche.
1 | Des boîtes de dialogue s'affichent afin d'obtenir des informations supplémentaires de la part de l'utilisateur non fournies par la chaîne de connexion.
2 | Des boîtes de dialogue s'affichent avec des valeurs de la chaîne de connexion fournies comme valeurs par défaut.
3 | Identique à 1, à l'exception du fait que les informations non obligatoires pour la connexion à la source de données sont estompées.

Exemple

Cet exemple montre comment utiliser l'élément de requête ConnectionString pour renvoyer la chaîne nécessaire à la connexion à une source de données. L'exemple montre ensuite comment enregistrer la chaîne à l'issue de la connexion de l'utilisateur à une source de données, puis utiliser la commande ODBCLogon pour se connecter à la même source de données sans intervention de l'utilisateur.

connstr = DDERequest(chan, "ConnectionString")
' intervening code
DDEExecute chan, "[ODBCLogon (connstr(1), 0)]"


Ouvrir un canal DDE

Pour ouvrir un canal DDE, votre procédure utilise la méthode DDEInitiate. La méthode DDEInitiate a deux arguments : le nom du programme source et l'« objet » de la conversation DDE (appelé sujet). Le nom de programme de Microsoft Query est « MSQuery ».

Microsoft Query peut comprendre les sujets suivants :

Sujet | Description
query_window_name | Nom d'une fenêtre de requête ouverte. Le nom de la fenêtre peut être spécifié uniquement si Microsoft Query est en cours d'exécution et qu'une fenêtre est ouverte.
System | Sujet général qui permet au programme de destination d'établir une liaison avec Microsoft Query plutôt qu'avec une fenêtre de requête, un fichier ou une instruction SQL SELECT.

Lorsque Microsoft Query reçoit une requête de conversation DDE sur un sujet qu'il reconnaît, il répond et ouvre un canal. La méthode DDEInitiate renvoie un numéro de canal DDE, qui peut être affecté à une variable et utilisé pour des opérations ultérieures sur ce canal.

Pour ouvrir plusieurs fenêtres sur un même canal, utilisez le sujet System. Lorsque vous utilisez le sujet System pour ouvrir un canal DDE, vous pouvez uniquement activer les fenêtres qui ont été préalablement ouvertes sur ce canal DDE.


Open, commande (DDE)

Ouvre et exécute une requête, puis affiche les données dans la grille de données. Cette commande n'est disponible que sur le canal système.

Syntaxe

Open(query)

query Nom du fichier de Microsoft Query (sous Microsoft Windows, l'extension du nom de fichier est .dqy) ou du fichier Q+E (uniquement sous Microsoft Windows ; l'extension du nom de fichier est .qef) qui contient la requête ou l'instruction SQL SELECT à exécuter.

Exemple

Cet exemple montre comment ouvrir une requête appelée Ventes.

DDEExecute chan, "[Open(""c:\msquery\sales.dqy"")]")

Voici le même exemple sous Macintosh.

DDEExecute chan, "[Open(""drivename:msquery:sales"")]")

Cette instruction montre comment utiliser une instruction SQL SELECT pour exécuter une nouvelle requête.

DDEExecute chan, "[Open(""SELECT * FROM pubs.dbo.titles"")]")


ParameterNames2, requête (DDE)

Renvoie des informations qui se rapportent aux paramètres pour une requête paramétrée. Cette requête est disponible sur le canal système uniquement.

Syntaxe

ParameterNames2( )

Pour chaque paramètre, ParameterNames2 renvoie le nom, le type de données et la dernière Valeur utilisée. ParameterNames2 renvoie une matrice de 3 colonnes sur N lignes au format xlTable, comme suit :

Colonne 1 | Colonne 2 | Colonne 3
Nom du paramètre | Type de données de la colonne | Dernière valeur du paramètre utilisée, si disponible, sinon : Null

Pour plus d'informations sur le format xlTable, consultez Aide de Visual Basic pour Microsoft Excel.

La requête ParameterNames2 peut être utilisée à tout moment, même si des paramètres ont été désactivés pour une requête à l'aide de la commande EnableParameters. Si la requête ne contient pas de paramètres, ParameterNames2 renvoie une matrice vide.


QueryNow, commande (DDE)

Exécute la requête active pour le canal DDE ouvert. Si vous avez utilisé la commande BuildSQL pour créer la requête, cette commande exécute l'instruction SQL dans le tampon et ouvre une fenêtre de requête. Cette commande est disponible à la fois sur le canal système et sur le canal de requête.

Syntaxe

QueryNow( )

Exemple

Cet exemple montre comment enregistrer une instruction SQL à partir d'une requête, puis envoyer la même instruction afin d'exécuter de nouveau la requête.

sql = DDERequest(Chan, "QueryDefinition")
DDEExecute chan, "[BuildSQL(""" & sql & """)]"
DDEExecute chan, "[QueryNow()]"


QueryType, requête (DDE)

Renvoie des informations qui se rapportent à la source de données pour une requête. Cette requête est disponible sur le canal système uniquement.

Syntaxe

QueryType( )

La requête QueryType renvoie une matrice à deux éléments au format xlTable. Le premier élément contient le type de la source de données de la requête. Il peut s'agir d'une source ODBC ou OLE/DB. Le deuxième élément contient le type de commandes acceptées par la source de données : SQL, Cube, ou Annuler, comme suit :

QueryType | CommandType | Description
ODBC | SQL | La source de données est SQL, compatible avec ODBC.
OLEDB | Cube | La source de données est un cube OLAP. L'instruction SQL contient le nom du cube.
ODBC | Annuler | L'utilisateur a annulé la requête, puis est retourné au programme de destination.

Pour plus d'informations sur le format xlTable, consultez Aide de Visual Basic pour Microsoft Excel.

Utilisez la requête QueryType comme première requête uniquement, après la fin de l'exécution d'une commande UserControl2.

Si QueryType indique que la source de données est un cube OLAP, vous pouvez utiliser ODBCSQLStatement et les requêtes ConnectionString pour récupérer les informations de la source de données. Obtenir des informations sur l'utilisation des requêtes DDE.


Demander des états et autres informations

Après avoir ouvert un canal DDE vers Microsoft Query, vous pouvez renvoyer un jeu de résultats ou d'autres informations à l'aide de DDERequest.

La méthode DDERequest a deux arguments.

Argument | Description
channel | Valeur du canal DDE renvoyée par DDEInitiate.
request_item | Données à renvoyer. Il peut s'agir du contenu d'un champ ou d'une plage de champs dans une fenêtre de requête ou d'autres types d'informations, tels que le nombre d'enregistrements présents dans une fenêtre de requête.

Les éléments d'une requête peuvent être demandés à la fois sur le canal de requête et sur le canal système. Sur le canal de requête, vous pouvez uniquement renvoyer des informations qui se rapportent à la requête, telles que le nombre de lignes ou de colonnes ou encore la définition de la requête. Sur le canal système, vous pouvez renvoyer des informations générales sur Microsoft Query, telles que les connexions en cours, le nom des sujets et l'état des programmes, ainsi que des informations spécifiques à la requête active.

Les éléments de requête possibles pour un canal de requête ou la requête active sur un canal système peuvent être les suivants :

Élément de demande | Information renvoyée
ColumnTitles | Matrice de titres de colonne. Le titre de la colonne est identique au nom du champ, sauf si l'utilisateur a modifié ce titre de colonne dans Microsoft Query.
ConnectionString | Matrice de segments de chaînes de connexion (chacun pouvant comporter jusqu'à 255 caractères) qui constitue la chaîne de connexion utilisée pour établir la connexion à la fenêtre de requête active. Si la requête a été créée à partir d'un DSN fichier (Data Source Name), cet élément renvoie une chaîne de connexion sans DSN.
ConnectionString/n | Matrice de segments de chaînes de connexion (chacun pouvant comporter jusqu'à n caractères) qui constitue la chaîne de connexion utilisée pour établir la connexion à la fenêtre de requête active. Si la requête a été créée à partir d'un DSN fichier, cet élément renvoie une chaîne de connexion sans DSN.
DataSourceName | Nom de la source de données (DSN, Data Source Name) utilisé par la requête active.
ErrorText | Texte d'erreur, le cas échéant, renvoyé par la dernière instruction SQL exécutée. Cet élément peut être demandé plusieurs fois afin d'extraire toutes les erreurs qui se sont produites. Une fois toutes les erreurs extraites, cet élément renvoie une chaîne vide. De même, il renvoie une chaîne vide si la plupart des instructions SQL récemment exécutées ont été menées à bien avec succès, même si les précédentes instructions SQL avaient échoué.
FieldDef | Matrice de valeurs qui décrit les expressions et les types de données des colonnes (champs) de la fenêtre de requête. Chaque ligne de la matrice décrit un champ de la requête. La matrice renvoie les données suivantes sous forme de colonnes : le nom du champ, son type de données Q+E, sa largeur, sa précision et son type de données SQL.
GetUniqueItems | Matrice des éléments uniques dans une colonne donnée des résultats de requête. L'élément de requête proprement dit doit être l'index de colonne défini à partir de zéro de la colonne ajoutée à "GetUniqueItems" (par exemple, les éléments uniques de la deuxième colonne sont renvoyés par "GetUniqueItems1"). Vous ne pouvez pas demander les éléments uniques d'une colonne qui n'est pas incluse dans la requête. Cet élément renvoie les mêmes valeurs qu'une instruction SELECT DISTINCT pour la colonne demandée, avec toutes les jointures et les clauses de critères en vigueur. Toutes les clauses de critères qui utilisent des paramètres ne sont pas incluses.
NameSeparator | Caractère unique utilisé par le séparateur de noms de qualificateur ODBC.
NumCols | Nombre de colonnes (champs) de la requête.
NumRows | Nombre de lignes (enregistrements) de la requête.
ODBCSQLStatement | Matrice de segments SQL (chacun pouvant comporter jusqu'à 255 caractères) qui constitue l'instruction SQL ODBC de la requête. Cette chaîne vous permet de contourner Microsoft Query et d'envoyer une instruction SQL ODBC directement à ODBC pour qu'il la traite.
ODBCSQLStatement/n | Matrice de segments SQL (chacun pouvant comporter jusqu'à n caractères) qui constitue l'instruction SQL ODBC de la requête. Vous pouvez utiliser cet élément de demande pour stocker une instruction SQL ODBC dans plusieurs segments plus petits.
ParameterNames | Matrice des paramètres de la requête. Une matrice vide est renvoyée s'il n'existe aucun paramètre. Cet élément peut être demandé à tout moment, même si des paramètres sont désactivés pour la requête.
Query | Nom de la requête.
QueryDefinition | Matrice des segments de définition de la requête (chaque segment pouvant comporter jusqu'à 255 caractères) qui constitue la définition de la requête (instruction SQL), tel que la définit Microsoft Query. Cet élément peut être extrait et enregistré pour des requêtes ultérieures.
QueryDefinition/n | Matrice des segments de définition de la requête (chaque segment pouvant comporter jusqu'à n caractères) qui constitue la définition de la requête (instruction SQL).
Recest | Estimation approximative du nombre de lignes qui peuvent être extraites en une seule fois.
TierType | Chiffre unique qui spécifie le type de la source de données : 1 indique un fichier qui ne peut contenir qu'une seule table ; 2 indique un fichier pour une base de données qui contient une ou plusieurs tables ; 3 indique que les données ne peuvent pas être parcourues. Cet élément de requête est utilisé si le programme a besoin de fournir une boîte de dialogue Ouvrir pour parcourir les données stockées sur un disque.

Lorsque vous utilisez les éléments de requête ci-dessus sur le canal système, les informations sont renvoyées pour la dernière fenêtre de requête utilisée dans une opération DDE.

Pour le canal système, outre les éléments de requête ci-dessus, vous pouvez également demander les éléments suivants :

Élément de demande | Information renvoyée
Sources | Toutes les connexions de source de données en cours (DSN uniquement).
Logon | Toutes les bases de données distantes auxquelles vous pouvez vous connecter (entrées DSN du Registre).
Logoff | Toutes les bases de données distantes actuellement connectées (DSN uniquement).
Tables/source/user/database | Toutes les tables pour la connexion DSN, l'utilisateur et la base de données spécifiés. Notez que la source doit être un nom de source de données valide.
Users/source/database | Tous les utilisateurs pour la connexion DSN et la base de données spécifiées. Notez que la source doit être un nom de source de données valide.
Database/source | Toutes les bases de données pour la connexion DSN spécifiée. Notez que la source doit être un nom de source de données valide.
Username/source/database | Nom d'utilisateur pour la connexion DSN et la base de données spécifiées. Notez que la source doit être un nom de source de données valide.
Topics | Le nom des sujets ouverts sur le canal système, en même temps que le sujet System.
Status | L'état du programme, à savoir Ready ou Busy. Ready signifie que le programme peut avoir une conversation DDE avec Microsoft Query, et Busy signifie que Microsoft Query n'est pas prêt pour une conversation DDE.

L'exemple suivant montre comment insérer la valeur renvoyée par l'élément de requête NumRows dans la cellule A10 de Microsoft Excel.

ActiveWorksheet.Range("A10").Value = DDERequest(chan, "NumRows")


SaveAs, commande (DDE)

Enregistre une nouvelle requête ou une requête existante sous un nom différent. Équivaut à la commande Enregistrer sous du menu Fichier et est disponible à la fois sur le canal système et sur le canal de requête.

Syntaxe 1

SaveAs(queryname)

Syntaxe 2

Save.As(queryname)

Les deux syntaxes sont équivalentes.

queryname Nouveau nom de la requête.


SetParameterName, commande (DDE)

Définit le nom d'un paramètre reçu dans une chaîne de requête transmise à Microsoft Query. SetParameterName doit être envoyé après l'envoi d'une commande BuildSQL.

Syntaxe

SetParameterName(index, name)

index Index du paramètre.

name Nom du paramètre.

Notes

Si l'instruction SQL envoyée par BuildSQL contient des paramètres mais si aucune commande SetParameterName n'est reçue, Query affecte les noms de paramètres par défaut sous la forme « Paramètre n », où n est un nombre qui s'incrémente. Si le nombre de noms de paramètre envoyés à l'aide de la commande SetParameterName est insuffisant, les paramètres restants sont appelés « Paramètre n ». Si trop de noms de paramètre sont envoyés, les noms en excès sont ignorés.


SetQueryName, commande (DDE)

Définit le nom de la requête active, ou crée une requête de ce nom s'il n'y a pas de requête active. Le nom apparaît dans la barre de titre de la fenêtre de requête.

Syntaxe

SetQueryName(name)

name Nom de la requête.


SetQueryType, commande (DDE)

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Détermine l'action prise par Microsoft Query pour les requêtes basées sur des types de sources de données différents. Cette commande est disponible sur le canal système uniquement.

Syntaxe

SetQueryType(QueryType, CommandType)

Combinaisons valides des paramètres QueryType et CommandType :

QueryType | CommandType | Description
ODBC | SQL | Modifie la requête dans Microsoft Query. Ces valeurs deviennent les valeurs par défaut si les paramètres sont omis.
OLEDB | Cube | Exécute l'Assistant Cube OLAP pour modifier la définition du cube.

Lorsque vous utilisez SetQueryType(OLEDB, Cube), Microsoft Query ignore toutes les commandes LogonNow, EnableParameters et SetQueryName, et les arguments UserControl2 qui ne sont pas valides dans le cadre de la modification d'une définition de cube à l'aide de l'Assistant Cube OLAP.


SetWindowState, commande (DDE)

Spécifie si la fenêtre active est normale, réduite ou agrandie lors de son ouverture. Cette commande est disponible à la fois sur le canal système et sur le canal de requête.

Syntaxe

SetWindowState(state)

state État de la fenêtre active. Il peut s'agir de l'une des valeurs ci-dessous.

Valeur | Description
1 | Normal
2 | Réduit (uniquement sous Microsoft Windows)
3 | Agrandi


UserControl2, commande (DDE)

Active Microsoft Query et permet aux utilisateurs de créer, d'ouvrir ou de modifier une requête comme s'ils exécutaient Microsoft Query comme un programme autonome.

Cette commande n'est disponible que sur le canal système.

Remarque La différence entre la commande UserControl et la commande UserControl2 réside dans le fait que UserControl2 vous permet de spécifier une commande à ajouter au menu Fichier qui ferme toutes les requêtes créées par Microsoft Query et qui retourne dans le programme de destination sans aucune donnée.

Syntaxe

UserControl2(exittext, canceltext, appstate, newquery)

exittext Nom de la commande Exit utilisée pour quitter Microsoft Query après une conversation DDE. Si vous ne spécifiez pas cet argument, Revenir est utilisé.

canceltext Nom de l'élément de menu utilisé pour annuler la session active. La commande est ajoutée au bas du menu Fichier dans Microsoft Query. Si vous ne spécifiez pas cet argument, aucun nouvel élément de menu n'est créé.

appstate État du programme. Il peut s'agir de l'une des valeurs ci-dessous.

Valeur | Description
1 | Normal
2 | Réduit (uniquement sous Microsoft Windows)
3 | Agrandi

Si vous ne spécifiez pas cet argument, l'état en cours de Microsoft Query est utilisé.

newquery Spécifie si la boîte de dialogue Choisir une source de données s'affiche lorsque Microsoft Query est lancé pendant une conversation DDE. Vous pouvez lui attribuer la valeur True ou False.

Si vous affectez la valeur True à newquery, la boîte de dialogue Choisir une source de données s'affiche, demandant à l'utilisateur de sélectionner une source de données. Si vous affectez la valeur False (valeur par défaut) à newquery, aucune boîte de dialogue ne s'affiche et toutes les requêtes ouvertes pour ce canal sont accessibles.


UserControl, commande (DDE)

Active Microsoft Query et permet aux utilisateurs de créer, d'ouvrir ou de modifier une requête comme s'ils exécutaient Microsoft Query comme un programme autonome.

Cette commande n'est disponible que sur le canal système.

Syntaxe

UserControl(exittext, appstate, newquery)

exittext Nom de la commande Exit utilisée pour quitter Microsoft Query après une conversation DDE. Si vous ne spécifiez pas cet argument, Revenir est utilisé.

appstate État du programme. Il peut s'agir de l'une des valeurs ci-dessous.

Valeur | Description
1 | Normal
2 | Réduit (uniquement sous Microsoft Windows)
3 | Agrandi

Si vous ne spécifiez pas cet argument, l'état en cours de Microsoft Query est utilisé.

newquery Spécifie si la boîte de dialogue Choisir une source de données s'affiche lorsque Microsoft Query est lancé pendant une conversation DDE. Vous pouvez lui attribuer la valeur True ou False.

Si vous affectez la valeur True à newquery, la boîte de dialogue Choisir une source de données s'affiche, demandant à l'utilisateur de sélectionner une source de données. Si vous affectez la valeur False (valeur par défaut) à newquery, aucune boîte de dialogue ne s'affiche et toutes les requêtes ouvertes pour ce canal sont accessibles.

Notes

Le contrôle utilisateur prend fin lorsque l'utilisateur clique dans le menu Fichier sur Quitter. Microsoft Query reprend alors son état précédent et renvoie le contrôle au programme de destination.

Important N'autorisez pas un programme incluant une fonctionnalité de délai d'attente à dépasser ce délai avant la fin du contrôle utilisateur.

Lorsque Microsoft Query fonctionne sous le contrôle de l'utilisateur, les nouvelles requêtes ou les requêtes existantes sont toutes ouvertes sur le même canal DDE.

Exemple

Cet exemple montre comment démarrer Microsoft Query comme un programme agrandi et remplacer la commande Quitter du menu Fichier par la commande Renvoyer les données vers Microsoft Excel. Il montre ensuite comment afficher la boîte de dialogue Choisir une source de données.

DDEExecute chan, "[UserControl(""&Return To Excel"",3,True)]")


Utiliser DDE

Deux programmes échangent des informations en entamant une conversation DDE sur un canal DDE. Un programme peut conduire plusieurs conversations avec Microsoft Query, mais chacune d'elles a lieu sur un canal distinct.

Le programme qui amorce la conversation est appelé programme de destination et celui qui répond au programme de destination, programme source. Microsoft Query est toujours le programme source dans une conversation DDE. En d'autres termes, ce sont toujours les autres programmes qui amorcent une conversation DDE avec Microsoft Query.

Remarque Tous les programmes ne prennent pas en charge DDE. Pour savoir si votre programme le prend en charge, consultez la documentation qui l'accompagne.

Canaux DDE

Il existe deux types de canaux DDE : les canaux système et les canaux de requête.

Vous utilisez un canal système dans une conversation DDE entre le programme de destination et Microsoft Query pour obtenir des informations générales et des informations relatives à des requêtes. Le canal système fournit non seulement des informations sur les requêtes, mais vous permet également d'extraire des données concernant le système, telles que les connexions en cours, les requêtes ouvertes et l'état du programme de destination.

Vous utilisez un canal de requête dans une conversation DDE entre le programme de destination et une requête spécifique (par exemple, Requête1) dans Microsoft Query. Pour utiliser un canal de requête, la fenêtre de requête doit avoir été préalablement ouverte au moyen d'un canal système.

Fonctionnement de DDE

Une conversation DDE est comparable à une conversation normale entre deux personnes. Par exemple, dans un entretien d'embauche, le chef du personnel peut poser au postulant une série de questions le concernant. Le chef du personnel (la destination) amorce la conversation, demande des informations au postulant (la source) et consigne ces informations sur du papier (la feuille de calcul ou le document). Bien entendu, le postulant peut également poser des questions au chef du personnel et établir ainsi un dialogue.

De même, les programmes qui participent à une conversation DDE envoient et reçoivent des informations. Par exemple, pour utiliser DDE en vue de communiquer avec Microsoft Query, une procédure Visual Basic pour Applications (VBA) est susceptible de suivre les étapes suivantes :

  1. La procédure ouvre un canal au moyen de la méthode DDEInitiate.
  2. Si nécessaire, la procédure envoie des informations, telles que les sources de données disponibles ou les connexions en cours, à Microsoft Query.
  3. La procédure active Microsoft Query. Cette étape permet à Microsoft Query d'accepter des commandes. À ce stade de la procédure, l'utilisateur ou la procédure peut créer ou modifier une requête. La procédure peut envoyer des commandes directement à Microsoft Query au moyen de la méthode DDEExecute.
  4. Une fois que l'utilisateur ou la procédure a quitté Microsoft Query, le programme de destination reprend le contrôle. La procédure peut extraire des données de requête et les renvoyer au programme de destination au moyen de la méthode DDERequest ou bien envoyer les données à Microsoft Query.
  5. La procédure ferme le canal au moyen de la méthode DDETerminate.

Pour plus d'informations sur les méthodes DDE dans VBA, consultez l'aide de Visual Basic.


Utiliser Microsoft Query avec d'autres programmes

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

En règle générale, les autres programmes utilisent Microsoft Query pour accomplir trois tâches principales :

  • créer une nouvelle requête ;
  • mettre à jour des données existantes ;
  • modifier la définition de la requête ou les données.

Microsoft Query comme outil de requête de données pour les utilisateurs

À l'aide de DDE, vous pouvez faire fonctionner Microsoft Query comme un outil d'extraction de données. Une fois que votre macro ou votre programme ouvre un canal DDE, il peut activer Microsoft Query et spécifier la commande qui remplace Quitter dans le menu Fichier dans Microsoft Windows ou Quitter dans le menu Fichier sur le Macintosh, l'état du programme (réduit en icône [Windows uniquement], agrandi ou restauré) dans lequel se trouve Microsoft Query et l'affichage éventuel d'une série de boîtes de dialogue.

Un utilisateur peut alors créer, ouvrir ou modifier une requête comme si Microsoft Query était exécuté en tant que programme autonome. Lorsque l'utilisateur a terminé la création de la requête, il peut cliquer sur la commande personnalisée Quitter ou sur le bouton Renvoyer les données de la barre d'outils.

Une fois que le programme de destination (document, feuille de calcul ou autre objet) reprend le contrôle, des données peuvent être demandées à Microsoft Query. Par exemple, l'utilisateur peut demander le nombre de lignes ou de colonnes contenues dans la requête, la chaîne SQL qui définit la requête, la chaîne de connexion pour la source de données ou le nom de la source de données. Des données peuvent être renvoyées au programme de destination avant que le canal DDE soit fermé et que la macro ou le programme prenne fin.

Mise à jour des données extraites

Après avoir exécuté une requête et renvoyé un jeu de résultats, il peut arriver que vous souhaitiez ultérieurement mettre à jour les données avec les données en cours dans la source de données. À l'aide de DDE, vous pouvez mettre à jour des données sans qu'une intervention de l'utilisateur soit nécessaire. En effet, un programme peut envoyer une instruction SQL à Microsoft Query, qui peut alors exécuter la requête et renvoyer le jeu de résultats au programme de destination.

Modification d'une définition de requête ou de données

Un programme peut également utiliser Microsoft Query de façon à permettre à un utilisateur de modifier une définition de requête existante dans Microsoft Query ou de modifier des données dans une source de données.

Pour démarrer ce processus, un programme ouvre un canal DDE, se connecte à une source de données, puis envoie une chaîne SQL (enregistrée à partir de la requête précédente) à Microsoft Query pour créer une nouvelle requête. Une fois que le programme a ouvert la nouvelle requête, le contrôle est passé à l'utilisateur, qui peut alors modifier la requête ou les données comme il le souhaite. Lorsque l'utilisateur quitte Microsoft Query, les données sont renvoyées au programme, la nouvelle définition de requête est enregistrée et la requête est fermée.

Par exemple, un utilisateur qui travaille dans Microsoft Word peut choisir une commande personnalisée appelée "Chiffres de ventes" pour démarrer la macro correspondante. Sans que l'utilisateur s'en rende compte, cette macro peut alors démarrer Microsoft Query, créer une requête, puis renvoyer les données relatives aux ventes dans le document Word.


ViewPane, commande (DDE)

Spécifie les volets affichés dans la fenêtre de requête. Cette commande est disponible à la fois sur le canal système et sur le canal de requête.

Syntaxe

ViewPane(pane)

pane Spécifie les volets affichés. Il peut s'agir de l'une des valeurs suivantes :

Valeur | Description
0 (zéro) | Volet des données uniquement
1 | Volet des données et volet des tables
2 | Volet des données et volet des critères
3 | Volet des données, volet des tables et volet des critères


Types de données Q+E

Valeur | De type
1 | SQL_CHAR
2 | SQL_BINARY, SQL_VARBINARY, SQL_LONGVARBINARY, SQL_LONGVARCHAR, SQL_VARCHAR
3 | SQL_NUMERIC, SQL_DECIMAL
4 | SQL_INTEGER, SQL_BIGINT
5 | SQL_BIT, SQL_TYNYINT, SQL_SMALLINT
6 | SQL_FLOAT
7 | SQL_REAL, SQL_DOUBLE
8 | SQL_TIME, SQL_DATE, SQL_TIMESTAMP


Types de données SQL

Valeur | De type
0 | SQL_UNKNOWN_TYPE
1 | SQL_CHAR
2 | SQL_NUMERIC
3 | SQL_DECIMAL
4 | SQL_INTEGER
5 | SQL_SMALLINT
6 | SQL_FLOAT
7 | SQL_REAL
8 | SQL_DOUBLE
9 | SQL_DATETIME (ODBC 3.0 only)
12 | SQL_VARCHAR


<nom> a été supprimée avec succès.

Microsoft Query a supprimé la table ainsi que toutes les données qu'elle contenait. Vous ne pouvez pas annuler cette suppression.


Voulez-vous supprimer la table <nom> ?

Vous avez indiqué que vous voulez supprimer cette table. Si vous supprimez la table, toutes les données qu'elle contient seront supprimées.

Attention Si vous supprimez la table, vous ne pouvez pas annuler la suppression.

  • Pour supprimer la table et les données qu'elle contient, cliquez sur Oui.
  • Pour ne pas supprimer la table, cliquez sur Non.


Une instruction non valide de la requête a fait échouer l'enregistrement.

Votre requête n'est pas valide. Par exemple, vous n'avez peut-être pas défini les critères correctement. Si la commande Requête automatique est désactivée, essayez d'exécuter la requête en cliquant dans le menu Enregistrements sur Exécuter la requête.


Un écran disposant au moins d'une résolution de 400 x 350 pixels est nécessaire pour exécuter Microsoft Query.

Votre écran ne dispose pas d'une résolution d'affichage suffisante pour exécuter Microsoft Query. Remplacez l'écran à l'aide du programme d'installation de Microsoft Windows. Avant de remplacer l'écran, vous devrez peut-être mettre à jour la carte vidéo de votre ordinateur afin qu'elle puisse gérer une résolution d'affichage supérieure.


Erreur de pilote.

Cette erreur a été renvoyée par le pilote. Pour plus d'informations, consultez la documentation du pilote que vous utilisez actuellement.


Des enregistrements identiques ont été trouvés.

Le jeu de résultats contient des enregistrements identiques, car le volet des données n'inclut pas un champ dont les valeurs identifient chaque enregistrement de manière exclusive, tel qu'un numéro de client ou un numéro de commande. Toute modification apportée à l'un de ces enregistrements identiques affecte tous les enregistrements identiques.

Pour distinguer les enregistrements, veillez à ajouter tous les champs de la table sous-jacente dans le volet des données avant de commencer à modifier les données.


Impossible de modifier une colonne calculée.

Vous ne pouvez pas modifier les données dans une colonne à partir de laquelle vous avez calculé des totaux ou dans laquelle vous affichez les résultats d'une expression personnalisée.


Impossible de modifier une requête groupée.

Vous ne pouvez pas modifier les données d'une requête contenant des totaux ou pour laquelle la case à cocher Grouper les enregistrements de la boîte de dialogue Propriétés de la requête est activée. Pour modifier les données, supprimez les totaux ou désactivez la propriété Grouper les enregistrements.


Impossible de modifier une requête possédant plusieurs tables.

Vous ne pouvez pas modifier les données d'une requête qui contient plusieurs tables.

  • Pour modifier des données d'une table, ajoutez uniquement cette table à la requête, puis cliquez dans le menu Enregistrements sur Modification autorisée.
  • Pour modifier des données dans la requête active, supprimez toutes les tables supplémentaires de la requête, ne conservez que la table contenant les données que vous souhaitez modifier. Cliquez ensuite dans le menu Enregistrements sur Modification autorisée.

Remarque Lorsque vous supprimez une table dans une requête, les données de la table sous-jacente ne sont pas supprimées. Cette opération ne supprime la table et les données qu'elle contient que de la requête active.


Impossible d'ajouter la source de données.

Microsoft Query ne peut ajouter la source de données sélectionnée en raison d'un problème de connexion à la source de données.


Expression de la colonne incorrecte : <expression>.

L'expression spécifiée dans la liste Select est incorrecte. L'expression doit avoir la forme suivante :

SELECT employés.N° employé, employés.Date d'embauche
FROM C:\QT\employés employés


'GROUP BY' doit être suivi par une expression de regroupement.

Votre instruction SQL inclut GROUP BY, mais GROUP BY n'est pas suivi par une expression.


'ORDER BY' doit être suivi par une expression de tri.

Votre instruction SQL inclut ORDER BY, mais ORDER BY n'est pas suivi par une expression.


Impossible d'ouvrir plusieurs copies d'un fichier.

Vous ne pouvez pas ouvrir deux copies du même fichier de requête en même temps.


Impossible d'ajouter la table <nom>.

La table spécifiée ne peut être ajoutée. Vérifiez que les conditions suivantes sont respectées :

  • La table spécifiée est présente dans la base de données.
  • Le nom de table est orthographié correctement. Recherchez tout trait de soulignement ( _ ) manquant ou autre signe de ponctuation.
  • La table spécifiée contient des champs valides (colonnes).


Pour créer une jointure réflexive, vous devez ajouter la même table.

Le volet des tables comporte deux tables différentes et vous avez défini une jointure réflexive en utilisant le même nom de table dans les zones Gauche et Droite de la boîte de dialogue Jointure.

  • Pour créer une jointure réflexive, vous devez avoir deux occurrences de la même table dans le volet des tables.
  • Pour joindre deux tables différentes, vous devez utiliser l'une des deux tables pour la partie gauche de la jointure et l'autre table pour la partie droite de la jointure.


La longueur <nombre> doit être numérique.

Vous avez utilisé une valeur non numérique dans la zone Longueur. Remplacez cette valeur par une valeur numérique.


Erreur dans le nom <nom>.

Le nom de table et les noms de champ doivent respecter les conventions de noms standard obligatoires par votre source de données. Consultez la documentation relative à votre source de données.


Le nombre de chiffres après la virgule doit être inférieur ou égal à la longueur totale.

Vous avez tapé un nombre dans la zone Décimales supérieur au nombre de la zone Longueur. Remplacez la valeur de la zone Décimales par un nombre inférieur ou égal au nombre de la zone Longueur.


La longueur maximale pour le type <nom du type de données> est <nombre>.

Vous avez tapé dans la zone Longueur un nombre supérieur à la longueur maximale autorisée pour un champ lorsque ce type de données est utilisé.


L'actualisation a échoué.

Microsoft Query ne peut pas mettre à jour la liste des tables de la boîte de dialogue Ajouter une table, car la source de données ne répond pas. Assurez-vous que vous êtes toujours connecté à la source de données.


Impossible de supprimer la source de données.

Microsoft Query ne peut supprimer la source de données sélectionnée. Vous devez vous déconnecter de la source de données pour pouvoir la supprimer.


Erreur ODBC

Microsoft ODBC ou votre source de données a renvoyé une erreur sans qu'aucune information détaillée ne soit disponible. Assurez-vous que votre base de données est disponible et en cours d'exécution, puis réessayez.


Erreur de syntaxe dans la clause GROUP BY.

Votre instruction SQL contient une clause GROUP BY non valide. Un mot réservé est peut-être mal orthographié ou manquant, ou la ponctuation est incorrecte.


Erreur de syntaxe dans la clause HAVING.

Votre instruction SQL contient une clause HAVING non valide. Un mot réservé est peut-être mal orthographié ou manquant, ou la ponctuation est incorrecte.


Erreur de syntaxe dans l'expression JOIN.

La clause ON de votre instruction SQL n'est pas suivie d'une expression valide. L'expression doit avoir la forme suivante :

{oj C:\QT\commandes commandes LEFT OUTER JOIN C:\QT\détailscommandes détailscommandes ON commandes.N° commande = détailscommandes. N° commande}


Erreur de syntaxe dans la clause ORDER BY.

Votre instruction SQL contient une clause ORDER BY non valide. Un mot réservé est peut-être mal orthographié ou manquant, ou la ponctuation est incorrecte.


Vous devez d'abord choisir une source de données.

Vous avez essayé d'exécuter une instruction SQL avant de sélectionner une source de données. Cliquez dans la boîte de dialogue Exécuter SQL sur Sources de données, puis sélectionnez une source de données.


La table <nom> doit être suivie par un opérateur de jointure.

Votre clause LEFT OUTER JOIN ou RIGHT OUTER JOIN ne contient pas d'opérateur = entre les noms des deux tables de l'expression. Les jointures externes doivent être séparées par un opérateur de jointure. (Utilisez l'opérateur =.)


La table <nom> doit être suivie par LEFT ou RIGHT.

Votre instruction SQL inclut une clause OUTER JOIN mais n'est pas précédée des mots clés LEFT ou RIGHT. Une clause de jointure externe d'une instruction SQL doit être soit une clause LEFT OUTER JOIN ou RIGHT OUTER JOIN.


'HAVING' doit être suivi par une expression.

La clause HAVING de votre instruction SQL n'est pas suivie d'une condition de recherche.


'WHERE' doit être suivi par une expression.

La clause WHERE de votre instruction SQL n'est pas suivie d'une condition de recherche.


'FROM' doit être suivi par le nom d'une table.

Votre instruction SQL inclut une clause FROM qui n'est pas suivie d'un nom de table.


Le collage a été annulé, car le texte est trop long.

Le texte que vous essayez de coller à partir du Presse-papiers est trop long pour le champ sélectionné dans le volet des données ou des critères. Le nombre maximum de caractères que vous pouvez coller dans le champ dépend de la longueur spécifiée pour le champ lors de la création de la table.


Erreur de lecture lors du chargement.

Microsoft Query ne peut pas ouvrir ou lire le fichier sélectionné. Une erreur disque s'est peut-être produite, ou le fichier est corrompu.


Impossible de lire ce fichier.

Microsoft Query ne peut lire votre fichier. Il est possible que le fichier n'ait pas un format Microsoft Query ou Q+E, qu'une erreur disque se soit produite ou que le fichier soit corrompu.


Erreur à l'écriture sur le disque lors de l'enregistrement.

Microsoft Query ne peut pas enregistrer la requête sur le disque. Une erreur disque s'est peut-être produite.


Impossible de définir les critères avant d'avoir spécifié un champ.

Avant de pouvoir définir les critères d'un champ, vous devez ajouter ce champ au volet des critères.


Toutes les fonctions ne sont pas prises en charge par le pilote.

L'expression que vous avez tapée contient une ou plusieurs fonctions non prises en charge par votre source de données. Pour déterminer quelles sont les fonctions prises en charge par votre source de données, consultez la documentation du pilote utilisé par votre source de données, ou consultez le revendeur du pilote.


Impossible de créer l'index

La source de données pour cette table ne prend pas en charge les index.


L'index a été créé avec succès.

Microsoft Query a créé un index avec succès dans le ou les champs spécifiés de la table.


Conversation DDE terminée ou changée.

L'autre programme a malencontreusement fermé ou modifié la conversation DDE (Dynamic Data Exchange), probablement en émettant une instruction DDETerminate ou DDETerminateAll.

Fermez la conversation en cours, puis établissez une nouvelle conversation avec l'autre programme.


La largeur doit être comprise entre 0 et <nombre>.

Spécifiez une largeur de colonne comprise entre ces deux nombres, ou sélectionnez l'option Largeur standard dans la boîte de dialogue Largeur de colonne.


Le nom du fichier n'est pas valide.

Les noms de fichier doivent respecter les conventions de noms standard obligatoires par votre source de données. Consultez la documentation relative à votre source de données.


La hauteur doit être comprise entre 1 et <nombre>.

Spécifiez une hauteur de ligne comprise entre ces deux nombres, ou sélectionnez l'option Hauteur standard dans la boîte de dialogue Hauteur de ligne.


Les jointures externes droite et gauche doivent utiliser l'opérateur '='.

Votre clause LEFT OUTER JOIN ou RIGHT OUTER JOIN omet l'opérateur = entre les noms des deux tables de l'expression ou utilise un opérateur différent. Les jointures externes doivent utiliser un opérateur de jointure. (Utilisez l'opérateur =.)


Les colonnes <nom> et <nom> que vous désirez joindre sont de types différents. Désirez-vous quand même créer la jointure ?

Vous essayez de joindre des champs (colonnes) contenant des types de données différents. Par exemple, vous essayez peut-être de joindre un champ contenant des dates avec un champ contenant du texte.

  • Pour n'effectuer aucune jointure, cliquez sur Annuler.
  • Pour créer la jointure, cliquez sur OK.

Remarque Ce type de jointure peut ne pas produire les résultats escomptés. Vérifiez que Microsoft Query affiche les données souhaitées dans le jeu de résultats.


'OUTER' doit être suivi par 'JOIN'.

Votre instruction SQL inclut une clause LEFT OUTER ou RIGHT OUTER au lieu d'une clause LEFT OUTER JOIN ou RIGHT OUTER JOIN. JOIN est peut-être mal orthographié ou manquant.


La transaction DDE a échoué. Assurez-vous que vous avez la version correcte de DDEML.DLL.

L'installation de Microsoft Query est incomplète ou corrompue. Pour corriger ce problème, réinstaller Microsoft Query et sélectionner l'option de réparation.


Impossible de créer une jointure externe s'il existe plus de deux tables dans la requête.

Le volet des tables ne peut contenir que deux tables lorsque vous utilisez une jointure externe. Supprimez les tables supplémentaires du volet des tables, puis créez la jointure externe.


Liste des messages pleine ; message DDE perdu.

Microsoft Query ne peut effectuer toutes les opérations DDE (Dynamic Data Exchange) qui ont été lancées.

Essayez de fermer certaines des conversations DDE, puis réessayez.


Cette valeur doit être un nombre.

Vous tapez une valeur non numérique pour une option requérant une valeur numérique. Tapez un nombre à la place.


Impossible d'exécuter l'opération DDE.

L'autre programme ne peut exécuter l'opération DDE (Dynamic Data Exchange).

  • Vous avez fourni des données ou des commandes que l'autre programme ne reconnaît pas. Consultez la documentation de ce programme afin de déterminer quelles sont les données et les commandes qu'il reconnaît.
  • En fonction du sujet défini de la conversation, l'autre programme ne reconnaît pas l'argument Item. Consultez la documentation de ce programme afin de déterminer quels sont les éléments qu'il reconnaît.


Impossible d'ouvrir un canal DDE. Microsoft Query n'a pu trouver le sujet de l'application spécifiée ou l'application elle-même.

Microsoft Query ne peut localiser le sujet du programme spécifié ou le programme lui-même (le sujet de la conversation DDE). Assurez-vous que l'autre programme (de destination) est en cours d'exécution, que le sujet est ouvert, et que vous avez correctement orthographié le nom du programme et du sujet lorsque vous avez défini la conversation DDE (Dynamic Data Exchange).


Impossible d'enregistrer la colonne <nom> dans cette source de données.

Vous avez essayé d'enregistrer un jeu de résultats sous forme d'une table, mais la source de données dans laquelle vous l'enregistrez ne gère pas le type de données affecté au champ spécifié ou ne peut pas le convertir en un type de données comparable. Essayez de l'enregistrer dans une autre source de données qui gère ce type de données.


Ressources système insuffisantes pour compléter l'opération.

Microsoft Query ne dispose pas de mémoire disponible suffisante pour effectuer cette opération.

Fermez la fenêtre de Microsoft Query ainsi que les autres programmes. Si l'erreur se reproduit, redémarrez Microsoft Windows et réessayez.


Impossible d'accéder à la table <nom>.

La table spécifiée ne peut pas être trouvée, est verrouillée par un autre utilisateur ou par une autre requête en cours d'exécution, ou ne contient aucun champ valide.


Impossible d'afficher l'aide.

Le fichier d'aide Microsoft Query ne se trouve pas dans le dossier actif. Essayez de déplacer ou de copier ce fichier vers le dossier actif.


Impossible de charger les procédures.

Microsoft Query ne peut afficher la liste des procédures à partir de la source de données, car la source de données ne répond pas. Vous n'êtes peut-être plus connecté à la source de données.


Aucune procédure n'a été trouvée.

Cette source de données ne contient aucune procédure. Pour créer des procédures, consultez la documentation relative à votre source de données.


Impossible de supprimer cette source car elle est utilisée par des requêtes.

Une ou plusieurs requêtes utilisent la source de données que vous souhaitez supprimer. Vous devez d'abord fermer les requêtes utilisant la source de données.


L'enregistrement n'existe pas.

Le numéro d'enregistrement spécifié n'existe pas. Le numéro d'enregistrement est peut-être trop long ou trop court. Assurez-vous que le volet des données comprend des enregistrements, puis vérifiez que vous avez correctement tapé le numéro d'enregistrement.


Il n'existe pas d'index unique dans cette table. Désirez-vous en créer un vous-même ?

Le jeu de résultats que vous souhaitez enregistrer comme nouvelle table provient d'une table qui ne contient pas d'index unique.

  • Pour afficher la boîte de dialogue Créer un index afin de pouvoir créer un index unique pour la table, cliquez sur Oui.
  • Si vous ne souhaitez pas créer d'index, cliquez sur Non.


Impossible de récupérer les valeurs.

Microsoft Query ne peut pas afficher les valeurs que vous avez sélectionnées comme critères. La mémoire est peut-être insuffisante, ou vous n'êtes peut-être plus connecté à la source de données.

Si vous êtes toujours connecté à la source de données, essayez de fermer les autres fenêtres de Microsoft Query ou les autres programmes. Si l'erreur se reproduit, relancez Microsoft Windows.


Impossible de créer une nouvelle fenêtre.

Microsoft Query ne peut pas afficher le fichier sélectionné, probablement car la mémoire disponible est insuffisante.

Fermez les autres fenêtres de Microsoft Query, ou fermez les autres programmes. Si l'erreur se reproduit, redémarrez Windows.


Il vous sera impossible d'annuler cette opération. Désirez-vous continuer ?

La commande Annuler n'est pas disponible pour cette opération, car l'opération est trop volumineuse ou la mémoire disponible est insuffisante.

  • Pour poursuivre l'opération sans pouvoir l'annuler, cliquez sur OK.
  • Pour interrompre l'opération, cliquez sur Annuler.


La seconde table doit être suivie par 'ON'.

Votre instruction SQL inclut une clause LEFT OUTER JOIN ou RIGHT OUTER JOIN et son expression, mais l'expression n'est pas suivie d'une clause ON et de son expression. ON est peut-être mal orthographié ou manquant.


Une requête ne peut avoir qu'une seule jointure externe.

Vous ne pouvez avoir qu'une seule jointure externe dans une requête.


Vous devez sélectionner une valeur pour l'opérateur <opérateur>.

Lorsque vous définissez les critères à l'aide de cet opérateur, vous ne devez utiliser qu'une seule valeur. Microsoft Query sélectionne alors uniquement les enregistrements contenant cette valeur dans le champ pour lequel vous avez défini les critères. Par exemple, si vous sélectionnez « commence par » dans la zone Opérateur, Microsoft Query recherche dans le champ pour lequel vous avez défini les critères les valeurs commençant par la valeur spécifiée. Seuls ces enregistrements sont sélectionnés pour être placés dans le jeu de résultats.


Vous devez sélectionner deux valeurs pour l'opérateur <opérateur>.

Lorsque vous définissez les critères à l'aide de cet opérateur, vous devez utiliser deux valeurs. Par exemple, si vous sélectionnez est compris entre dans la zone Opérateur, Microsoft Query recherche dans le champ pour lequel vous avez défini les critères les valeurs comprises entre les deux valeurs spécifiées. Seuls ces enregistrements sont sélectionnés pour être placés dans le jeu de résultats.


Impossible d'ouvrir le fichier.

Microsoft Query ne peut pas ouvrir le fichier de requête spécifié. Une erreur disque s'est peut-être produite, ou le fichier est peut-être corrompu.


Impossible d'ouvrir le fichier.

Microsoft Query ne peut pas ouvrir ou lire le fichier Microsoft Query que vous avez spécifié dans la boîte de dialogue Exécuter SQL. Il est possible que le fichier n'ait pas le format texte, qu'une erreur disque se soit produite ou que le fichier soit corrompu.


LEFT/RIGHT doit être suivi par 'OUTER'.

Votre instruction SQL inclut une clause de jointure externe LEFT ou RIGHT ne contenant pas le mot clé OUTER. Une clause de jointure externe de l'instruction SQL doit être soit une clause LEFT OUTER JOIN, soit une clause RIGHT OUTER JOIN.


Une jointure externe existe. Voulez-vous la supprimer ?

Deux tables du volet des tables sont déjà connectées à une jointure externe. Si vous souhaitez utiliser trois tables ou davantage dans le volet des tables, vous devez supprimer la jointure externe ou la modifier en une jointure interne.


Le nombre est trop grand.

Tapez une valeur inférieure.


L'expression est trop longue.

L'expression est trop longue pour être évaluée par Microsoft Query. Essayez de raccourcir l'expression, ou scindez-la en deux expressions séparées.


Impossible d'accéder à <base de données>

La source de données que vous utilisez ne vous permet d'ajouter des tables qu'à partir de la base de données en cours (ou d'une base de données équivalente).


Modifier un en-tête de colonne de champ pour le rendre plus explicite

  1. Double-cliquez sur l'en-tête de colonne du champ que vous souhaitez modifier.
  2. Dans la zone En-tête de la colonne, tapez l'en-tête souhaité.


Modifier la largeur d'une colonne ou la hauteur de toutes les lignes

Modification de la largeur d'une colonne Pour modifier la largeur d'une colonne, pointez sur la bordure droite de l'en-tête de colonne, puis faites glisser la bordure jusqu'à ce que la colonne ait la largeur souhaitée.

Conseil Pour ajuster rapidement la largeur de la colonne à celle de la valeur la plus longue, double-cliquez sur la bordure droite de l'en-tête de colonne.

Modification de la hauteur d'une ligne Pour modifier la hauteur de toutes les lignes, pointez sur la bordure inférieure de l'en-tête de ligne, puis faites glisser la bordure jusqu'à ce que la ligne ait la hauteur souhaitée.

Remarque La modification de la hauteur d'une ligne affecte toutes les lignes du jeu de résultats.


Modifier la police, le style ou la taille du texte dans un jeu de résultats

  1. Dans le menu Format, cliquez sur Police.
  2. Effectuez les modifications souhaitées.


Modifier le type de jointure entre les tables d'une requête

  1. Double-cliquez sur la ligne de jointure entre les tables.
  2. Pour sélectionner un opérateur que Microsoft Query utilisera pour comparer les données des champs joints, cliquez sur l'opérateur souhaité dans la zone Opérateur. Pour plus d'informations, cliquez sur Image du bouton .
  3. Pour créer une jointure externe qui utilise tous les enregistrements de la table de gauche, cliquez sur l'option 2 sous Options. Vous devez sélectionner l'opérateur = pour créer des jointures externes.

    Pour créer une jointure externe qui utilise tous les enregistrements de la table de droite, cliquez sur l'option 3 sous Options.

    Pour créer une jointure interne qui utilise uniquement les enregistrements des deux tables, cliquez sur l'option 1 sous Options.

  4. Cliquez sur Ajouter.
  5. Cliquez sur Fermer.

    Pour plus d'informations concernant les types de jointures et leurs effets sur les résultats d'une requête, cliquez sur Image du bouton .


Créer une requête plus complexe dans Microsoft Query

  1. Cliquez sur le bouton Nouvelle requête Image du bouton.
  2. Sous l'onglet Bases de données, cliquez sur la base de données dans laquelle vous souhaitez rechercher les données, ou créez une nouvelle source des données.

    Procédure

  3. Désactivez la case à cocher Utilisez l'Assistant Requête pour créer et/ou modifier vos requêtes, puis cliquez sur OK.
  4. Ajoutez les tables souhaitées.

    Procédure

  5. Ajoutez les champs que vous souhaitez afficher dans l'ensemble de résultats.

    Procédure

    Si vous souhaitez affiner votre jeu de résultats pour inclure certains enregistrements, entrez les critères de filtrage des enregistrements.

    Procédure

    Si vous souhaitez créer une requête paramétrée qui demande des critères lorsque vous l'exécutez, indiquez ces paramètres.

    Procédure

    Vous pouvez créer une jointure interne ou une jointure externe entre les tables pour modifier le jeu de résultats.

    Procédure

Remarques

  • Lorsque vous avez terminé de récupérer les données souhaitées, vous pouvez renvoyer le jeu de résultats vers Microsoft Excel. Pour plus d'informations, cliquez sur Image du bouton .
  • Vous pouvez interrompre l'exécution d'une requête pour laquelle le temps de récupération des données est trop long, en appuyant sur ÉCHAP.
  • Si vous souhaitez attendre d'avoir ajouté tous les champs dans votre jeu de résultats avant de récupérer les données, vérifiez que le bouton Requête automatique Image du bouton n'est pas enfoncé. Lorsque vous êtes prêt à effectuer votre requête, cliquez sur le bouton Requête immédiate Image du bouton.
  • Pour empêcher Microsoft Query d'exécuter la requête avant son enregistrement ou avant le renvoi des données dans Excel, cliquez dans le menu Edition sur Options, puis désactivez la case à cocher Valider les requêtes avant l'enregistrement ou le retour des données.


Créer une requête à l'aide de l'Assistant Requête

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

  1. Cliquez sur le bouton Nouvelle requête Image du bouton.
  2. Activez la case à cocher Utilisez l'Assistant Requête pour créer et/ou modifier vos requêtes.
  3. Sous l'onglet Bases de données, double-cliquez sur la base de données dont vous voulez extraire des données.

    Si vous devez définir une nouvelle source de données, double-cliquez sur Nouvelle source de données, puis indiquez la source de données.

  4. Suivez les instructions de l'Assistant Requête.
  5. Dans la boîte de dialogue Assistant Reuqête – Terminer, exécutez l'une des actions suivante :

    Pour renvoyer les données directement dans Microsoft Excel, cliquez sur Renvoyer les données vers Microsoft Excel, cliquez sur Terminer, puis sélectionnez l'emplacement où vous souhaitez insérer les données externes.

    Pour enregistrer la requête dans un fichier de requête .dqy que vous pouvez ouvrir et modifier dans Microsoft Query ou ouvrir et exécuter dans Excel, cliquez sur Enregistrer la requête. Il est recommandé d'exécuter cette étape facultative si vous envisagez de créer un cube OLAP à partir de la requête.

    Pour exécuter l'Assistant Cube OLAP, dans lequel vous pouvez créer un cube à partir des données de votre requête, cliquez sur Créer un cube OLAP à partir de cette requête, sur Terminer, puis suivez les instructions de l'Assistant. Cette option est destinée aux utilisateurs confirmés. Obtenir des informations sur la création des cubes OLAP.

    Pour affiner la requête, cliquez sur Afficher les données ou modifier la requête dans Microsoft Query, puis sur Terminer. Le jeu de résultats s'affiche dans le volet des données, dans lequel vous pouvez apporter des modifications supplémentaires, puis renvoyer le jeu de résultats dans Microsoft Excel ultérieurement.

Conseil Pour arrêter l'exécution d'une requête pour laquelle le temps de récupération des données est trop long, appuyez sur ÉCHAP.


Supprimer des données dans une base de données faisant l'objet d'une requête

Attention Lorsque vous avez supprimé un enregistrement dans une base de données, il est définitivement supprimé du jeu de résultats et de la base de données.

  1. Dans le menu Enregistrements, assurez-vous que la commande Modification autorisée est activée.

    Dans certains cas, Microsoft Query ne vous autorise pas à modifier les données. Si la commande Modification autorisée est estompée ou si Microsoft Query affiche un message lorsque vous cliquez sur la commande Modification autorisée, vous ne pouvez pas changer les données. Pour plus d'informations, cliquez sur Image du bouton .

  2. Cliquez sur l'enregistrement que vous souhaitez supprimer.
  3. Dans le menu Edition, cliquez sur Supprimer.


Modifier des données dans une base de données faisant l'objet d'une requête

  1. Dans Microsoft Query, assurez-vous que la commande Modification autorisée est activée dans le menu Enregistrements.

    Dans certains cas, Microsoft Query interdit les modifications. Si la commande Modification autorisée est grisée ou si Microsoft Query affiche un message lorsque vous cliquez sur la commande Modification autorisée, vous ne pouvez pas changer les données. Pour plus d'informations, cliquez sur image du bouton .

  2. Dans le jeu de résultats, cliquez sur le champ que vous souhaitez modifier.
  3. Apportez les modifications souhaitées, et appuyez sur ENTRÉE.

Remarque Si vous faites une erreur, vous pouvez annuler la dernière modification en cliquant dans le menu Edition sur Annuler. Vous devez annuler votre modification avant de changer un nouvel enregistrement ou de passer dans une autre fenêtre.


Insérer un champ dans un jeu de résultats

  1. Cliquez sur l'en-tête de colonne du champ à droite de l'emplacement où vous souhaitez insérer le nouveau champ.
  2. Dans le menu Enregistrements, cliquez sur Insérer une colonne.
  3. Dans la zone Champ, sélectionnez la colonne que vous souhaitez insérer.

    Si vous souhaitez un en-tête plus explicite pour la colonne, tapez-le dans la zone En-tête de la colonne.

  4. Cliquez sur Insérer.

Remarque Pour insérer un champ rapidement dans un jeu de résultats, vous pouvez glisser un champ du volet des tables vers le jeu de résultats.


Modifier l'ordre des champs dans un jeu de résultats

  1. Cliquez sur l'en-tête de colonne du champ que vous souhaitez déplacer.
  2. Déplacez le pointeur sur l'en-tête de colonne et faites glisser la colonne jusqu'à l'emplacement souhaité.


Afficher ou masquer un champ dans un jeu de résultats

  1. Cliquez sur l'en-tête de colonne du champ que vous souhaitez masquer.
  2. Dans le menu Format, cliquez sur Masquer une colonne.

Pour afficher une colonne masquée, cliquez dans le menu Format sur Afficher une colonne, sélectionnez la colonne souhaitée, puis cliquez sur Affichage.


Annuler des modifications apportées aux données d'une base de données faisant l'objet d'une requête

  • Dans le menu Edition, cliquez sur Annuler.

Remarque Vous pouvez annuler la modification la plus récente apportée aux données. Vous devez annuler votre modification avant de modifier un autre enregistrement ou de passer dans une autre fenêtre.


Un message indique que le chemin d'accès à ma base de données n'est pas valide.

Recherchez un lecteur réseau mappé Si votre base de données est située dans un répertoire réseau partagé, il est possible que, lors de l'installation de la source de données et de la sélection du fichier de base de données, le chemin d'accès à la base de données ait été enregistré dans la source de données en tenant compte de la lettre de lecteur mappée à ce moment-là par votre système. Par exemple, si votre base de données s'appelle Inventaire.mdb et que votre lecteur G était mappé au répertoire réseau partagé dans lequel cette base de données est stockée, votre source de données peut enregistrer cet emplacement comme étant G:\public\Inventaire.mdb. Lorsque vous essayez d'utiliser cette source de données, le pilote ODBC affiche un message indiquant que le chemin n'est pas valide si le lecteur G n'est pas mappé au même répertoire réseau partagé.

Utilisez une solution autre que le mappage de lecteurs Si vous utilisez le pilote Microsoft Access ou le pilote Microsoft Excel, vous pouvez résoudre ce problème en créant une source de données. Lorsque vous spécifiez l'emplacement d'un fichier de base de données, ne sélectionnez pas le lecteur mappé au répertoire réseau partagé, mais tapez l'adresse UNC du répertoire réseau partagé, puis localisez le fichier de base de données. Par exemple, si votre fichier de base de données est stocké sur un serveur appelé Partagé, vous pouvez taper \\Partagé\public, puis sélectionner le fichier Inventaire.mdb.

Mappez la même lettre de lecteur avant d'utiliser la source de données Pour d'autres pilotes ODBC, avant d'utiliser une source de données ou d'exécuter une requête créée avec cette source de données, assurez-vous que le lecteur mappé au répertoire réseau partagé dans lequel est stockée la base de données est bien le même que lorsque la source de données a été créée.


Un pilote ODBC que j'ai déjà utilisé ne fonctionne plus.

Dans les situations suivantes, vous devrez utiliser un autre pilote avec Microsoft Query :

Vérifiez que vous utilisez un pilote ODBC 32 bits Microsoft Query requiert l'utilisation de pilotes ODBC 32 bits, tels que ceux fournis avec Microsoft Query 07 et versions ultérieures. Par exemple, si vous développez un programme Microsoft Excel dans Microsoft Visual Basic pour recevoir des données externes et distribuer votre programme à des utilisateurs de Microsoft Excel version 5.x, il est possible que le programme ne fonctionne pas avec les pilotes 16 bits sur les systèmes disposant de Microsoft Excel version 5.x.

Vérifiez que vous disposez de pilotes Microsoft version 3.0 ou ultérieure Si vous installez des pilotes ODBC Microsoft autres que ceux livrés avec les versions les plus récentes de Microsoft Excel ou de Microsoft Office, veillez à installer la version 3.0 ou ultérieure de ces pilotes. Les versions antérieures de pilotes ODBC Microsoft risquent de ne pas fonctionner avec Query et versions ultérieures. Les pilotes fournis avec Microsoft Excel 97 et Microsoft Office 97 sont de la version 3.0 ou ultérieure. Lorsque vous installez ces pilotes, toutes les versions anciennes présentes sur votre système doivent être remplacées automatiquement.

Vérifiez que vous disposez de la version correcte fournie par un autre fabricant Si vous utilisez un pilote ODBC d'un autre fabricant, vous pouvez également être amené à installer un nouveau pilote ODBC pour Microsoft Query lors de la mise à niveau de votre base de données ou de l'installation d'une nouvelle version de la base de données. Pour savoir si cette opération est nécessaire, consultez la documentation de votre base de données.

Vérifiez que vous avez défini la source de données du pilote avec Microsoft Query Vous ne pouvez pas utiliser Query pour accéder aux sources de données définies avec l'Assistant Connexion aux données.


Le format des champs de date ou d'heure est incorrect.

Vérifiez le champ de date ou heure dans la base de données sources Si vous ne voyez pas les niveaux que vous attendez dans les dimensions de date ou heure dans votre cube OLAP, vérifiez le champ de date ou heure à partir de la base de données relationnelle sous-jacente qui a fourni les enregistrements pour la requête. Les dates et les heures dans les enregistrements peuvent être stockées sous forme de texte plutôt que dans un format de date ou heure susceptible d'être reconnu par l'Assistant Cube OLAP. Si vous estimez que c'est le cas, consultez l'administrateur de la base de données relationnelle pour vérifier et corriger le format de date ou heure pour le champ.

Vérifiez le niveau supérieur de la dimension Lorsque l'Assistant Cube OLAP ajoute des champs de date et heure comme niveaux inférieurs d'une dimension existante, l'Assistant ne divise pas automatiquement les données en niveaux année/trimestre/mois/semaine et heure/minute/seconde. L'Assistant ne procède ainsi que lorsque vous ajoutez le champ de date ou heure comme niveau supérieur d'une nouvelle dimension. Si le champ de date ou heure n'est pas le niveau supérieur, modifiez le cube.


Les modifications et la mise en forme de la requête disparaissent lors de l'exécution suivante.

Excel n'enregistre pas les modifications apportées à la mise en forme des requêtes Lorsque vous renvoyez des données vers Microsoft Excel, vous enregistrez la définition de requête en tant que partie intégrante de la feuille de calcul, mais vous n'enregistrez pas automatiquement un fichier de requête distinct. Lorsque vous modifiez ensuite la requête pour la plage de données externes, les modifications apportées à la mise en forme et aux en-têtes de colonne dans Microsoft Query ne sont pas conservées.

Les modifications apportées à la mise en forme ne sont pas enregistrées dans les fichiers de requêtes .dqy Lors de l'enregistrement d'un fichier au format .dqy, les modifications apportées à la mise en forme et aux en-têtes de colonne ne sont pas conservées.

Les modifications apportées à la mise en forme sont conservées dans les fichiers .qry Pour conserver la mise en forme dans Microsoft Query, effectuez vos modifications de mise en forme, cliquez dans le menu Fichier de Microsoft Query sur Enregistrer sous, puis cliquez dans la liste Type sur Fichiers Query (*.qry). Lorsque vous rouvrez le fichier de requête, votre mise en forme Microsoft Query s'affiche.


Lors de la modification d'un cube OLAP, un message m'indique que des données ont été perdues.

Un champ inclus dans le cube n'est plus disponible dans la base de données sources.

Vérifiez les modifications apportées à la base de données d'origine Vous pouvez ouvrir la requête de base de données, si vous avez enregistré la requête que vous avez créée lors de la première création du cube, ou vous pouvez créer une nouvelle requête. Dans la requête, vérifiez le volet des données pour vous assurer que tous les champs que vous avez inclus à l'origine sont toujours dans la requête. Dans le volet des tables, vous pouvez faire défiler les champs pour voir quels sont ceux qui sont disponibles.

Si vous ne parvenez pas à ouvrir une requête existante ou à en créer une nouvelle, contactez l'administrateur de la base de données pour obtenir des informations sur les changements effectués dans la base de données.

Créez un cube Si des champs ont été supprimés de la base de données, vous pouvez créer un cube.


Impossible d'ajouter des champs à mon cube OLAP.

Après avoir défini un cube OLAP dans l'Assistant Cube OLAP, vous ne parvenez pas à insérer d'autres champs à partir de la base de données relationnelle d'origine. Pour ajouter d'autres champs, vous devez modifier le fichier de requête de base de données (.dqy) puis recréer le cube.

Ouvrez ou créez la requête Si vous avez enregistré la requête de base de données créée en même temps que le cube, vous pouvez ouvrir le fichier .dqy. Si vous n'avez pas enregistré la requête, vous pouvez créer une nouvelle requête.

Ajoutez des champs à la requête Ajoutez les champs nécessaires à la requête. Si vous pensez avoir besoin d'un cube avec des champs différents dans le futur, enregistrez une copie de la requête afin de ne pas avoir à la recréer à chaque fois.

Créez un nouveau cube Une fois que vous disposez d'une requête avec tous les champs que vous souhaitez pour le cube, vous pouvez créer un nouveau cube.


La fonction de synthèse que je souhaite pour mes données de cube n'est pas disponible.

Lorsque vous utilisez l'Assistant Cube OLAP pour créer un cube à partir des enregistrements contenus dans une base de données relationnelle, les seules fonctions de synthèse disponibles pour calculer des valeurs pour les champs de données sont SOMME, NB, MIN et MAX.

Créez le rapport directement à partir des enregistrements de la base de données Si vous pouvez affiner votre requête suffisamment pour que la quantité de données renvoyées ne soit pas supérieure à ce que votre système peut prendre en charge et s'il n'est pas nécessaire de créer un cube OLAP pour les données, essayez de renvoyer les enregistrements de la requête dans Microsoft Excel plutôt que de créer un cube.

Dans Excel, lorsque vous créez un rapport de tableau ou de graphique croisé dynamique directement basé sur votre requête de base de données relationnelle plutôt que sur un cube, vous avez accès à un plus grand nombre de fonctions de synthèse : SOMME, NBVAL, MOYENNE, MAX, MIN, PRODUIT, NB, ECARTYPE, ECARTYPEP, VAR et VAR.P. Pour plus d'informations sur la façon dont ces fonctions de synthèse fonctionnent et comment les utiliser, consultez l'aide de Microsoft Excel.

Configurez un serveur OLAP pour la base de données Le produit serveur Microsoft OLAP, Microsoft SQL Server OLAP Services, vous permet de configurer plus de champs de synthèse que le logiciel client OLAP de Microsoft Office.


Lorsque j'essaie d'enregistrer un fichier de cube hors connexion, je manque d'espace disque.

La base de données relationnelles pour laquelle vous créez un cube peut être très volumineuse. Si vous spécifiez un large sous-ensemble de ces données pour votre fichier de cube hors connexion, l'espace disque risque de manquer sur votre disque dur local.

Libérez de l'espace disque ou trouvez un autre disque Supprimez les fichiers inutiles de votre disque avant d'enregistrer le fichier. Vous pouvez également essayer d'enregistrer le fichier sur un lecteur réseau.

Réduisez le volume des données incluses dans le fichier de cube hors connexion Essayez de minimiser le volume des données contenues dans le fichier sans vous passer des informations nécessaires pour vos rapports de tableau et de graphique croisé dynamique Microsoft Excel. Essayez les méthodes suivantes :

  • Incluez uniquement les champs absolument nécessaires Dans l'étape 1 de l'Assistant Cube OLAP, sélectionnez uniquement les champs de données que vos rapports doivent afficher.
  • Incluez uniquement les dimensions à utiliser Dans l'étape 2 de l'Assistant Cube OLAP, ajoutez uniquement les champs que vos rapports doivent afficher en tant que dimensions et niveaux. Pour obtenir des instructions sur la création de dimensions, consultez l'aide de l'Assistant Cube OLAP.

Utilisez un cube temporaire plutôt qu'un fichier de cube hors connexion Si vous avez éliminé toutes les données possibles et que vous ne parvenez toujours pas à enregistrer un fichier de cube hors connexion, essayez d'utiliser la première option de l'étape 3 de l'Assistant Cube OLAP, qui est celle qui utilise le moins d'espace disque. L'option recrée le cube en mémoire lorsque vous ouvrez un rapport basé sur le cube, et extrait uniquement les données nécessaires pour afficher le rapport.


Impossible d'ajouter, de copier ou de déplacer un enregistrement dans ma base de données.

Dans Microsoft Query 2000 et versions ultérieures, vous pouvez modifier et supprimer des enregistrements qui sont déjà présents dans la base de données, mais vous ne pouvez ni modifier l'ordre des enregistrements, ni utiliser Microsoft Query pour ajouter des enregistrements aux bases de données auxquelles vous pouvez accéder à l'aide du pilote Microsoft Excel ou Microsoft Text.

Utilisez des données directement dans la base Si vous devez copier un enregistrement, ouvrez directement la base de données, puis utilisez les commandes qu'elle fournit. Pour plus d'informations et d'instructions, consultez l'administrateur de votre base de données.

Triez les enregistrements dans Microsoft Query Vous pouvez modifier l'ordre des enregistrements dans le jeu de résultats en utilisant la commande Copies assemblées du menu Enregistrements. Le tri dans Microsoft Query n'affecte pas la base de données sous-jacente, mais uniquement le jeu de résultats. Pour plus d'informations, cliquez sur Image du bouton .


Impossible de créer les jointures souhaitées.

Vérifiez que la requête comporte deux tables au maximum pour une jointure externe Si votre requête comporte plus de deux tables, vous ne pouvez pas créer de jointure externe dans cette requête. Les jointures externes correspondent aux options 2 et 3 de la boîte de dialogue Jointure.

Une requête ne peut comporter qu'une jointure externe Vous pouvez créer autant de jointures internes (option 1 de la boîte de dialogue Jointure) que vous le souhaitez, mais vous ne pouvez créer qu'une seule jointure externe par requête. Si vous connaissez le langage de programmation SQL, vous pouvez essayer de modifier l'instruction SQL de la boîte de dialogue SQL (menu Affichage, commande SQL) pour créer plusieurs jointures externes.

Informations relatives aux jointures Pour plus d'informations sur l'utilisation de jointures externes en vue d'associer des enregistrements, cliquez sur Image du bouton .


Impossible d'enregistrer l'ensemble de résultats sous la forme d'une table dans ma base de données.

Microsoft Query 2000 et versions ultérieures n'autorise pas l'enregistrement du jeu de résultats sous la forme d'une table dans la base de données.

Importez les données dans la base de données à partir de Microsoft Excel Si votre base de données peut importer des données Microsoft Excel, vous pouvez renvoyer l'ensemble de résultats vers Microsoft Excel, puis utiliser les commandes de votre base de données pour importer les données Microsoft Excel sous la forme d'une table. Par exemple, Microsoft Access dispose d'un Assistant d'importation de feuille de calcul que vous pouvez utiliser pour créer une table à partir de données Microsoft Excel. Pour plus d'informations, consultez la documentation ou l'aide de votre base de données.

Importez un fichier texte dans la base de données Si votre base de données peut importer des fichiers texte, vous pouvez renvoyer l'ensemble de résultats vers Microsoft Excel, l'enregistrer sous la forme d'un fichier texte, puis utiliser les commandes de votre base de données pour importer le fichier texte sous la forme d'une table. Pour plus d'informations sur la conversion de texte, consultez l'aide de Microsoft Excel.


Impossible de trouver ou de supprimer une source de données.

Sources de données créées à l'aide de versions antérieures de Microsoft Query Un astérisque s'affiche en regard du nom de la source de données créée à l'aide de versions de Microsoft Query antérieures à Query 97. Toutes les sources de données, y compris celles créées à l'aide de Query 2000 et versions ultérieures, sont stockées sous forme de fichiers portant l'extension .dsn. Pour énumérer les sources de données créées à l'aide de versions antérieures de Microsoft Query, cliquez sur Options dans la boîte de dialogue Choisir une source de données (menu Fichier, commande Nouveau), puis activez la case à cocher Inclure les DSN du registre dans la liste des bases de données disponibles. Si ces sources de données sont stockées à l'emplacement par défaut, vous pouvez les sélectionner dans la boîte de dialogue Choisir une source de données, puis cliquer sur Supprimer.

Emplacements des fichiers de sources de données En règle générale, les fichiers de sources de données de versions antérieures de Microsoft Query sont stockés dans le dossier Sources de données ODBC, lui-même situé dans le dossier Fichiers communs. Les fichiers de sources de données de Query 2000 et versions ultérieures sont stockés, quant à eux, dans votre dossier de profils utilisateur dans Application Data\Microsoft\Queries. Pour visualiser les dossiers utilisés pour stocker des fichiers de sources de données, cliquez sur Nouvelle requête Image du bouton, sur l'onglet Bases de données, puis sur Options.

Recherchez et supprimez le fichier de sources de données Vous pouvez rechercher et supprimer les fichiers de sources de données en procédant de la façon suivante :

  • Utilisez le Panneau de configuration de Windows Si tous les fichiers de sources de données se trouvent dans le dossier Fichier communs\Sources de données ODBC ou dans votre dossier de profil utilisateur, double-cliquez sur l'icône Sources de données ODBC (32 bits) dans le Panneau de configuration, ou sur les systèmes Microsoft Windows 2000, double-cliquez sur Outils d'administration, puis double-cliquez sur Source de données (ODBC). Cliquez sur l'onglet DSN fichier, puis utilisez le bouton Supprimer pour supprimer tous les fichiers .dsn que vous ne souhaitez pas conserver.
  • Recherchez les fichiers .dsn Si les fichiers de sources de données se trouvent dans plusieurs dossiers de Windows, utilisez la commande Rechercher de Microsoft Windows pour rechercher tous les fichiers portant l'extension de nom de fichier .dsn, puis supprimez les fichiers que vous ne souhaitez pas conserver.


Impossible de modifier ma requête.

Vérifiez que vous pouvez apporter des modifications Dans le menu Edition, cliquez sur Options, puis désactivez la case à cocher Désactiver la possibilité de modifier les résultats d'une requête.


Impossible de trouver la table souhaitée.

Si la table souhaitée ne figure pas dans la liste de tables, vérifiez les points suivants, en fonction des options disponibles pour votre source de données.

  • Vérifiez l'identité du propriétaire Les tables souhaitées peuvent appartenir à un autre propriétaire. Dans la boîte de dialogue Ajouter une table, cliquez dans la zone Propriétaire sur un autre propriétaire. Il se peut que la personne qui possède les tables doive vous accorder la permission de les utiliser.
  • Vérifiez les types de tables affichées Les types des tables souhaitées ne sont peut-être pas sélectionnés pour l'affichage. Dans la boîte de dialogue Ajouter une table, cliquez sur Options. Sous Affichage, vérifiez que tous les types de tables sont sélectionnés.
  • Actualisez la liste de tables Les tables souhaitées ont peut-être été ajoutées à la base de données depuis la dernière connexion de Query à celle-ci. Pour afficher les tables ajoutées récemment, cliquez dans la boîte de dialogue Ajouter une table sur Options, puis sur Actualiser.


Impossible de créer une nouvelle source de données.

Vérifiez votre pilote Commencez par vérifier que vous disposez du pilote ODBC ou pilote de source de données approprié pour votre source de données. Les pilotes ODBC et pilotes de sources de données donnent à Microsoft Query une flexibilité qui vous permet de vous connecter à de nouvelles bases de données au fil de leur disponibilité en installant de nouveaux pilotes. Cependant, vous devez veiller à installer le pilote adapté au type de base de données que vous utilisez.

Vérifiez que le pilote est compatible avec Microsoft Query Outre les pilotes fournis avec Microsoft Query, vous pouvez utiliser des pilotes ODBC et des pilotes de sources de données fournis par d'autres fabricants. Avant d'utiliser un pilote d'un autre fabricant, il est conseillé de vérifier qu'il a été testé avec votre version de Microsoft Query. Pour certaines bases de données, le pilote fourni avec le logiciel de base de données peut être le mieux adapté. Contactez l'administrateur de votre base de données pour obtenir des informations sur les pilotes existants et sur les pilotes les mieux adaptés à votre site. Consulter une liste des pilotes fournis avec Microsoft Query.

Vérifiez l'adresse du serveur et les informations relatives à la connexion Avant de créer une source de données, vérifiez que vous connaissez l'adresse de la base de données sur votre réseau et que vous disposez des autorisations nécessaires à la connexion et à l'ouverture de session. Contactez l'administrateur de votre base de données pour obtenir un nom d'ouverture de session, un mot de passe et toute autre autorisation obligatoire, ainsi que pour vérifier que l'accès autorisé fonctionne correctement.

Vérifiez que le pilote est correctement installé Pour afficher la liste des pilotes ODBC disponibles, cliquez sur Nouvelle requête Image du bouton, double-cliquez sur Nouvelle source de données sous l'onglet Bases de données ou Cubes OLAP, tapez un nom à l'étape 1 de la boîte de dialogue Créer une nouvelle source de données, puis cliquez dans la liste à l'étape 2. Si l'onglet Cubes OLAP n'est pas disponible, exécutez Microsoft Query à partir de Microsoft Excel en pointant dans le menu Données de Excel sur Données externes, puis en cliquant sur Créer une requête. Double-cliquez sur Nouvelle source de données sous l'onglet Cubes OLAP, tapez un nom à l'étape 1 de la boîte de dialogue Créer une nouvelle source de données, puis cliquez dans la liste à l'étape 2. Si le pilote requis ne s'affiche pas, vous devez vérifier que le pilote est correctement installé. Comment installer les pilotes.

Vérifiez que toutes les informations de configuration ont été fournies Une fois que vous avez installé le pilote et que vous l'avez sélectionné à l'étape 2 de la boîte de dialogue Créer une nouvelle source de données, vérifiez que vous fournissez toutes les informations nécessaires à l'étape 3 de cette boîte de dialogue. Pour plus d'informations sur les pilotes Microsoft, cliquez sur Ouverture de session, puis sur ? dans la boîte de dialogue d'installation du pilote. Pour les pilotes fournis par d'autres fabricants, consultez l'aide ou la documentation fournie avec ces pilotes.

Si vous créez une source de données avec un pilote ODBC ou un pilote de source de données fourni par Microsoft, cliquez sur le nom de votre pilote pour plus d'informations sur les paramètres à indiquer à l'étape 3 de la boîte de dialogue Créer une nouvelle source de données.

Remarque Query ne peut pas accéder aux sources de données créées avec l'Assistant Connexion aux données.

Pilotes ODBC

Pilote Microsoft Access

Pilote Microsoft dBASE

Pilotes Microsoft Visual FoxPro

Pilote Microsoft Excel

Pilote Microsoft ODBC pour Oracle

Pilote Microsoft Paradox

Pilote de texte Microsoft

Pilote Microsoft SQL Server

Pilote de source de données

Pilote OLAP Services Microsoft SQL Server


Mes jointures ne me permettent pas d'obtenir les enregistrements souhaités.

Microsoft Query utilise des jointures internes par défaut La jointure interne (option 1 de la boîte de dialogue Jointure) est la jointure par défaut utilisée par Microsoft Query pour joindre des tables automatiquement. Lorsque deux tables sont jointes à l'aide d'une jointure interne, les enregistrements de la seconde table qui n'ont pas d'enregistrements correspondants dans la première table ne sont pas inclus dans le jeu de résultats.

Créez une jointure externe Pour extraire tous les enregistrements des deux tables lorsqu'une table contient des enregistrements qui ne figurent pas dans l'autre table, vous pouvez utiliser une jointure externe (options 2 et 3 de la boîte de dialogue Jointure). Pour plus d'informations sur l'utilisation de jointures externes en vue d'associer des enregistrements, cliquez sur Image du bouton .

Vérifiez la présence de plusieurs jointures entre les mêmes tables Il peut arriver qu'une jointure externe entre deux tables ne renvoie aucun enregistrement de la seconde table. Si vous ajoutez alors une jointure interne entre les deux tables, Microsoft Query n'extrait aucun enregistrement de l'une ou l'autre des tables. Pour afficher les enregistrements, supprimez l'une des jointures.

Informations relatives aux jointures Pour plus d'informations sur les jointures, cliquez sur Image du bouton .


Microsoft Query ne renvoie pas tous les enregistrements disponibles.

Vérifiez qu'il n'y a pas de limitation du nombre d'enregistrements à renvoyer Vérifiez que le nombre d'enregistrements à renvoyer n'a pas été limité. Cliquez dans le menu Edition sur Options, puis vérifiez que la case à cocher Limite le nombre d'enregistrements renvoyés à située sous Paramètres personnalisés est désactivée.

Vérifiez vos critères Vérifiez que tous les critères spécifiés sont correctement tapés, afin qu'ils extraient les enregistrements souhaités. Pour plus d'informations sur la spécification de critères, cliquez sur Image du bouton .

Vérifiez vos jointures Vérifiez que toutes les jointures créées produisent l'effet escompté. Pour plus d'informations sur les jointures, cliquez sur Image du bouton


Microsoft Query ne dispose pas d'assez de temps pour se connecter à ma base de données.

Définissez un temps de connexion plus long Par défaut, Microsoft Query tente de se connecter à votre base de données pendant une durée prédéfinie par le pilote ODBC de la source de données. Si les connexions à votre base de données nécessitent souvent davantage de temps, vous pouvez définir un intervalle plus long. Dans le menu Edition de Microsoft Query, cliquez sur Options, vérifiez que la case à cocher Annuler la connexion si elle ne se produit pas avant est activée, puis tapez le nombre de secondes autorisé pour la connexion.

Configurez Microsoft Query pour qu'il effectue indéfiniment des tentatives de connexion Si vous voulez permettre à Microsoft Query d'effectuer des tentatives de connexion pendant une durée indéterminée, désactivez la case à cocher Annuler la connexion si elle ne se produit pas avant. Si Microsoft Query ne parvient pas à se connecter à votre base de données, vous pouvez annuler la tentative en appuyant sur ÉCHAP.


Impossible d'accéder à partir de Microsoft Query aux données d'une liste Microsoft Excel.

Fermez le classeur Avant d'essayer d'accéder aux données, vérifiez que le classeur est fermé dans Microsoft Excel.

Vérifiez la feuille de calcul Vérifiez les éléments suivants dans votre feuille de calcul Microsoft Excel :

  • Vérifiez le format de liste Assurez-vous que la liste respecte le format de liste Microsoft Excel. (Pour plus d'informations sur la création d'une liste dans une feuille de calcul, consultez l'aide de Microsoft Excel.) Nommez les plages qui constituent des tables et veillez à attribuer un nom différent à chaque plage.
  • Attribuez un nom à la liste Microsoft Query reconnaît uniquement les plages nommées en tant que tables. Pour nommer une liste, sélectionnez l'ensemble de la liste dans Microsoft Excel, puis tapez un nom dans la zone Nom de la barre de formule.
  • N'accédez pas à la liste en tant que table système N'essayez pas d'accéder à des tables Microsoft Excel en cliquant dans la boîte de dialogue Options de la table sur l'option Tables système située sous Affichage. Si vous utilisez cette approche, Microsoft Query risque de considérer les cellules vides de vos feuilles de calcul comme des données, de ne pas reconnaître certaines de vos données réelles et de ne pas être en mesure d'extraire correctement vos données.
  • Utilisez des listes de formats pour associer les données de la même manière Utilisez le même format pour toutes les colonnes de chaque liste que vous voulez associer. Par exemple, si chaque liste comporte une colonne contenant des dates, appliquez le même format de date à chaque colonne. Si vous mélangez des formats de texte et numériques dans une même colonne, le pilote Microsoft Excel risque de ne pas pouvoir trouver et associer toutes vos données.
  • N'utilisez pas d'étiquettes de colonne, telles que Table ou Base de données Microsoft Query utilise certaines étiquettes de manière interne et ne les reconnaît pas dans vos données.
  • Placez tous les classeurs dans le même dossier Une source de données que vous définissez pour le pilote Microsoft Excel permet uniquement d'accéder à des classeurs situés dans un seul dossier à la fois. Si les listes se trouvent dans deux classeurs différents, assurez-vous que ces deux classeurs sont dans le même dossier que le classeur spécifié lors de la définition de la source de données.
  • Placez les classeurs dans le dossier demandé par la source de données Avant de démarrer Microsoft Query, veillez à copier tous les classeurs que vous voulez utiliser dans le dossier spécifié dans votre source de données. Microsoft Query ne reconnaît pas automatiquement les nouveaux classeurs que vous ajoutez dans le dossier pendant la création d'une requête. Vous pouvez accéder à de nouveaux classeurs en cliquant dans la boîte de dialogue Ajouter une table sur Options, puis en cliquant sur Actualiser.

Utilisez Excel pour associer les données Microsoft Query est particulièrement utile lorsque vous voulez associer des données issues de deux listes Microsoft Excel ou davantage. Si vous utilisez des données provenant d'une seule feuille de calcul ou que vous souhaitez utiliser des critères simples pour sélectionner des lignes dans une seule feuille de calcul, les commandes Filtre automatique et Filtre avancé de Microsoft Excel (menu Données, sous-menu Filtrer ) peuvent vous paraître plus faciles à utiliser. Pour plus d'informations sur le filtre automatique et le filtre élaboré, consultez l'aide de Microsoft Excel.


Impossible de modifier dans Microsoft Query les types de paramètres de ma procédure SQL.

Pour créer des paramètres dans une procédure SQL enregistrée et définir les types de données, procédez de la façon suivante :

  1. Dans le menu Fichier, cliquez sur Exécuter SQL.
  2. Dans la zone Interrogation SQL, créez votre requête en utilisant des arguments fixes pour la procédure, puis cliquez sur Enregistrer.
  3. Dans le menu Affichage, cliquez sur SQL.
  4. Dans la zone Interrogation SQL, remplacez chaque argument fixe par un point d'interrogation (?)
  5. Cliquez sur OK, puis cliquez dans le menu Affichage sur Paramètres.
  6. Pour changer le type de données d'un paramètre, cliquez sur ce paramètre, puis sur Modifier.


Impossible de créer des étiquettes de publipostage dans Microsoft Query.

Microsoft Query extrait les données pour créer des étiquettes Microsoft Query est un outil qui extrait des données d'une base de données. Il ne permet pas de créer des étiquettes de publipostage. Cependant, vous pouvez utiliser des données extraites par Microsoft Query dans Microsoft Excel et Microsoft Word pour créer des étiquettes de publipostage.

Créez les étiquettes dans Word Renvoyez tout d'abord les données vers Excel en cliquant dans le menu Fichier sur Renvoyer les données vers Microsoft Excel. Une fois que le jeu de résultats figure dans Microsoft Excel, vous pouvez utiliser les données sous la forme d'une liste de publipostage dans Word. Vous pouvez également commencer à créer les étiquettes dans Word, puis renvoyer directement les données de Microsoft Query à Word. Pour plus d'informations sur les étiquettes de publipostage, consultez l'aide de Excel ou de Word.


Impossible d'imprimer l'ensemble de résultats dans Microsoft Query.

Microsoft Query ne dispose pas de fonction d'impression Microsoft Query est un outil qui extrait des données d'une base de données. Il ne permet pas d'imprimer directement des états.

Imprimez les enregistrements à partir de Excel Pour imprimer l'ensemble de résultats, renvoyez-le vers Microsoft Excel en cliquant dans le menu Fichier sur Renvoyer les données vers Microsoft Excel. Une fois l'ensemble de résultats dans Microsoft Excel, vous pouvez utiliser toutes les commandes de mise en forme et d'impression de Microsoft Excel pour organiser et imprimer les données. Pour plus d'informations sur l'impression dans Microsoft Excel, consultez l'aide de Microsoft Excel.


Microsoft Query continue d'utiliser des ressources de connexion alors que je ne travaille pas avec une base de données.

Les connexions restent ouvertes lors d'une session Microsoft Query Par défaut, Microsoft Query établit une seule connexion à votre base de données et la maintient ouverte jusqu'à ce que vous quittiez Microsoft Query, quel que soit le nombre de fenêtres de requête que vous ouvrez pour la base de données pendant cette période. Si vous créez des requêtes sur plusieurs bases de données au cours d'une session Microsoft Query, les connexions ouvertes peuvent immobiliser les ressources et des temps de connexion élevés.

Fermez les connexions lors de la fermeture des fenêtres de requête Si vous voulez réduire le temps de connexion, vous pouvez faire en sorte que Microsoft Query mette fin à la connexion lorsque vous n'avez aucune fenêtre de requête ouverte pour une base de données. Pour maintenir la connexion ouverte uniquement lorsqu'une fenêtre de requête est ouverte, cliquez dans le menu Edition sur Options, puis désactivez la case à cocher Rester en connexion jusqu'à la fermeture de MS Query.


Pourquoi y a-t-il un astérisque à côté de ma source de données ?

La source de données a été créée dans une version antérieure de Microsoft Query Les sources de données Query 97 et versions ultérieures ont un format différent de celui des sources de données créées dans des versions antérieures de Query. Les sources de données et les requêtes créées dans les versions de Query antérieures à Query 97 peuvent encore être utilisées avec des versions ultérieures de Query, mais les requêtes créées à l'aide de ces sources de données ne peuvent pas être partagées avec d'autres utilisateurs. Les versions antérieures à Query 97 stockent les informations relatives aux sources de données en tant que parties de votre système d'exploitation Microsoft Windows, ce qui implique que ces informations ne soient disponibles que sur votre système.

Identifiez les sources de données non partageables Pour utiliser des sources de données créées à l'aide de versions antérieures de Microsoft Query, cliquez dans la boîte de dialogue Choisir une source de données sur Options (menu Fichier, commande Nouveau), puis activez la case à cocher Inclure les DSN du registre dans la liste des bases de données disponibles. Toutes les sources de données créées à l'aide d'une version antérieure à Microsoft Query 97 s'affichent dans la boîte de dialogue Choisir une source de données et comportent des astérisques en regard de leurs noms.

Créez des sources de données partageables Si vous souhaitez partager des requêtes ou des modèles de rapport qui utilisent des données en provenance de bases de données externes spécifiées dans vos sources de données non partageables, créez de nouvelles sources de données pour ces bases de données et utilisez-les pour créer les requêtes, les fichiers de requête et les modèles de rapport.

Supprimez les anciennes sources de données Comment supprimer des sources de données non partageables.


Impossible de modifier mon cube OLAP.

Assurez-vous que la base de données d'origine est disponible Pour effectuer des changements dans un cube OLAP, vous devez avoir accès à la base de données de serveur d'origine qui a fourni les données pour le cube. Vérifiez l'emplacement de cette base de données pour vous assurer qu'elle n'a pas été renommée ni déplacée. Assurez-vous que le serveur est disponible et que vous pouvez vous y connecter.

Vérifiez les changements effectués dans la base de données d'origine Des tables de la base de données ont pu être renommées ou supprimées, de sorte que le cube ne peut plus retrouver les données d'origine. Vérifiez les éventuels changements effectués dans l'organisation, ou le schéma, de la base de données. Pour ce faire, vous pouvez ouvrir la requête de base de données si vous avez enregistré la requête créée en même temps que le cube, ou vous pouvez créer une nouvelle requête. Dans le menu Table, cliquez sur Ajouter une table pour voir quelles sont les tables disponibles. Si vous ne parvenez pas à ouvrir une requête existante ou à en créer une nouvelle, contactez l'administrateur de la base de données pour obtenir des informations sur les changements effectués dans la base de données.


Un message m'indique que l'Assistant Cube OLAP ne parvient pas à ouvrir mon fichier .oqy.

Assurez-vous que le fichier a été créé par l'Assistant Vous ne pouvez ouvrir et modifier des fichiers .oqy que s'ils ont été créés et enregistrés en utilisant l'Assistant Cube OLAP. Vous ne pouvez pas utiliser l'Assistant pour ouvrir et modifier d'autres fichiers .oqy qui ne contiennent pas une définition de cube, tels que ceux qui se connectent à une base de données de serveur OLAP ou à un fichier de cube hors connexion.

Recréez le fichier .oqy Si vous ne pouvez pas ouvrir le fichier .oqy créé par l'Assistant Cube OLAP, le fichier a peut-être été endommagé. Essayez d'ouvrir une copie de sauvegarde du fichier ou, si vous n'en possédez pas, créez de nouveau le cube.


La base de données étant en lecture seule, il ne vous sera pas possible de créer des tables. Désirez-vous continuer ?

Vous pouvez afficher la définition d'une table dans une base de données en lecture seule, mais vous ne pouvez pas créer de nouvelles tables ni supprimer des tables existantes.


Impossible d'accéder à l'enregistrement. Davantage de colonnes sont nécessaires pour l'identifier ou un autre utilisateur l'a modifié.

Microsoft Query ne peut pas trouver un enregistrement dans la table sous-jacente qui corresponde à l'enregistrement que vous avez mis à jour ou supprimé dans la requête. Vous ne disposez peut-être pas de suffisamment de colonnes dans la requête pour distinguer l'enregistrement que vous souhaitez mettre à jour, ou un autre utilisateur a peut-être modifié l'enregistrement depuis la dernière exécution de la requête. Avant de mettre l'enregistrement à jour, effectuez l'une des opérations suivantes :

  • Ajoutez davantage de colonnes à la requête, ou ajoutez la colonne qui identifie l'enregistrement de manière exclusive.
  • Pour obtenir les données les plus actuelles de la table sous-jacente, exécutez de nouveau la requête en cliquant dans le menu Enregistrements sur Requête immédiate.


Il existe des liens hors programme. Désirez-vous fermer quand même ?

Les données de votre requête sont liées à un autre programme, tel que Microsoft Excel ou Microsoft Word.

  • Pour fermer la requête et le lien, cliquez sur OK. Vous ne pouvez pas rétablir le lien une fois la requête fermée.
  • Pour maintenir la requête ouverte et conserver le lien, cliquez sur Annuler.


Voulez-vous enregistrer le Presse-papiers de <nom> ?

Vous avez placé une grande quantité de données dans le Presse-papiers.

  • Pour enregistrer les données du Presse-papiers, et fermer la requête ou quitter Microsoft Query, cliquez sur Oui.
  • Pour supprimer les données, et fermer la requête ou quitter Microsoft Query, cliquez sur Non.
  • Pour continuer de travailler dans Microsoft Query en conservant les données dans le Presse-papiers, cliquez sur Annuler.


Impossible de continuer à travailler dans Microsoft Query.

Le contenu de cette rubrique n'est peut-être pas applicable à certaines langues.

Lorsque certains messages sont affichés, que ce soit par le Compagnon Office sans celui-ci, il se peut que vous ne parveniez pas à travailler dans Microsoft Query tant que vous n'avez pas fermé ces messages. Il s'agit dans ce cas de messages importants qui exigent une réponse de votre part.

Pour continuer de travailler dans Microsoft Query, cliquez sur un bouton d'option dans le message affiché. Si Microsoft Excel n'affiche plus le message mais une rubrique d'aide, cliquez n'importe où sur la fenêtre Microsoft Query pour afficher à nouveau le message.


Désirez-vous enregistrer les changements dans la requête <nom> ?

Vous avez effectué des changements dans la conception ou la mise en forme de la requête en cours depuis son dernier enregistrement.

  • Pour enregistrer vos changements avant de fermer la requête, cliquez sur Oui.
  • Pour fermer la requête sans enregistrer les changements, cliquez sur Non.
  • Pour garder la requête ouverte sans enregistrer les changements, cliquez sur Annuler.


L'interrogation SQL a été effectuée avec succès : <nombre> lignes ont été affectées.

Microsoft Query a exécuté l'instruction SQL spécifiée, en affectant le nombre de lignes (enregistrements) indiqué.


L'interrogation SQL a échoué.

Microsoft Query ne peut exécuter votre instruction SQL. Veillez à taper l'instruction correctement.


La table <nom> existe déjà. Désirez-vous la remplacer ?

Une table portant le nom que vous avez tapé existe déjà.

  • Pour remplacer l'ancienne table par celle que vous créez, cliquez sur Oui.
  • Pour ne pas remplacer l'ancienne table, cliquez sur Non, puis tapez un nom différent pour la nouvelle table.


Désirez-vous enregistrer le fichier sous <nom> ?

Vous avez essayé d'enregistrer un jeu de résultats sous forme de table avec un nom de fichier dans lequel l'extension est incorrecte ou manquante.

  • Pour enregistrer le jeu de résultats dans un fichier comportant une extension correcte pour votre source de données, cliquez sur OK.
  • Pour revenir dans Microsoft Query sans enregistrer le jeu de résultats, cliquez sur Annuler.


Fin d'exécution de l'autre application.

L'autre programme de la conversation DDE (Dynamic Data Exchange) a été inopinément fermé. Redémarrez l'autre programme avant de reprendre la conversation DDE.


La requête SQL ne peut pas être représentée graphiquement. Désirez-vous continuer quand même ?

Microsoft Query ne peut pas afficher le volet des tables pour cette requête. Si la requête renvoie des enregistrements, vous ne pouvez modifier ni ceux-ci, ni la conception de la requête dans la fenêtre Requête. Vous pouvez cependant modifier la conception de la requête en cliquant dans le menu Affichage sur SQL, puis en modifiant directement l'instruction SQL.


Délai d'attente de la réponse DDE dépassé.

L'autre programme de la conversation DDE (Dynamic Data Exchange) n'a pas répondu dans le délai spécifié par l'option Délai d'attente DDE.

  • L'autre programme attend une réponse de l'utilisateur. Basculez vers ce programme et fermez la boîte de dialogue, ou répondez au message affiché par l'autre programme.
  • L'autre programme est trop occupé pour répondre aux messages DDE.

Remarque Vous ne pouvez modifier le délai spécifié dans l'option DDE Timeout.


La clause GROUP BY ne doit pas être suivie par <texte>.

L'expression ou la clause suivant votre clause GROUP BY n'est pas valide.


La clause HAVING ne doit pas être suivie par <texte>.

L'expression ou la clause suivant la clause HAVING de votre instruction SQL n'est pas valide.


La clause ORDER BY ne doit pas être suivie par <texte>.

L'expression ou la clause suivant la clause ORDER BY de votre instruction SQL n'est pas valide.


L'instruction SELECT ne doit pas être suivie par <texte>.

L'expression ou la clause suivant la liste sélectionnée dans votre instruction SELECT n'est pas valide.


La clause WHERE ne doit pas être suivie par <texte>.

L'expression ou la clause suivant la clause WHERE de votre instruction SQL n'est pas valide.


Trop de valeurs sélectionnées.

La mémoire est insuffisante pour stocker toutes les valeurs que vous avez spécifiées comme critères pour ce champ. Spécifiez moins de valeurs.


Unité de mesure non reconnue.

Microsoft Query ne reconnaît pas les caractères saisis pour cette option. Tapez un nombre comme mesure, mais n'incluez pas des caractères comme type d'unité, tels que " (des guillemets doubles), « in » (pour les pouces) ou « cm » (pour les centimètres).


La mise à jour a échoué. Désirez-vous continuer ?

Microsoft Query ne peut pas mettre à jour les données modifiées car la table sous-jacente ou la source de données est en lecture seule, la table sous-jacente est corrompue ou l'espace disque est insuffisant pour enregistrer les modifications.


<Valeur> a trop de chiffres après la virgule.

Il y a plus de chiffres après la virgule que ne l'autorisent les valeurs de ce champ. Utilisez moins de chiffres.


<Value> n'est pas une valeur booléenne.

Vous avez tapé une valeur non booléenne dans un champ qui n'accepte que des valeurs booléennes. Par exemple, vous avez peut-être tapé une date alors que le champ n'accepte qu'une valeur « 0 » ou « 1 ».


<Valeur> n'est pas une date valide.

Vous avez tapé un type de valeur erroné dans le champ. Par exemple, vous avez peut-être tapé du texte dans un champ qui n'accepte que des dates.


<Valeur> n'est pas un nombre valide.

Vous avez tapé un type de valeur erroné dans le champ. Par exemple, vous avez peut-être tapé du texte dans un champ qui n'accepte que des chiffres.


<Valeur> dépasse la plage numérique de cette colonne.

La valeur dépasse le nombre maximal autorisé pour les valeurs de cette colonne (champ). Tapez une valeur inférieure.


Les tables existantes ne peuvent pas être modifiées. Les changements peuvent être utilisés pour créer une nouvelle table.

Pour créer une nouvelle table à partir d'une table existante, vous devez modifier le nom de la table dans la boîte de dialogue Définir une table. La nouvelle table ne contient pas les données enregistrées dans la table existante. Vous ne pouvez pas modifier les définitions de tables existantes dans Microsoft Query.


Extension <extension> incorrecte.

Le nom de table que vous avez spécifié ne contient pas une extension de nom de fichier valide. Consultez la documentation de votre source de données pour connaître l'extension de nom de fichier appropriée.


Expression trop complexe.

Votre expression est trop complexe pour être évaluée avec succès. Essayez de la simplifier.


Erreur de syntaxe.

Votre expression présente une syntaxe non valide. Par exemple, vous n'avez pas tapé d'opérateur, vous avez tapé un caractère non valide ou une virgule, ou vous avez tapé du texte sans le placer entre guillemets ( " ou " ). Veillez à taper l'expression correctement.


Erreur de syntaxe dans la date.

Votre expression contient une date non valide. Veillez à taper l'expression correctement.


Utilisation non valide de '.', '!', ou '( )'.

Votre expression contient un opérateur . (point) ou ! non valide ou une parenthèse non valide. Par exemple, vous avez tapé un identificateur non valide ou une parenthèse après la constante Null. Veillez à taper l'expression correctement.


Erreur de syntaxe dans le nombre.

Votre expression contient un nombre non valide. Veillez à taper l'expression correctement.


Erreur de syntaxe dans la chaîne.

Votre expression contient une chaîne non valide. Par exemple, vous avez dépassé la longueur maximale d'une chaîne. Veillez à taper l'expression correctement.


Opérateur Est compris entre (Between...And) ne comporte pas la clause Et.

Lorsque vous utilisez l'opérateur Est compris entre (Between...And), vous devez taper le mot réservé Et. Utilisez la syntaxe suivante :

expression Est compris entre valeur1 Et valeur2


Trop de parenthèses fermantes.

Votre expression contient trop de parenthèses fermantes. Supprimez les parenthèses qui ne correspondent pas à une parenthèse ouvrante.


Dépassement de mémoire pendant le calcul.

Il n'y a pas suffisamment de mémoire disponible pour effectuer les calculs.

Fermez les fenêtres de Microsoft Query, ou fermez les autres programmes. Si l'erreur se reproduit, redémarrez Microsoft Windows et réessayez d'effectuer les calculs.


Il manque le signe ')', ']', ou '|'.

Il manque une parenthèse fermante, un crochet ou une barre verticale dans votre expression. Veillez à taper l'expression correctement.